/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.23.0(c1b3b90cfb5d4e3805f8aea3c005800590733397)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var re=["exports","require","vs/base/common/platform","vs/editor/common/core/position","vs/base/common/errors","vs/editor/common/core/range","vs/base/common/strings","vs/base/common/functional","vs/base/common/lifecycle","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/base/common/uri","vs/base/common/stopwatch","vs/base/common/event","vs/base/common/cancellation","vs/base/common/arrays","vs/base/common/hash","vs/base/common/linkedList","vs/base/common/diff/diffChange","vs/base/common/process","vs/base/common/path","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/characterClassifier","vs/base/common/iterator","vs/base/common/keyCodes","vs/editor/common/core/selection","vs/editor/common/core/token","vs/editor/common/diff/diffComputer","vs/editor/common/model/wordHelper","vs/editor/common/modes/linkComputer","vs/editor/common/modes/supports/inplaceReplaceSupport","vs/editor/common/standalone/standaloneEnums","vs/editor/common/standalone/standaloneBase","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],ie=function(R){for(var t=[],C=0,M=R.length;C<M;C++)t[C]=re[R[C]];return t};"use strict";var Re=this,Me=typeof global=="object"?global:{},he;(function(R){R.global=Re;var t=function(){function C(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1}return Object.defineProperty(C.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(C.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(C.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(C.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),C.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=C._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof R.global.importScripts=="function")},C._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},C}();R.Environment=t})(he||(he={}));var he;(function(R){var t=function(){function d(n,_,s){this.type=n,this.detail=_,this.timestamp=s}return d}();R.LoaderEvent=t;var C=function(){function d(n){this._events=[new t(1,"",n)]}return d.prototype.record=function(n,_){this._events.push(new t(n,_,R.Utilities.getHighPerformanceTimestamp()))},d.prototype.getEvents=function(){return this._events},d}();R.LoaderEventRecorder=C;var M=function(){function d(){}return d.prototype.record=function(n,_){},d.prototype.getEvents=function(){return[]},d.INSTANCE=new d,d}();R.NullLoaderEventRecorder=M})(he||(he={}));var he;(function(R){var t=function(){function C(){}return C.fileUriToFilePath=function(M,d){if(d=decodeURI(d).replace(/%23/g,"#"),M){if(/^file:\/\/\//.test(d))return d.substr(8);if(/^file:\/\//.test(d))return d.substr(5)}else if(/^file:\/\//.test(d))return d.substr(7);return d},C.startsWith=function(M,d){return M.length>=d.length&&M.substr(0,d.length)===d},C.endsWith=function(M,d){return M.length>=d.length&&M.substr(M.length-d.length)===d},C.containsQueryString=function(M){return/^[^\#]*\?/gi.test(M)},C.isAbsolutePath=function(M){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(M)},C.forEachProperty=function(M,d){if(M){var n=void 0;for(n in M)M.hasOwnProperty(n)&&d(n,M[n])}},C.isEmpty=function(M){var d=!0;return C.forEachProperty(M,function(){d=!1}),d},C.recursiveClone=function(M){if(!M||typeof M!="object"||M instanceof RegExp||!Array.isArray(M)&&Object.getPrototypeOf(M)!==Object.prototype)return M;var d=Array.isArray(M)?[]:{};return C.forEachProperty(M,function(n,_){_&&typeof _=="object"?d[n]=C.recursiveClone(_):d[n]=_}),d},C.generateAnonymousModule=function(){return"===anonymous"+C.NEXT_ANONYMOUS_ID+++"==="},C.isAnonymousModule=function(M){return C.startsWith(M,"===anonymous")},C.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=R.global.performance&&typeof R.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?R.global.performance.now():Date.now()},C.NEXT_ANONYMOUS_ID=1,C.PERFORMANCE_NOW_PROBED=!1,C.HAS_PERFORMANCE_NOW=!1,C}();R.Utilities=t})(he||(he={}));var he;(function(R){function t(d){if(d instanceof Error)return d;var n=new Error(d.message||String(d)||"Unknown Error");return d.stack&&(n.stack=d.stack),n}R.ensureError=t;var C=function(){function d(){}return d.validateConfigurationOptions=function(n){function _(a){if(a.phase==="loading"){console.error('Loading "'+a.moduleId+'" failed'),console.error(a),console.error("Here are the modules that depend on it:"),console.error(a.neededBy);return}if(a.phase==="factory"){console.error('The factory method of "'+a.moduleId+'" has thrown an exception'),console.error(a);return}}if(n=n||{},typeof n.baseUrl!="string"&&(n.baseUrl=""),typeof n.isBuild!="boolean"&&(n.isBuild=!1),typeof n.paths!="object"&&(n.paths={}),typeof n.config!="object"&&(n.config={}),typeof n.catchError=="undefined"&&(n.catchError=!1),typeof n.recordStats=="undefined"&&(n.recordStats=!1),typeof n.urlArgs!="string"&&(n.urlArgs=""),typeof n.onError!="function"&&(n.onError=_),Array.isArray(n.ignoreDuplicateModules)||(n.ignoreDuplicateModules=[]),n.baseUrl.length>0&&(R.Utilities.endsWith(n.baseUrl,"/")||(n.baseUrl+="/")),typeof n.cspNonce!="string"&&(n.cspNonce=""),typeof n.preferScriptTags=="undefined"&&(n.preferScriptTags=!1),Array.isArray(n.nodeModules)||(n.nodeModules=[]),n.nodeCachedData&&typeof n.nodeCachedData=="object"&&(typeof n.nodeCachedData.seed!="string"&&(n.nodeCachedData.seed="seed"),(typeof n.nodeCachedData.writeDelay!="number"||n.nodeCachedData.writeDelay<0)&&(n.nodeCachedData.writeDelay=1e3*7),!n.nodeCachedData.path||typeof n.nodeCachedData.path!="string")){var s=t(new Error("INVALID cached data configuration, 'path' MUST be set"));s.phase="configuration",n.onError(s),n.nodeCachedData=void 0}return n},d.mergeConfigurationOptions=function(n,_){n===void 0&&(n=null),_===void 0&&(_=null);var s=R.Utilities.recursiveClone(_||{});return R.Utilities.forEachProperty(n,function(a,m){a==="ignoreDuplicateModules"&&typeof s.ignoreDuplicateModules!="undefined"?s.ignoreDuplicateModules=s.ignoreDuplicateModules.concat(m):a==="paths"&&typeof s.paths!="undefined"?R.Utilities.forEachProperty(m,function(N,l){return s.paths[N]=l}):a==="config"&&typeof s.config!="undefined"?R.Utilities.forEachProperty(m,function(N,l){return s.config[N]=l}):s[a]=R.Utilities.recursiveClone(m)}),d.validateConfigurationOptions(s)},d}();R.ConfigurationOptionsUtil=C;var M=function(){function d(n,_){if(this._env=n,this.options=C.mergeConfigurationOptions(_),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var s=this.options.nodeRequire.main.filename,a=Math.max(s.lastIndexOf("/"),s.lastIndexOf("\\"));this.options.baseUrl=s.substring(0,a+1)}if(this.options.nodeMain&&this._env.isNode){var s=this.options.nodeMain,a=Math.max(s.lastIndexOf("/"),s.lastIndexOf("\\"));this.options.baseUrl=s.substring(0,a+1)}}}return d.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var n=0;n<this.options.ignoreDuplicateModules.length;n++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[n]]=!0},d.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var n=0,_=this.options.nodeModules;n<_.length;n++){var s=_[n];this.nodeModulesMap[s]=!0}},d.prototype._createSortedPathsRules=function(){var n=this;this.sortedPathsRules=[],R.Utilities.forEachProperty(this.options.paths,function(_,s){Array.isArray(s)?n.sortedPathsRules.push({from:_,to:s}):n.sortedPathsRules.push({from:_,to:[s]})}),this.sortedPathsRules.sort(function(_,s){return s.from.length-_.from.length})},d.prototype.cloneAndMerge=function(n){return new d(this._env,C.mergeConfigurationOptions(n,this.options))},d.prototype.getOptionsLiteral=function(){return this.options},d.prototype._applyPaths=function(n){for(var _,s=0,a=this.sortedPathsRules.length;s<a;s++)if(_=this.sortedPathsRules[s],R.Utilities.startsWith(n,_.from)){for(var m=[],N=0,l=_.to.length;N<l;N++)m.push(_.to[N]+n.substr(_.from.length));return m}return[n]},d.prototype._addUrlArgsToUrl=function(n){return R.Utilities.containsQueryString(n)?n+"&"+this.options.urlArgs:n+"?"+this.options.urlArgs},d.prototype._addUrlArgsIfNecessaryToUrl=function(n){return this.options.urlArgs?this._addUrlArgsToUrl(n):n},d.prototype._addUrlArgsIfNecessaryToUrls=function(n){if(this.options.urlArgs)for(var _=0,s=n.length;_<s;_++)n[_]=this._addUrlArgsToUrl(n[_]);return n},d.prototype.moduleIdToPaths=function(n){var _=this.nodeModulesMap[n]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(n);if(_)return this.isBuild()?["empty:"]:["node|"+n];var s=n,a;if(!R.Utilities.endsWith(s,".js")&&!R.Utilities.isAbsolutePath(s)){a=this._applyPaths(s);for(var m=0,N=a.length;m<N;m++)this.isBuild()&&a[m]==="empty:"||(R.Utilities.isAbsolutePath(a[m])||(a[m]=this.options.baseUrl+a[m]),!R.Utilities.endsWith(a[m],".js")&&!R.Utilities.containsQueryString(a[m])&&(a[m]=a[m]+".js"))}else!R.Utilities.endsWith(s,".js")&&!R.Utilities.containsQueryString(s)&&(s=s+".js"),a=[s];return this._addUrlArgsIfNecessaryToUrls(a)},d.prototype.requireToUrl=function(n){var _=n;return R.Utilities.isAbsolutePath(_)||(_=this._applyPaths(_)[0],R.Utilities.isAbsolutePath(_)||(_=this.options.baseUrl+_)),this._addUrlArgsIfNecessaryToUrl(_)},d.prototype.isBuild=function(){return this.options.isBuild},d.prototype.isDuplicateMessageIgnoredFor=function(n){return this.ignoreDuplicateModulesMap.hasOwnProperty(n)},d.prototype.getConfigForModule=function(n){if(this.options.config)return this.options.config[n]},d.prototype.shouldCatchError=function(){return this.options.catchError},d.prototype.shouldRecordStats=function(){return this.options.recordStats},d.prototype.onError=function(n){this.options.onError(n)},d}();R.Configuration=M})(he||(he={}));var he;(function(R){var t=function(){function s(a){this._env=a,this._scriptLoader=null,this._callbackMap={}}return s.prototype.load=function(a,m,N,l){var b=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new M;else if(this._env.isElectronRenderer){var S=a.getConfig().getOptionsLiteral().preferScriptTags;S?this._scriptLoader=new C:this._scriptLoader=new d(this._env)}else this._env.isNode?this._scriptLoader=new d(this._env):this._scriptLoader=new C;var E={callback:N,errorback:l};if(this._callbackMap.hasOwnProperty(m)){this._callbackMap[m].push(E);return}this._callbackMap[m]=[E],this._scriptLoader.load(a,m,function(){return b.triggerCallback(m)},function(c){return b.triggerErrorback(m,c)})},s.prototype.triggerCallback=function(a){var m=this._callbackMap[a];delete this._callbackMap[a];for(var N=0;N<m.length;N++)m[N].callback()},s.prototype.triggerErrorback=function(a,m){var N=this._callbackMap[a];delete this._callbackMap[a];for(var l=0;l<N.length;l++)N[l].errorback(m)},s}(),C=function(){function s(){}return s.prototype.attachListeners=function(a,m,N){var l=function(){a.removeEventListener("load",b),a.removeEventListener("error",S)},b=function(E){l(),m()},S=function(E){l(),N(E)};a.addEventListener("load",b),a.addEventListener("error",S)},s.prototype.load=function(a,m,N,l){if(/^node\|/.test(m)){var b=a.getConfig().getOptionsLiteral(),S=n(a.getRecorder(),b.nodeRequire||R.global.nodeRequire),E=m.split("|"),c=null;try{c=S(E[1])}catch(i){l(i);return}a.enqueueDefineAnonymousModule([],function(){return c}),N()}else{var g=document.createElement("script");g.setAttribute("async","async"),g.setAttribute("type","text/javascript"),this.attachListeners(g,N,l);var h=a.getConfig().getOptionsLiteral().trustedTypesPolicy;h&&(m=h.createScriptURL(m)),g.setAttribute("src",m);var p=a.getConfig().getOptionsLiteral().cspNonce;p&&g.setAttribute("nonce",p),document.getElementsByTagName("head")[0].appendChild(g)}},s}(),M=function(){function s(){}return s.prototype.load=function(a,m,N,l){var b=a.getConfig().getOptionsLiteral().trustedTypesPolicy;b&&(m=b.createScriptURL(m));try{importScripts(m),N()}catch(S){l(S)}},s}(),d=function(){function s(a){this._env=a,this._didInitialize=!1,this._didPatchNodeRequire=!1}return s.prototype._init=function(a){this._didInitialize||(this._didInitialize=!0,this._fs=a("fs"),this._vm=a("vm"),this._path=a("path"),this._crypto=a("crypto"))},s.prototype._initNodeRequire=function(a,m){var N=m.getConfig().getOptionsLiteral().nodeCachedData;if(!!N&&!this._didPatchNodeRequire){this._didPatchNodeRequire=!0;var l=this,b=a("module");function S(E){var c=E.constructor,g=function(p){try{return E.require(p)}finally{}};return g.resolve=function(p,i){return c._resolveFilename(p,E,!1,i)},g.main=process.mainModule,g.extensions=c._extensions,g.cache=c._cache,g}b.prototype._compile=function(E,c){var g=b.wrap(E.replace(/^#!.*/,"")),h=m.getRecorder(),p=l._getCachedDataPath(N,c),i={filename:c},u;try{var r=l._fs.readFileSync(p);u=r.slice(0,16),i.cachedData=r.slice(16),h.record(60,p)}catch(A){h.record(61,p)}var f=new l._vm.Script(g,i),v=f.runInThisContext(i),L=l._path.dirname(c),y=S(this),o=[this.exports,y,this,c,L,process,Me,Buffer],w=v.apply(this.exports,o);return l._handleCachedData(f,g,p,!i.cachedData,m),l._verifyCachedData(f,g,p,u,m),w}}},s.prototype.load=function(a,m,N,l){var b=this,S=a.getConfig().getOptionsLiteral(),E=n(a.getRecorder(),S.nodeRequire||R.global.nodeRequire),c=S.nodeInstrumenter||function(v){return v};this._init(E),this._initNodeRequire(E,a);var g=a.getRecorder();if(/^node\|/.test(m)){var h=m.split("|"),p=null;try{p=E(h[1])}catch(v){l(v);return}a.enqueueDefineAnonymousModule([],function(){return p}),N()}else{m=R.Utilities.fileUriToFilePath(this._env.isWindows,m);var i=this._path.normalize(m),u=this._getElectronRendererScriptPathOrUri(i),r=Boolean(S.nodeCachedData),f=r?this._getCachedDataPath(S.nodeCachedData,m):void 0;this._readSourceAndCachedData(i,f,g,function(v,L,y,o){if(v){l(v);return}var w;L.charCodeAt(0)===s._BOM?w=s._PREFIX+L.substring(1)+s._SUFFIX:w=s._PREFIX+L+s._SUFFIX,w=c(w,i);var A={filename:u,cachedData:y},D=b._createAndEvalScript(a,w,A,N,l);b._handleCachedData(D,w,f,r&&!y,a),b._verifyCachedData(D,w,f,o,a)})}},s.prototype._createAndEvalScript=function(a,m,N,l,b){var S=a.getRecorder();S.record(31,N.filename);var E=new this._vm.Script(m,N),c=E.runInThisContext(N),g=a.getGlobalAMDDefineFunc(),h=!1,p=function(){return h=!0,g.apply(null,arguments)};return p.amd=g.amd,c.call(R.global,a.getGlobalAMDRequireFunc(),p,N.filename,this._path.dirname(N.filename)),S.record(32,N.filename),h?l():b(new Error("Didn't receive define call in "+N.filename+"!")),E},s.prototype._getElectronRendererScriptPathOrUri=function(a){if(!this._env.isElectronRenderer)return a;var m=a.match(/^([a-z])\:(.*)/i);return m?"file:///"+(m[1].toUpperCase()+":"+m[2]).replace(/\\/g,"/"):"file://"+a},s.prototype._getCachedDataPath=function(a,m){var N=this._crypto.createHash("md5").update(m,"utf8").update(a.seed,"utf8").update(process.arch,"").digest("hex"),l=this._path.basename(m).replace(/\.js$/,"");return this._path.join(a.path,l+"-"+N+".code")},s.prototype._handleCachedData=function(a,m,N,l,b){var S=this;a.cachedDataRejected?this._fs.unlink(N,function(E){b.getRecorder().record(62,N),S._createAndWriteCachedData(a,m,N,b),E&&b.getConfig().onError(E)}):l&&this._createAndWriteCachedData(a,m,N,b)},s.prototype._createAndWriteCachedData=function(a,m,N,l){var b=this,S=Math.ceil(l.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),E=-1,c=0,g=void 0,h=function(){setTimeout(function(){g||(g=b._crypto.createHash("md5").update(m,"utf8").digest());var p=a.createCachedData();if(!(p.length===0||p.length===E||c>=5)){if(p.length<E){h();return}E=p.length,b._fs.writeFile(N,Buffer.concat([g,p]),function(i){i&&l.getConfig().onError(i),l.getRecorder().record(63,N),h()})}},S*Math.pow(4,c++))};h()},s.prototype._readSourceAndCachedData=function(a,m,N,l){if(!m)this._fs.readFile(a,{encoding:"utf8"},l);else{var b=void 0,S=void 0,E=void 0,c=2,g=function(h){h?l(h):--c==0&&l(void 0,b,S,E)};this._fs.readFile(a,{encoding:"utf8"},function(h,p){b=p,g(h)}),this._fs.readFile(m,function(h,p){!h&&p&&p.length>0?(E=p.slice(0,16),S=p.slice(16),N.record(60,m)):N.record(61,m),g()})}},s.prototype._verifyCachedData=function(a,m,N,l,b){var S=this;!l||a.cachedDataRejected||setTimeout(function(){var E=S._crypto.createHash("md5").update(m,"utf8").digest();l.equals(E)||(b.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+N+"' now, but a RESTART IS REQUIRED")),S._fs.unlink(N,function(c){c&&b.getConfig().onError(c)}))},Math.ceil(5e3*(1+Math.random())))},s._BOM=65279,s._PREFIX="(function (require, define, __filename, __dirname) { ",s._SUFFIX=`
});`,s}();function n(s,a){if(a.__$__isRecorded)return a;var m=function(l){s.record(33,l);try{return a(l)}finally{s.record(34,l)}};return m.__$__isRecorded=!0,m}R.ensureRecordedNodeRequire=n;function _(s){return new t(s)}R.createScriptLoader=_})(he||(he={}));var he;(function(R){var t=function(){function s(a){var m=a.lastIndexOf("/");m!==-1?this.fromModulePath=a.substr(0,m+1):this.fromModulePath=""}return s._normalizeModuleId=function(a){var m=a,N;for(N=/\/\.\//;N.test(m);)m=m.replace(N,"/");for(m=m.replace(/^\.\//g,""),N=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;N.test(m);)m=m.replace(N,"/");return m=m.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),m},s.prototype.resolveModule=function(a){var m=a;return R.Utilities.isAbsolutePath(m)||(R.Utilities.startsWith(m,"./")||R.Utilities.startsWith(m,"../"))&&(m=s._normalizeModuleId(this.fromModulePath+m)),m},s.ROOT=new s(""),s}();R.ModuleIdResolver=t;var C=function(){function s(a,m,N,l,b,S){this.id=a,this.strId=m,this.dependencies=N,this._callback=l,this._errorback=b,this.moduleIdResolver=S,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return s._safeInvokeFunction=function(a,m){try{return{returnedValue:a.apply(R.global,m),producedError:null}}catch(N){return{returnedValue:null,producedError:N}}},s._invokeFactory=function(a,m,N,l){return a.isBuild()&&!R.Utilities.isAnonymousModule(m)?{returnedValue:null,producedError:null}:a.shouldCatchError()?this._safeInvokeFunction(N,l):{returnedValue:N.apply(R.global,l),producedError:null}},s.prototype.complete=function(a,m,N){this._isComplete=!0;var l=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);var b=s._invokeFactory(m,this.strId,this._callback,N);l=b.producedError,a.record(22,this.strId),!l&&typeof b.returnedValue!="undefined"&&(!this.exportsPassedIn||R.Utilities.isEmpty(this.exports))&&(this.exports=b.returnedValue)}else this.exports=this._callback;if(l){var S=R.ensureError(l);S.phase="factory",S.moduleId=this.strId,this.error=S,m.onError(S)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},s.prototype.onDependencyError=function(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1},s.prototype.isComplete=function(){return this._isComplete},s}();R.Module=C;var M=function(){function s(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return s.prototype.getMaxModuleId=function(){return this._nextId},s.prototype.getModuleId=function(a){var m=this._strModuleIdToIntModuleId.get(a);return typeof m=="undefined"&&(m=this._nextId++,this._strModuleIdToIntModuleId.set(a,m),this._intModuleIdToStrModuleId[m]=a),m},s.prototype.getStrModuleId=function(a){return this._intModuleIdToStrModuleId[a]},s}(),d=function(){function s(a){this.id=a}return s.EXPORTS=new s(0),s.MODULE=new s(1),s.REQUIRE=new s(2),s}();R.RegularDependency=d;var n=function(){function s(a,m,N){this.id=a,this.pluginId=m,this.pluginParam=N}return s}();R.PluginDependency=n;var _=function(){function s(a,m,N,l,b){b===void 0&&(b=0),this._env=a,this._scriptLoader=m,this._loaderAvailableTimestamp=b,this._defineFunc=N,this._requireFunc=l,this._moduleIdProvider=new M,this._config=new R.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return s.prototype.reset=function(){return new s(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},s.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},s.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},s._findRelevantLocationInStack=function(a,m){for(var N=function(u){return u.replace(/\\/g,"/")},l=N(a),b=m.split(/\n/),S=0;S<b.length;S++){var E=b[S].match(/(.*):(\d+):(\d+)\)?$/);if(E){var c=E[1],g=E[2],h=E[3],p=Math.max(c.lastIndexOf(" ")+1,c.lastIndexOf("(")+1);if(c=c.substr(p),c=N(c),c===l){var i={line:parseInt(g,10),col:parseInt(h,10)};return i.line===1&&(i.col-="(function (require, define, __filename, __dirname) { ".length),i}}}throw new Error("Could not correlate define call site for needle "+a)},s.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var a=[],m=0,N=0,l=this._modules2.length;N<l;N++){var b=this._modules2[N];if(!!b){var S=this._buildInfoPath[b.id]||null,E=this._buildInfoDefineStack[b.id]||null,c=this._buildInfoDependencies[b.id];a[m++]={id:b.strId,path:S,defineLocation:S&&E?s._findRelevantLocationInStack(S,E):null,dependencies:c,shim:null,exports:b.exports}}}return a},s.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new R.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=R.NullLoaderEventRecorder.INSTANCE),this._recorder},s.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},s.prototype.enqueueDefineAnonymousModule=function(a,m){if(this._currentAnnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var N=null;this._config.isBuild()&&(N=new Error("StackLocation").stack||null),this._currentAnnonymousDefineCall={stack:N,dependencies:a,callback:m}},s.prototype.defineModule=function(a,m,N,l,b,S){var E=this;S===void 0&&(S=new t(a));var c=this._moduleIdProvider.getModuleId(a);if(this._modules2[c]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}var g=new C(c,a,this._normalizeDependencies(m,S),N,l,S);this._modules2[c]=g,this._config.isBuild()&&(this._buildInfoDefineStack[c]=b,this._buildInfoDependencies[c]=(g.dependencies||[]).map(function(h){return E._moduleIdProvider.getStrModuleId(h.id)})),this._resolve(g)},s.prototype._normalizeDependency=function(a,m){if(a==="exports")return d.EXPORTS;if(a==="module")return d.MODULE;if(a==="require")return d.REQUIRE;var N=a.indexOf("!");if(N>=0){var l=m.resolveModule(a.substr(0,N)),b=m.resolveModule(a.substr(N+1)),S=this._moduleIdProvider.getModuleId(l+"!"+b),E=this._moduleIdProvider.getModuleId(l);return new n(S,E,b)}return new d(this._moduleIdProvider.getModuleId(m.resolveModule(a)))},s.prototype._normalizeDependencies=function(a,m){for(var N=[],l=0,b=0,S=a.length;b<S;b++)N[l++]=this._normalizeDependency(a[b],m);return N},s.prototype._relativeRequire=function(a,m,N,l){if(typeof m=="string")return this.synchronousRequire(m,a);this.defineModule(R.Utilities.generateAnonymousModule(),m,N,l,null,a)},s.prototype.synchronousRequire=function(a,m){m===void 0&&(m=new t(a));var N=this._normalizeDependency(a,m),l=this._modules2[N.id];if(!l)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!l.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(l.error)throw l.error;return l.exports},s.prototype.configure=function(a,m){var N=this._config.shouldRecordStats();m?this._config=new R.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!N&&(this._recorder=null)},s.prototype.getConfig=function(){return this._config},s.prototype._onLoad=function(a){if(this._currentAnnonymousDefineCall!==null){var m=this._currentAnnonymousDefineCall;this._currentAnnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),m.dependencies,m.callback,null,m.stack)}},s.prototype._createLoadError=function(a,m){var N=this,l=this._moduleIdProvider.getStrModuleId(a),b=(this._inverseDependencies2[a]||[]).map(function(E){return N._moduleIdProvider.getStrModuleId(E)}),S=R.ensureError(m);return S.phase="loading",S.moduleId=l,S.neededBy=b,S},s.prototype._onLoadError=function(a,m){var N=this._createLoadError(a,m);this._modules2[a]||(this._modules2[a]=new C(a,this._moduleIdProvider.getStrModuleId(a),[],function(){},function(){},null));for(var l=[],b=0,S=this._moduleIdProvider.getMaxModuleId();b<S;b++)l[b]=!1;var E=!1,c=[];for(c.push(a),l[a]=!0;c.length>0;){var g=c.shift(),h=this._modules2[g];h&&(E=h.onDependencyError(N)||E);var p=this._inverseDependencies2[g];if(p)for(var b=0,S=p.length;b<S;b++){var i=p[b];l[i]||(c.push(i),l[i]=!0)}}E||this._config.onError(N)},s.prototype._hasDependencyPath=function(a,m){var N=this._modules2[a];if(!N)return!1;for(var l=[],b=0,S=this._moduleIdProvider.getMaxModuleId();b<S;b++)l[b]=!1;var E=[];for(E.push(N),l[a]=!0;E.length>0;){var c=E.shift(),g=c.dependencies;if(g)for(var b=0,S=g.length;b<S;b++){var h=g[b];if(h.id===m)return!0;var p=this._modules2[h.id];p&&!l[h.id]&&(l[h.id]=!0,E.push(p))}}return!1},s.prototype._findCyclePath=function(a,m,N){if(a===m||N===50)return[a];var l=this._modules2[a];if(!l)return null;var b=l.dependencies;if(b)for(var S=0,E=b.length;S<E;S++){var c=this._findCyclePath(b[S].id,m,N+1);if(c!==null)return c.push(a),c}return null},s.prototype._createRequire=function(a){var m=this,N=function(l,b,S){return m._relativeRequire(a,l,b,S)};return N.toUrl=function(l){return m._config.requireToUrl(a.resolveModule(l))},N.getStats=function(){return m.getLoaderEvents()},N.hasDependencyCycle=function(){return m._hasDependencyCycle},N.config=function(l,b){b===void 0&&(b=!1),m.configure(l,b)},N.__$__nodeRequire=R.global.nodeRequire,N},s.prototype._loadModule=function(a){var m=this;if(!(this._modules2[a]||this._knownModules2[a])){this._knownModules2[a]=!0;var N=this._moduleIdProvider.getStrModuleId(a),l=this._config.moduleIdToPaths(N),b=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(N.indexOf("/")===-1||b.test(N))&&l.push("node|"+N);var S=-1,E=function(c){if(S++,S>=l.length)m._onLoadError(a,c);else{var g=l[S],h=m.getRecorder();if(m._config.isBuild()&&g==="empty:"){m._buildInfoPath[a]=g,m.defineModule(m._moduleIdProvider.getStrModuleId(a),[],null,null,null),m._onLoad(a);return}h.record(10,g),m._scriptLoader.load(m,g,function(){m._config.isBuild()&&(m._buildInfoPath[a]=g),h.record(11,g),m._onLoad(a)},function(p){h.record(12,g),E(p)})}};E(null)}},s.prototype._loadPluginDependency=function(a,m){var N=this;if(!(this._modules2[m.id]||this._knownModules2[m.id])){this._knownModules2[m.id]=!0;var l=function(b){N.defineModule(N._moduleIdProvider.getStrModuleId(m.id),[],b,null,null)};l.error=function(b){N._config.onError(N._createLoadError(m.id,b))},a.load(m.pluginParam,this._createRequire(t.ROOT),l,this._config.getOptionsLiteral())}},s.prototype._resolve=function(a){var m=this,N=a.dependencies;if(N)for(var l=0,b=N.length;l<b;l++){var S=N[l];if(S===d.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(S===d.MODULE){a.unresolvedDependenciesCount--;continue}if(S===d.REQUIRE){a.unresolvedDependenciesCount--;continue}var E=this._modules2[S.id];if(E&&E.isComplete()){if(E.error){a.onDependencyError(E.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(S.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(S.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");var c=this._findCyclePath(S.id,a.id,0)||[];c.reverse(),c.push(S.id),console.warn(c.map(function(p){return m._moduleIdProvider.getStrModuleId(p)}).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[S.id]=this._inverseDependencies2[S.id]||[],this._inverseDependencies2[S.id].push(a.id),S instanceof n){var g=this._modules2[S.pluginId];if(g&&g.isComplete()){this._loadPluginDependency(g.exports,S);continue}var h=this._inversePluginDependencies2.get(S.pluginId);h||(h=[],this._inversePluginDependencies2.set(S.pluginId,h)),h.push(S),this._loadModule(S.pluginId);continue}this._loadModule(S.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)},s.prototype._onModuleComplete=function(a){var m=this,N=this.getRecorder();if(!a.isComplete()){var l=a.dependencies,b=[];if(l)for(var S=0,E=l.length;S<E;S++){var c=l[S];if(c===d.EXPORTS){b[S]=a.exports;continue}if(c===d.MODULE){b[S]={id:a.strId,config:function(){return m._config.getConfigForModule(a.strId)}};continue}if(c===d.REQUIRE){b[S]=this._createRequire(a.moduleIdResolver);continue}var g=this._modules2[c.id];if(g){b[S]=g.exports;continue}b[S]=null}a.complete(N,this._config,b);var h=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,h)for(var S=0,E=h.length;S<E;S++){var p=h[S],i=this._modules2[p];i.unresolvedDependenciesCount--,i.unresolvedDependenciesCount===0&&this._onModuleComplete(i)}var u=this._inversePluginDependencies2.get(a.id);if(u){this._inversePluginDependencies2.delete(a.id);for(var S=0,E=u.length;S<E;S++)this._loadPluginDependency(a.exports,u[S])}}},s}();R.ModuleManager=_})(he||(he={}));var te,he;(function(R){var t=new R.Environment,C=null,M=function(s,a,m){typeof s!="string"&&(m=a,a=s,s=null),(typeof a!="object"||!Array.isArray(a))&&(m=a,a=null),a||(a=["require","exports","module"]),s?C.defineModule(s,a,m,null,null):C.enqueueDefineAnonymousModule(a,m)};M.amd={jQuery:!0};var d=function(s,a){a===void 0&&(a=!1),C.configure(s,a)},n=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){d(arguments[0]);return}if(typeof arguments[0]=="string")return C.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){C.defineModule(R.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};n.config=d,n.getConfig=function(){return C.getConfig().getOptionsLiteral()},n.reset=function(){C=C.reset()},n.getBuildInfo=function(){return C.getBuildInfo()},n.getStats=function(){return C.getLoaderEvents()},n.define=function(){return M.apply(null,arguments)};function _(){if(typeof R.global.require!="undefined"||typeof require!="undefined"){var s=R.global.require||require;if(typeof s=="function"&&typeof s.resolve=="function"){var a=R.ensureRecordedNodeRequire(C.getRecorder(),s);R.global.nodeRequire=a,n.nodeRequire=a,n.__$__nodeRequire=a}}t.isNode&&!t.isElectronRenderer?(module.exports=n,require=n):(t.isElectronRenderer||(R.global.define=M),R.global.require=n)}R.init=_,(typeof R.global.define!="function"||!R.global.define.amd)&&(C=new R.ModuleManager(t,R.createScriptLoader(t),M,n,R.Utilities.getHighPerformanceTimestamp()),typeof R.global.require!="undefined"&&typeof R.global.require!="function"&&n.config(R.global.require),te=function(){return M.apply(null,arguments)},te.amd=M.amd,typeof doNotInitLoader=="undefined"&&_())})(he||(he={})),te(re[19],ie([1,0]),function(R,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;var C=function(){function M(d,n,_,s){this.originalStart=d,this.originalLength=n,this.modifiedStart=_,this.modifiedLength=s}return M.prototype.getOriginalEnd=function(){return this.originalStart+this.originalLength},M.prototype.getModifiedEnd=function(){return this.modifiedStart+this.modifiedLength},M}();t.DiffChange=C});var ye=this&&this.__extends||function(){var R=function(t,C){return R=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(M,d){M.__proto__=d}||function(M,d){for(var n in d)Object.prototype.hasOwnProperty.call(d,n)&&(M[n]=d[n])},R(t,C)};return function(t,C){if(typeof C!="function"&&C!==null)throw new TypeError("Class extends value "+String(C)+" is not a constructor or null");R(t,C);function M(){this.constructor=t}t.prototype=C===null?Object.create(C):(M.prototype=C.prototype,new M)}}();te(re[4],ie([1,0]),function(R,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createErrorWithActions=t.isErrorWithActions=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isPromiseCanceledError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;var C=function(){function r(){this.listeners=[],this.unexpectedErrorHandler=function(f){setTimeout(function(){throw f.stack?new Error(f.message+`

`+f.stack):f},0)}}return r.prototype.addListener=function(f){var v=this;return this.listeners.push(f),function(){v._removeListener(f)}},r.prototype.emit=function(f){this.listeners.forEach(function(v){v(f)})},r.prototype._removeListener=function(f){this.listeners.splice(this.listeners.indexOf(f),1)},r.prototype.setUnexpectedErrorHandler=function(f){this.unexpectedErrorHandler=f},r.prototype.getUnexpectedErrorHandler=function(){return this.unexpectedErrorHandler},r.prototype.onUnexpectedError=function(f){this.unexpectedErrorHandler(f),this.emit(f)},r.prototype.onUnexpectedExternalError=function(f){this.unexpectedErrorHandler(f)},r}();t.ErrorHandler=C,t.errorHandler=new C;function M(r){t.errorHandler.setUnexpectedErrorHandler(r)}t.setUnexpectedErrorHandler=M;function d(r){a(r)||t.errorHandler.onUnexpectedError(r)}t.onUnexpectedError=d;function n(r){a(r)||t.errorHandler.onUnexpectedExternalError(r)}t.onUnexpectedExternalError=n;function _(r){if(r instanceof Error){var f=r.name,v=r.message,L=r.stacktrace||r.stack;return{$isError:!0,name:f,message:v,stack:L}}return r}t.transformErrorForSerialization=_;var s="Canceled";function a(r){return r instanceof Error&&r.name===s&&r.message===s}t.isPromiseCanceledError=a;var m=function(r){ye(f,r);function f(){var v=r.call(this,s)||this;return v.name=v.message,v}return f}(Error);t.CancellationError=m;function N(){var r=new Error(s);return r.name=r.message,r}t.canceled=N;function l(r){return r?new Error("Illegal argument: "+r):new Error("Illegal argument")}t.illegalArgument=l;function b(r){return r?new Error("Illegal state: "+r):new Error("Illegal state")}t.illegalState=b;function S(r){return r?new Error("readonly property '"+r+" cannot be changed'"):new Error("readonly property cannot be changed")}t.readonly=S;function E(r){var f=new Error(r+" has been disposed");return f.name="DISPOSED",f}t.disposed=E;function c(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}t.getErrorMessage=c;var g=function(r){ye(f,r);function f(v){var L=r.call(this,"NotImplemented")||this;return v&&(L.message=v),L}return f}(Error);t.NotImplementedError=g;var h=function(r){ye(f,r);function f(v){var L=r.call(this,"NotSupported")||this;return v&&(L.message=v),L}return f}(Error);t.NotSupportedError=h;var p=function(r){ye(f,r);function f(){var v=r!==null&&r.apply(this,arguments)||this;return v.isExpected=!0,v}return f}(Error);t.ExpectedError=p;function i(r){var f=r;return f instanceof Error&&Array.isArray(f.actions)}t.isErrorWithActions=i;function u(r,f){f===void 0&&(f=Object.create(null));var v=new Error(r);return f.actions&&(v.actions=f.actions),v}t.createErrorWithActions=u});var pe=this&&this.__awaiter||function(R,t,C,M){function d(n){return n instanceof C?n:new C(function(_){_(n)})}return new(C||(C=Promise))(function(n,_){function s(N){try{m(M.next(N))}catch(l){_(l)}}function a(N){try{m(M.throw(N))}catch(l){_(l)}}function m(N){N.done?n(N.value):d(N.value).then(s,a)}m((M=M.apply(R,t||[])).next())})},de=this&&this.__generator||function(R,t){var C={label:0,sent:function(){if(n[0]&1)throw n[1];return n[1]},trys:[],ops:[]},M,d,n,_;return _={next:s(0),throw:s(1),return:s(2)},typeof Symbol=="function"&&(_[Symbol.iterator]=function(){return this}),_;function s(m){return function(N){return a([m,N])}}function a(m){if(M)throw new TypeError("Generator is already executing.");for(;C;)try{if(M=1,d&&(n=m[0]&2?d.return:m[0]?d.throw||((n=d.return)&&n.call(d),0):d.next)&&!(n=n.call(d,m[1])).done)return n;switch(d=0,n&&(m=[m[0]&2,n.value]),m[0]){case 0:case 1:n=m;break;case 4:return C.label++,{value:m[1],done:!1};case 5:C.label++,d=m[1],m=[0];continue;case 7:m=C.ops.pop(),C.trys.pop();continue;default:if(n=C.trys,!(n=n.length>0&&n[n.length-1])&&(m[0]===6||m[0]===2)){C=0;continue}if(m[0]===3&&(!n||m[1]>n[0]&&m[1]<n[3])){C.label=m[1];break}if(m[0]===6&&C.label<n[1]){C.label=n[1],n=m;break}if(n&&C.label<n[2]){C.label=n[2],C.ops.push(m);break}n[2]&&C.ops.pop(),C.trys.pop();continue}m=t.call(R,C)}catch(N){m=[6,N],d=0}finally{M=n=0}if(m[0]&5)throw m[1];return{value:m[0]?m[1]:void 0,done:!0}}},ue=this&&this.__values||function(R){var t=typeof Symbol=="function"&&Symbol.iterator,C=t&&R[t],M=0;if(C)return C.call(R);if(R&&typeof R.length=="number")return{next:function(){return R&&M>=R.length&&(R=void 0),{value:R&&R[M++],done:!R}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},fe=this&&this.__read||function(R,t){var C=typeof Symbol=="function"&&R[Symbol.iterator];if(!C)return R;var M=C.call(R),d,n=[],_;try{for(;(t===void 0||t-- >0)&&!(d=M.next()).done;)n.push(d.value)}catch(s){_={error:s}}finally{try{d&&!d.done&&(C=M.return)&&C.call(M)}finally{if(_)throw _.error}}return n},_e=this&&this.__spreadArray||function(R,t){for(var C=0,M=t.length,d=R.length;C<M;C++,d++)R[d]=t[C];return R};te(re[16],ie([1,0,4]),function(R,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.mergeSort=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function M(T,k){return k===void 0&&(k=0),T[T.length-(1+k)]}t.tail=M;function d(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}t.tail2=d;function n(T,k,O){if(O===void 0&&(O=function(J,x){return J===x}),T===k)return!0;if(!T||!k||T.length!==k.length)return!1;for(var Y=0,G=T.length;Y<G;Y++)if(!O(T[Y],k[Y]))return!1;return!0}t.equals=n;function _(T,k,O){for(var Y=0,G=T.length-1;Y<=G;){var J=(Y+G)/2|0,x=O(T[J],k);if(x<0)Y=J+1;else if(x>0)G=J-1;else return J}return-(Y+1)}t.binarySearch=_;function s(T,k){var O=0,Y=T.length;if(Y===0)return 0;for(;O<Y;){var G=Math.floor((O+Y)/2);k(T[G])?Y=G:O=G+1}return O}t.findFirstInSorted=s;function a(T,k,O){var Y,G;if(T=T|0,T>=k.length)throw new TypeError("invalid index");var J=k[Math.floor(k.length*Math.random())],x=[],se=[],ee=[];try{for(var oe=ue(k),le=oe.next();!le.done;le=oe.next()){var ve=le.value,me=O(ve,J);me<0?x.push(ve):me>0?se.push(ve):ee.push(ve)}}catch(be){Y={error:be}}finally{try{le&&!le.done&&(G=oe.return)&&G.call(oe)}finally{if(Y)throw Y.error}}return T<x.length?a(T,x,O):T<x.length+ee.length?ee[0]:a(T-(x.length+ee.length),se,O)}t.quickSelect=a;function m(T,k){return l(T,k,0,T.length-1,[]),T}t.mergeSort=m;function N(T,k,O,Y,G,J){for(var x=O,se=Y+1,ee=O;ee<=G;ee++)J[ee]=T[ee];for(var ee=O;ee<=G;ee++)x>Y?T[ee]=J[se++]:se>G?T[ee]=J[x++]:k(J[se],J[x])<0?T[ee]=J[se++]:T[ee]=J[x++]}function l(T,k,O,Y,G){if(!(Y<=O)){var J=O+(Y-O)/2|0;l(T,k,O,J,G),l(T,k,J+1,Y,G),!(k(T[J],T[J+1])<=0)&&N(T,k,O,J,Y,G)}}function b(T,k){var O,Y,G=[],J=void 0;try{for(var x=ue(m(T.slice(0),k)),se=x.next();!se.done;se=x.next()){var ee=se.value;!J||k(J[0],ee)!==0?(J=[ee],G.push(J)):J.push(ee)}}catch(oe){O={error:oe}}finally{try{se&&!se.done&&(Y=x.return)&&Y.call(x)}finally{if(O)throw O.error}}return G}t.groupBy=b;function S(T,k,O){var Y=[];function G(le,ve,me){var be;if(!(ve===0&&me.length===0)){var Le=Y[Y.length-1];Le&&Le.start+Le.deleteCount===le?(Le.deleteCount+=ve,(be=Le.toInsert).push.apply(be,_e([],fe(me)))):Y.push({start:le,deleteCount:ve,toInsert:me})}}for(var J=0,x=0;;){if(J===T.length){G(J,0,k.slice(x));break}if(x===k.length){G(J,T.length-J,[]);break}var se=T[J],ee=k[x],oe=O(se,ee);oe===0?(J+=1,x+=1):oe<0?(G(J,1,[]),J+=1):oe>0&&(G(J,0,[ee]),x+=1)}return Y}t.sortedDiff=S;function E(T,k,O){var Y,G,J=S(T,k,O),x=[],se=[];try{for(var ee=ue(J),oe=ee.next();!oe.done;oe=ee.next()){var le=oe.value;x.push.apply(x,_e([],fe(T.slice(le.start,le.start+le.deleteCount)))),se.push.apply(se,_e([],fe(le.toInsert)))}}catch(ve){Y={error:ve}}finally{try{oe&&!oe.done&&(G=ee.return)&&G.call(ee)}finally{if(Y)throw Y.error}}return{removed:x,added:se}}t.delta=E;function c(T,k,O){if(O===0)return[];var Y=T.slice(0,O).sort(k);return h(T,k,Y,O,T.length),Y}t.top=c;function g(T,k,O,Y,G){var J=this;return O===0?Promise.resolve([]):new Promise(function(x,se){(function(){return pe(J,void 0,void 0,function(){var ee,oe,le,ve;return de(this,function(me){switch(me.label){case 0:ee=T.length,oe=T.slice(0,O).sort(k),le=O,ve=Math.min(O+Y,ee),me.label=1;case 1:return le<ee?le>O?[4,new Promise(function(be){return setTimeout(be)})]:[3,3]:[3,5];case 2:me.sent(),me.label=3;case 3:if(G&&G.isCancellationRequested)throw C.canceled();h(T,k,oe,le,ve),me.label=4;case 4:return le=ve,ve=Math.min(ve+Y,ee),[3,1];case 5:return[2,oe]}})})})().then(x,se)})}t.topAsync=g;function h(T,k,O,Y,G){for(var J=function(se){var ee=T[Y];if(k(ee,O[se-1])<0){O.pop();var oe=s(O,function(le){return k(ee,le)<0});O.splice(oe,0,ee)}},x=O.length;Y<G;Y++)J(x)}function p(T){return T.filter(function(k){return!!k})}t.coalesce=p;function i(T){for(var k=0,O=0;O<T.length;O++)T[O]&&(T[k]=T[O],k+=1);T.length=k}t.coalesceInPlace=i;function u(T,k,O){T.splice(O,0,T.splice(k,1)[0])}t.move=u;function r(T){return!Array.isArray(T)||T.length===0}t.isFalsyOrEmpty=r;function f(T){return Array.isArray(T)&&T.length>0}t.isNonEmptyArray=f;function v(T,k){if(!k)return T.filter(function(Y,G){return T.indexOf(Y)===G});var O=Object.create(null);return T.filter(function(Y){var G=k(Y);return O[G]?!1:(O[G]=!0,!0)})}t.distinct=v;function L(T){var k=new Set;return T.filter(function(O){return k.has(O)?!1:(k.add(O),!0)})}t.distinctES6=L;function y(T){var k=Object.create(null);return function(O){var Y=T(O);return k[Y]?!1:(k[Y]=!0,!0)}}t.uniqueFilter=y;function o(T,k){for(var O=T.length-1;O>=0;O--){var Y=T[O];if(k(Y))return O}return-1}t.lastIndex=o;function w(T,k){return T.length>0?T[0]:k}t.firstOrDefault=w;function A(T,k,O){O===void 0&&(O=function(x,se){return x===se});for(var Y=0,G=0,J=Math.min(T.length,k.length);G<J&&O(T[G],k[G]);G++)Y++;return Y}t.commonPrefixLength=A;function D(T){var k;return(k=[]).concat.apply(k,_e([],fe(T)))}t.flatten=D;function F(T,k){var O=typeof k=="number"?T:0;typeof k=="number"?O=T:(O=0,k=T);var Y=[];if(O<=k)for(var G=O;G<k;G++)Y.push(G);else for(var G=O;G>k;G--)Y.push(G);return Y}t.range=F;function I(T,k,O){return T.reduce(function(Y,G){return Y[k(G)]=O?O(G):G,Y},Object.create(null))}t.index=I;function z(T,k){return T.push(k),function(){return X(T,k)}}t.insert=z;function X(T,k){var O=T.indexOf(k);if(O>-1)return T.splice(O,1),k}t.remove=X;function H(T,k,O){var Y=T.slice(0,k),G=T.slice(k);return Y.concat(O,G)}t.arrayInsert=H;function $(T,k){var O;if(typeof k=="number"){var Y=k;O=function(){var se=Math.sin(Y++)*179426549;return se-Math.floor(se)}}else O=Math.random;for(var G=T.length-1;G>0;G-=1){var J=Math.floor(O()*(G+1)),x=T[G];T[G]=T[J],T[J]=x}}t.shuffle=$;function e(T,k){var O=T.indexOf(k);O>-1&&(T.splice(O,1),T.unshift(k))}t.pushToStart=e;function W(T,k){var O=T.indexOf(k);O>-1&&(T.splice(O,1),T.push(k))}t.pushToEnd=W;function j(T,k){return Array.isArray(T)?T.map(k):k(T)}t.mapArrayOrNot=j;function Q(T){return Array.isArray(T)?T:[T]}t.asArray=Q;function K(T){return T[Math.floor(Math.random()*T.length)]}t.getRandomElement=K;function ae(T,k){var O,Y;try{for(var G=ue(T),J=G.next();!J.done;J=G.next()){var x=J.value,se=k(x);if(se!==void 0)return se}}catch(ee){O={error:ee}}finally{try{J&&!J.done&&(Y=G.return)&&Y.call(G)}finally{if(O)throw O.error}}}t.mapFind=ae}),te(re[7],ie([1,0]),function(R,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function C(M){var d=this,n=!1,_;return function(){return n||(n=!0,_=M.apply(d,arguments)),_}}t.once=C});var ue=this&&this.__values||function(R){var t=typeof Symbol=="function"&&Symbol.iterator,C=t&&R[t],M=0;if(C)return C.call(R);if(R&&typeof R.length=="number")return{next:function(){return R&&M>=R.length&&(R=void 0),{value:R&&R[M++],done:!R}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")};te(re[24],ie([1,0]),function(R,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var C;(function(M){function d(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}M.is=d;var n=Object.freeze([]);function _(){return n}M.empty=_;function s(r){return de(this,function(f){switch(f.label){case 0:return[4,r];case 1:return f.sent(),[2]}})}M.single=s;function a(r){return r||n}M.from=a;function m(r){return!r||r[Symbol.iterator]().next().done===!0}M.isEmpty=m;function N(r){return r[Symbol.iterator]().next().value}M.first=N;function l(r,f){var v,L;try{for(var y=ue(r),o=y.next();!o.done;o=y.next()){var w=o.value;if(f(w))return!0}}catch(A){v={error:A}}finally{try{o&&!o.done&&(L=y.return)&&L.call(y)}finally{if(v)throw v.error}}return!1}M.some=l;function b(r,f){var v,L;try{for(var y=ue(r),o=y.next();!o.done;o=y.next()){var w=o.value;if(f(w))return w}}catch(A){v={error:A}}finally{try{o&&!o.done&&(L=y.return)&&L.call(y)}finally{if(v)throw v.error}}}M.find=b;function S(r,f){var v,L,y,o,w,A;return de(this,function(D){switch(D.label){case 0:D.trys.push([0,5,6,7]),v=ue(r),L=v.next(),D.label=1;case 1:return L.done?[3,4]:(y=L.value,f(y)?[4,y]:[3,3]);case 2:D.sent(),D.label=3;case 3:return L=v.next(),[3,1];case 4:return[3,7];case 5:return o=D.sent(),w={error:o},[3,7];case 6:try{L&&!L.done&&(A=v.return)&&A.call(v)}finally{if(w)throw w.error}return[7];case 7:return[2]}})}M.filter=S;function E(r,f){var v,L,y,o,w,A;return de(this,function(D){switch(D.label){case 0:D.trys.push([0,5,6,7]),v=ue(r),L=v.next(),D.label=1;case 1:return L.done?[3,4]:(y=L.value,[4,f(y)]);case 2:D.sent(),D.label=3;case 3:return L=v.next(),[3,1];case 4:return[3,7];case 5:return o=D.sent(),w={error:o},[3,7];case 6:try{L&&!L.done&&(A=v.return)&&A.call(v)}finally{if(w)throw w.error}return[7];case 7:return[2]}})}M.map=E;function c(){var r,f,v,L,y,o,w,A,D,F,I,z,X,H=[];for(r=0;r<arguments.length;r++)H[r]=arguments[r];return de(this,function($){switch($.label){case 0:$.trys.push([0,11,12,13]),f=ue(H),v=f.next(),$.label=1;case 1:if(v.done)return[3,10];L=v.value,$.label=2;case 2:$.trys.push([2,7,8,9]),y=(z=void 0,ue(L)),o=y.next(),$.label=3;case 3:return o.done?[3,6]:(w=o.value,[4,w]);case 4:$.sent(),$.label=5;case 5:return o=y.next(),[3,3];case 6:return[3,9];case 7:return A=$.sent(),z={error:A},[3,9];case 8:try{o&&!o.done&&(X=y.return)&&X.call(y)}finally{if(z)throw z.error}return[7];case 9:return v=f.next(),[3,1];case 10:return[3,13];case 11:return D=$.sent(),F={error:D},[3,13];case 12:try{v&&!v.done&&(I=f.return)&&I.call(f)}finally{if(F)throw F.error}return[7];case 13:return[2]}})}M.concat=c;function g(r){var f,v,L,y,o,w,A,D,F,I,z,X;return de(this,function(H){switch(H.label){case 0:H.trys.push([0,11,12,13]),f=ue(r),v=f.next(),H.label=1;case 1:if(v.done)return[3,10];L=v.value,H.label=2;case 2:H.trys.push([2,7,8,9]),y=(z=void 0,ue(L)),o=y.next(),H.label=3;case 3:return o.done?[3,6]:(w=o.value,[4,w]);case 4:H.sent(),H.label=5;case 5:return o=y.next(),[3,3];case 6:return[3,9];case 7:return A=H.sent(),z={error:A},[3,9];case 8:try{o&&!o.done&&(X=y.return)&&X.call(y)}finally{if(z)throw z.error}return[7];case 9:return v=f.next(),[3,1];case 10:return[3,13];case 11:return D=H.sent(),F={error:D},[3,13];case 12:try{v&&!v.done&&(I=f.return)&&I.call(f)}finally{if(F)throw F.error}return[7];case 13:return[2]}})}M.concatNested=g;function h(r,f,v){var L,y,o=v;try{for(var w=ue(r),A=w.next();!A.done;A=w.next()){var D=A.value;o=f(o,D)}}catch(F){L={error:F}}finally{try{A&&!A.done&&(y=w.return)&&y.call(w)}finally{if(L)throw L.error}}return o}M.reduce=h;function p(r,f,v){return v===void 0&&(v=r.length),de(this,function(L){switch(L.label){case 0:f<0&&(f+=r.length),v<0?v+=r.length:v>r.length&&(v=r.length),L.label=1;case 1:return f<v?[4,r[f]]:[3,4];case 2:L.sent(),L.label=3;case 3:return f++,[3,1];case 4:return[2]}})}M.slice=p;function i(r,f){var v;f===void 0&&(f=Number.POSITIVE_INFINITY);var L=[];if(f===0)return[L,r];for(var y=r[Symbol.iterator](),o=0;o<f;o++){var w=y.next();if(w.done)return[L,M.empty()];L.push(w.value)}return[L,(v={},v[Symbol.iterator]=function(){return y},v)]}M.consume=i;function u(r,f,v){v===void 0&&(v=function(A,D){return A===D});for(var L=r[Symbol.iterator](),y=f[Symbol.iterator]();;){var o=L.next(),w=y.next();if(o.done!==w.done)return!1;if(o.done)return!0;if(!v(o.value,w.value))return!1}}M.equals=u})(C=t.Iterable||(t.Iterable={}))}),te(re[25],ie([1,0,4]),function(R,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=t.KeyChord=t.KeyCodeUtils=void 0;var M=function(){function c(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}return c.prototype.define=function(g,h){this._keyCodeToStr[g]=h,this._strToKeyCode[h.toLowerCase()]=g},c.prototype.keyCodeToStr=function(g){return this._keyCodeToStr[g]},c.prototype.strToKeyCode=function(g){return this._strToKeyCode[g.toLowerCase()]||0},c}(),d=new M,n=new M,_=new M;(function(){function c(g,h,p,i){p===void 0&&(p=h),i===void 0&&(i=p),d.define(g,h),n.define(g,p),_.define(g,i)}c(0,"unknown"),c(1,"Backspace"),c(2,"Tab"),c(3,"Enter"),c(4,"Shift"),c(5,"Ctrl"),c(6,"Alt"),c(7,"PauseBreak"),c(8,"CapsLock"),c(9,"Escape"),c(10,"Space"),c(11,"PageUp"),c(12,"PageDown"),c(13,"End"),c(14,"Home"),c(15,"LeftArrow","Left"),c(16,"UpArrow","Up"),c(17,"RightArrow","Right"),c(18,"DownArrow","Down"),c(19,"Insert"),c(20,"Delete"),c(21,"0"),c(22,"1"),c(23,"2"),c(24,"3"),c(25,"4"),c(26,"5"),c(27,"6"),c(28,"7"),c(29,"8"),c(30,"9"),c(31,"A"),c(32,"B"),c(33,"C"),c(34,"D"),c(35,"E"),c(36,"F"),c(37,"G"),c(38,"H"),c(39,"I"),c(40,"J"),c(41,"K"),c(42,"L"),c(43,"M"),c(44,"N"),c(45,"O"),c(46,"P"),c(47,"Q"),c(48,"R"),c(49,"S"),c(50,"T"),c(51,"U"),c(52,"V"),c(53,"W"),c(54,"X"),c(55,"Y"),c(56,"Z"),c(57,"Meta"),c(58,"ContextMenu"),c(59,"F1"),c(60,"F2"),c(61,"F3"),c(62,"F4"),c(63,"F5"),c(64,"F6"),c(65,"F7"),c(66,"F8"),c(67,"F9"),c(68,"F10"),c(69,"F11"),c(70,"F12"),c(71,"F13"),c(72,"F14"),c(73,"F15"),c(74,"F16"),c(75,"F17"),c(76,"F18"),c(77,"F19"),c(78,"NumLock"),c(79,"ScrollLock"),c(80,";",";","OEM_1"),c(81,"=","=","OEM_PLUS"),c(82,",",",","OEM_COMMA"),c(83,"-","-","OEM_MINUS"),c(84,".",".","OEM_PERIOD"),c(85,"/","/","OEM_2"),c(86,"`","`","OEM_3"),c(110,"ABNT_C1"),c(111,"ABNT_C2"),c(87,"[","[","OEM_4"),c(88,"\\","\\","OEM_5"),c(89,"]","]","OEM_6"),c(90,"'","'","OEM_7"),c(91,"OEM_8"),c(92,"OEM_102"),c(93,"NumPad0"),c(94,"NumPad1"),c(95,"NumPad2"),c(96,"NumPad3"),c(97,"NumPad4"),c(98,"NumPad5"),c(99,"NumPad6"),c(100,"NumPad7"),c(101,"NumPad8"),c(102,"NumPad9"),c(103,"NumPad_Multiply"),c(104,"NumPad_Add"),c(105,"NumPad_Separator"),c(106,"NumPad_Subtract"),c(107,"NumPad_Decimal"),c(108,"NumPad_Divide")})();var s;(function(c){function g(r){return d.keyCodeToStr(r)}c.toString=g;function h(r){return d.strToKeyCode(r)}c.fromString=h;function p(r){return n.keyCodeToStr(r)}c.toUserSettingsUS=p;function i(r){return _.keyCodeToStr(r)}c.toUserSettingsGeneral=i;function u(r){return n.strToKeyCode(r)||_.strToKeyCode(r)}c.fromUserSettings=u})(s=t.KeyCodeUtils||(t.KeyCodeUtils={}));function a(c,g){var h=(g&65535)<<16>>>0;return(c|h)>>>0}t.KeyChord=a;function m(c,g){if(c===0)return null;var h=(c&65535)>>>0,p=(c&4294901760)>>>16;return p!==0?new b([N(h,g),N(p,g)]):new b([N(h,g)])}t.createKeybinding=m;function N(c,g){var h=!!(c&2048),p=!!(c&256),i=g===2?p:h,u=!!(c&1024),r=!!(c&512),f=g===2?h:p,v=c&255;return new l(i,u,r,f,v)}t.createSimpleKeybinding=N;var l=function(){function c(g,h,p,i,u){this.ctrlKey=g,this.shiftKey=h,this.altKey=p,this.metaKey=i,this.keyCode=u}return c.prototype.equals=function(g){return this.ctrlKey===g.ctrlKey&&this.shiftKey===g.shiftKey&&this.altKey===g.altKey&&this.metaKey===g.metaKey&&this.keyCode===g.keyCode},c.prototype.getHashCode=function(){var g=this.ctrlKey?"1":"0",h=this.shiftKey?"1":"0",p=this.altKey?"1":"0",i=this.metaKey?"1":"0";return""+g+h+p+i+this.keyCode},c.prototype.isModifierKey=function(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4},c.prototype.toChord=function(){return new b([this])},c.prototype.isDuplicateModifierCase=function(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57},c}();t.SimpleKeybinding=l;var b=function(){function c(g){if(g.length===0)throw C.illegalArgument("parts");this.parts=g}return c.prototype.getHashCode=function(){for(var g="",h=0,p=this.parts.length;h<p;h++)h!==0&&(g+=";"),g+=this.parts[h].getHashCode();return g},c.prototype.equals=function(g){if(g===null||this.parts.length!==g.parts.length)return!1;for(var h=0;h<this.parts.length;h++)if(!this.parts[h].equals(g.parts[h]))return!1;return!0},c}();t.ChordKeybinding=b;var S=function(){function c(g,h,p,i,u,r){this.ctrlKey=g,this.shiftKey=h,this.altKey=p,this.metaKey=i,this.keyLabel=u,this.keyAriaLabel=r}return c}();t.ResolvedKeybindingPart=S;var E=function(){function c(){}return c}();t.ResolvedKeybinding=E});var ue=this&&this.__values||function(R){var t=typeof Symbol=="function"&&Symbol.iterator,C=t&&R[t],M=0;if(C)return C.call(R);if(R&&typeof R.length=="number")return{next:function(){return R&&M>=R.length&&(R=void 0),{value:R&&R[M++],done:!R}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},fe=this&&this.__read||function(R,t){var C=typeof Symbol=="function"&&R[Symbol.iterator];if(!C)return R;var M=C.call(R),d,n=[],_;try{for(;(t===void 0||t-- >0)&&!(d=M.next()).done;)n.push(d.value)}catch(s){_={error:s}}finally{try{d&&!d.done&&(C=M.return)&&C.call(M)}finally{if(_)throw _.error}}return n},_e=this&&this.__spreadArray||function(R,t){for(var C=0,M=t.length,d=R.length;C<M;C++,d++)R[d]=t[C];return R};te(re[8],ie([1,0,7,24]),function(R,t,C,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ImmortalReference=t.ReferenceCollection=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.MultiDisposeError=t.trackDisposable=t.setDisposableTracker=void 0;var d=!1,n=null;function _(u){n=u}if(t.setDisposableTracker=_,d){var s="__is_disposable_tracked__";n=new(function(){function u(){}return u.prototype.trackDisposable=function(r){var f=new Error("Potentially leaked disposable").stack;setTimeout(function(){r[s]||console.log(f)},3e3)},u.prototype.markTracked=function(r){if(r&&r!==g.None)try{r[s]=!0}catch(f){}},u}())}function a(u){!n||n.markTracked(u)}function m(u){return n&&n.trackDisposable(u),u}t.trackDisposable=m;var N=function(u){ye(r,u);function r(f){var v=u.call(this,"Encountered errors while disposing of store. Errors: ["+f.join(", ")+"]")||this;return v.errors=f,v}return r}(Error);t.MultiDisposeError=N;function l(u){return typeof u.dispose=="function"&&u.dispose.length===0}t.isDisposable=l;function b(u){var r,f;if(M.Iterable.is(u)){var v=[];try{for(var L=ue(u),y=L.next();!y.done;y=L.next()){var o=y.value;if(o){a(o);try{o.dispose()}catch(w){v.push(w)}}}}catch(w){r={error:w}}finally{try{y&&!y.done&&(f=L.return)&&f.call(L)}finally{if(r)throw r.error}}if(v.length===1)throw v[0];if(v.length>1)throw new N(v);return Array.isArray(u)?[]:u}else if(u)return a(u),u.dispose(),u}t.dispose=b;function S(){for(var u=[],r=0;r<arguments.length;r++)u[r]=arguments[r];return u.forEach(a),E(function(){return b(u)})}t.combinedDisposable=S;function E(u){var r=m({dispose:function(){a(r),u()}});return r}t.toDisposable=E;var c=function(){function u(){this._toDispose=new Set,this._isDisposed=!1}return u.prototype.dispose=function(){this._isDisposed||(a(this),this._isDisposed=!0,this.clear())},u.prototype.clear=function(){try{b(this._toDispose.values())}finally{this._toDispose.clear()}},u.prototype.add=function(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return a(r),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r},u.DISABLE_DISPOSED_WARNING=!1,u}();t.DisposableStore=c;var g=function(){function u(){this._store=new c,m(this)}return u.prototype.dispose=function(){a(this),this._store.dispose()},u.prototype._register=function(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)},u.None=Object.freeze({dispose:function(){}}),u}();t.Disposable=g;var h=function(){function u(){this._isDisposed=!1,m(this)}return Object.defineProperty(u.prototype,"value",{get:function(){return this._isDisposed?void 0:this._value},set:function(r){var f;this._isDisposed||r===this._value||((f=this._value)===null||f===void 0||f.dispose(),r&&a(r),this._value=r)},enumerable:!1,configurable:!0}),u.prototype.clear=function(){this.value=void 0},u.prototype.dispose=function(){var r;this._isDisposed=!0,a(this),(r=this._value)===null||r===void 0||r.dispose(),this._value=void 0},u}();t.MutableDisposable=h;var p=function(){function u(){this.references=new Map}return u.prototype.acquire=function(r){for(var f=this,v=[],L=1;L<arguments.length;L++)v[L-1]=arguments[L];var y=this.references.get(r);y||(y={counter:0,object:this.createReferencedObject.apply(this,_e([r],fe(v)))},this.references.set(r,y));var o=y.object,w=C.once(function(){--y.counter==0&&(f.destroyReferencedObject(r,y.object),f.references.delete(r))});return y.counter++,{object:o,dispose:w}},u}();t.ReferenceCollection=p;var i=function(){function u(r){this.object=r}return u.prototype.dispose=function(){},u}();t.ImmortalReference=i}),te(re[18],ie([1,0]),function(R,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;var C=function(){function d(n){this.element=n,this.next=d.Undefined,this.prev=d.Undefined}return d.Undefined=new d(void 0),d}(),M=function(){function d(){this._first=C.Undefined,this._last=C.Undefined,this._size=0}return Object.defineProperty(d.prototype,"size",{get:function(){return this._size},enumerable:!1,configurable:!0}),d.prototype.isEmpty=function(){return this._first===C.Undefined},d.prototype.clear=function(){this._first=C.Undefined,this._last=C.Undefined,this._size=0},d.prototype.unshift=function(n){return this._insert(n,!1)},d.prototype.push=function(n){return this._insert(n,!0)},d.prototype._insert=function(n,_){var s=this,a=new C(n);if(this._first===C.Undefined)this._first=a,this._last=a;else if(_){var m=this._last;this._last=a,a.prev=m,m.next=a}else{var N=this._first;this._first=a,a.next=N,N.prev=a}this._size+=1;var l=!1;return function(){l||(l=!0,s._remove(a))}},d.prototype.shift=function(){if(this._first!==C.Undefined){var n=this._first.element;return this._remove(this._first),n}},d.prototype.pop=function(){if(this._last!==C.Undefined){var n=this._last.element;return this._remove(this._last),n}},d.prototype._remove=function(n){if(n.prev!==C.Undefined&&n.next!==C.Undefined){var _=n.prev;_.next=n.next,n.next.prev=_}else n.prev===C.Undefined&&n.next===C.Undefined?(this._first=C.Undefined,this._last=C.Undefined):n.next===C.Undefined?(this._last=this._last.prev,this._last.next=C.Undefined):n.prev===C.Undefined&&(this._first=this._first.next,this._first.prev=C.Undefined);this._size-=1},d.prototype[Symbol.iterator]=function(){var n;return de(this,function(_){switch(_.label){case 0:n=this._first,_.label=1;case 1:return n===C.Undefined?[3,3]:[4,n.element];case 2:return _.sent(),n=n.next,[3,1];case 3:return[2]}})},d}();t.LinkedList=M}),te(re[2],ie([1,0]),function(R,t){"use strict";var C;Object.defineProperty(t,"__esModule",{value:!0}),t.isLittleEndian=t.OS=t.setImmediate=t.globals=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isIOS=t.isWeb=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.isPreferringBrowserCodeLoad=t.browserCodeLoadingCacheStrategy=t.isElectronSandboxed=void 0;var M="en",d=!1,n=!1,_=!1,s=!1,a=!1,m=!1,N=!1,l=void 0,b=M,S=void 0,E=void 0,c=typeof self=="object"?self:typeof global=="object"?global:{},g=void 0;typeof process!="undefined"?g=process:typeof c.vscode!="undefined"&&(g=c.vscode.process);var h=typeof((C=g==null?void 0:g.versions)===null||C===void 0?void 0:C.electron)=="string"&&g.type==="renderer";if(t.isElectronSandboxed=h&&(g==null?void 0:g.sandboxed),t.browserCodeLoadingCacheStrategy=function(){if(t.isElectronSandboxed)return"bypassHeatCheck";var w=g==null?void 0:g.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof w=="string")return w==="none"||w==="code"||w==="bypassHeatCheck"||w==="bypassHeatCheckAndEagerCompile"?w:"bypassHeatCheck"}(),t.isPreferringBrowserCodeLoad=typeof t.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!h)E=navigator.userAgent,d=E.indexOf("Windows")>=0,n=E.indexOf("Macintosh")>=0,N=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=E.indexOf("Linux")>=0,m=!0,l=navigator.language,b=l;else if(typeof g=="object"){d=g.platform==="win32",n=g.platform==="darwin",_=g.platform==="linux",s=_&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,l=M,b=M;var p=g.env.VSCODE_NLS_CONFIG;if(p)try{var i=JSON.parse(p),u=i.availableLanguages["*"];l=i.locale,b=u||M,S=i._translationsConfigFile}catch(w){}a=!0}else console.error("Unable to resolve platform.");function r(w){switch(w){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=r;var f=0;n?f=1:d?f=3:_&&(f=2),t.isWindows=d,t.isMacintosh=n,t.isLinux=_,t.isLinuxSnap=s,t.isNative=a,t.isWeb=m,t.isIOS=N,t.platform=f,t.userAgent=E,t.language=b;var v;(function(w){function A(){return t.language}w.value=A;function D(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}w.isDefaultVariant=D;function F(){return t.language==="en"}w.isDefault=F})(v=t.Language||(t.Language={})),t.locale=l,t.translationsConfigFile=S,t.globals=c,t.setImmediate=function(){if(t.globals.setImmediate)return t.globals.setImmediate.bind(t.globals);if(typeof t.globals.postMessage=="function"&&!t.globals.importScripts){var A=[];t.globals.addEventListener("message",function(I){if(I.data&&I.data.vscodeSetImmediateId)for(var z=0,X=A.length;z<X;z++){var H=A[z];if(H.id===I.data.vscodeSetImmediateId){A.splice(z,1),H.callback();return}}});var D=0;return function(I){var z=++D;A.push({id:z,callback:I}),t.globals.postMessage({vscodeSetImmediateId:z},"*")}}if(g&&typeof g.nextTick=="function")return g.nextTick.bind(g);var F=Promise.resolve();return function(I){return F.then(I)}}(),t.OS=n||N?2:d?1:3;var L=!0,y=!1;function o(){if(!y){y=!0;var w=new Uint8Array(2);w[0]=1,w[1]=2;var A=new Uint16Array(w.buffer);L=A[0]===(2<<8)+1}return L}t.isLittleEndian=o}),te(re[20],ie([1,0,2]),function(R,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.nextTick=t.platform=t.env=t.cwd=void 0;var M;typeof process!="undefined"?M=process:typeof C.globals.vscode!="undefined"?M={get platform(){return C.globals.vscode.process.platform},get env(){return C.globals.vscode.process.env},nextTick:function(d){return C.setImmediate(d)},cwd:function(){return C.globals.vscode.process.env.VSCODE_CWD||C.globals.vscode.process.execPath.substr(0,C.globals.vscode.process.execPath.lastIndexOf(C.globals.vscode.process.platform==="win32"?"\\":"/"))}}:M={get platform(){return C.isWindows?"win32":C.isMacintosh?"darwin":"linux"},nextTick:function(d){return C.setImmediate(d)},get env(){return Object.create(null)},cwd:function(){return"/"}},t.cwd=M.cwd,t.env=M.env,t.platform=M.platform,t.nextTick=M.nextTick}),te(re[21],ie([1,0,20]),function(R,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;var M=65,d=97,n=90,_=122,s=46,a=47,m=92,N=58,l=63,b=function(i){ye(u,i);function u(r,f,v){var L=this,y;typeof f=="string"&&f.indexOf("not ")===0?(y="must not be",f=f.replace(/^not /,"")):y="must be";var o=r.indexOf(".")!==-1?"property":"argument",w='The "'+r+'" '+o+" "+y+" of type "+f;return w+=". Received type "+typeof v,L=i.call(this,w)||this,L.code="ERR_INVALID_ARG_TYPE",L}return u}(Error);function S(i,u){if(typeof i!="string")throw new b(u,"string",i)}function E(i){return i===a||i===m}function c(i){return i===a}function g(i){return i>=M&&i<=n||i>=d&&i<=_}function h(i,u,r,f){for(var v="",L=0,y=-1,o=0,w=0,A=0;A<=i.length;++A){if(A<i.length)w=i.charCodeAt(A);else{if(f(w))break;w=a}if(f(w)){if(!(y===A-1||o===1))if(o===2){if(v.length<2||L!==2||v.charCodeAt(v.length-1)!==s||v.charCodeAt(v.length-2)!==s){if(v.length>2){var D=v.lastIndexOf(r);D===-1?(v="",L=0):(v=v.slice(0,D),L=v.length-1-v.lastIndexOf(r)),y=A,o=0;continue}else if(v.length!==0){v="",L=0,y=A,o=0;continue}}u&&(v+=v.length>0?r+"..":"..",L=2)}else v.length>0?v+=""+r+i.slice(y+1,A):v=i.slice(y+1,A),L=A-y-1;y=A,o=0}else w===s&&o!==-1?++o:o=-1}return v}function p(i,u){if(u===null||typeof u!="object")throw new b("pathObject","Object",u);var r=u.dir||u.root,f=u.base||""+(u.name||"")+(u.ext||"");return r?r===u.root?""+r+f:""+r+i+f:f}t.win32={resolve:function(){for(var i=[],u=0;u<arguments.length;u++)i[u]=arguments[u];for(var r="",f="",v=!1,L=i.length-1;L>=-1;L--){var y=void 0;if(L>=0){if(y=i[L],S(y,"path"),y.length===0)continue}else r.length===0?y=C.cwd():(y=C.env["="+r]||C.cwd(),(y===void 0||y.slice(0,2).toLowerCase()!==r.toLowerCase()&&y.charCodeAt(2)===m)&&(y=r+"\\"));var o=y.length,w=0,A="",D=!1,F=y.charCodeAt(0);if(o===1)E(F)&&(w=1,D=!0);else if(E(F))if(D=!0,E(y.charCodeAt(1))){for(var I=2,z=I;I<o&&!E(y.charCodeAt(I));)I++;if(I<o&&I!==z){var X=y.slice(z,I);for(z=I;I<o&&E(y.charCodeAt(I));)I++;if(I<o&&I!==z){for(z=I;I<o&&!E(y.charCodeAt(I));)I++;(I===o||I!==z)&&(A="\\\\"+X+"\\"+y.slice(z,I),w=I)}}}else w=1;else g(F)&&y.charCodeAt(1)===N&&(A=y.slice(0,2),w=2,o>2&&E(y.charCodeAt(2))&&(D=!0,w=3));if(A.length>0)if(r.length>0){if(A.toLowerCase()!==r.toLowerCase())continue}else r=A;if(v){if(r.length>0)break}else if(f=y.slice(w)+"\\"+f,v=D,D&&r.length>0)break}return f=h(f,!v,"\\",E),v?r+"\\"+f:""+r+f||"."},normalize:function(i){S(i,"path");var u=i.length;if(u===0)return".";var r=0,f,v=!1,L=i.charCodeAt(0);if(u===1)return c(L)?"\\":i;if(E(L))if(v=!0,E(i.charCodeAt(1))){for(var y=2,o=y;y<u&&!E(i.charCodeAt(y));)y++;if(y<u&&y!==o){var w=i.slice(o,y);for(o=y;y<u&&E(i.charCodeAt(y));)y++;if(y<u&&y!==o){for(o=y;y<u&&!E(i.charCodeAt(y));)y++;if(y===u)return"\\\\"+w+"\\"+i.slice(o)+"\\";y!==o&&(f="\\\\"+w+"\\"+i.slice(o,y),r=y)}}}else r=1;else g(L)&&i.charCodeAt(1)===N&&(f=i.slice(0,2),r=2,u>2&&E(i.charCodeAt(2))&&(v=!0,r=3));var A=r<u?h(i.slice(r),!v,"\\",E):"";return A.length===0&&!v&&(A="."),A.length>0&&E(i.charCodeAt(u-1))&&(A+="\\"),f===void 0?v?"\\"+A:A:v?f+"\\"+A:""+f+A},isAbsolute:function(i){S(i,"path");var u=i.length;if(u===0)return!1;var r=i.charCodeAt(0);return E(r)||u>2&&g(r)&&i.charCodeAt(1)===N&&E(i.charCodeAt(2))},join:function(){for(var i=[],u=0;u<arguments.length;u++)i[u]=arguments[u];if(i.length===0)return".";for(var r,f,v=0;v<i.length;++v){var L=i[v];S(L,"path"),L.length>0&&(r===void 0?r=f=L:r+="\\"+L)}if(r===void 0)return".";var y=!0,o=0;if(typeof f=="string"&&E(f.charCodeAt(0))){++o;var w=f.length;w>1&&E(f.charCodeAt(1))&&(++o,w>2&&(E(f.charCodeAt(2))?++o:y=!1))}if(y){for(;o<r.length&&E(r.charCodeAt(o));)o++;o>=2&&(r="\\"+r.slice(o))}return t.win32.normalize(r)},relative:function(i,u){if(S(i,"from"),S(u,"to"),i===u)return"";var r=t.win32.resolve(i),f=t.win32.resolve(u);if(r===f||(i=r.toLowerCase(),u=f.toLowerCase(),i===u))return"";for(var v=0;v<i.length&&i.charCodeAt(v)===m;)v++;for(var L=i.length;L-1>v&&i.charCodeAt(L-1)===m;)L--;for(var y=L-v,o=0;o<u.length&&u.charCodeAt(o)===m;)o++;for(var w=u.length;w-1>o&&u.charCodeAt(w-1)===m;)w--;for(var A=w-o,D=y<A?y:A,F=-1,I=0;I<D;I++){var z=i.charCodeAt(v+I);if(z!==u.charCodeAt(o+I))break;z===m&&(F=I)}if(I!==D){if(F===-1)return f}else{if(A>D){if(u.charCodeAt(o+I)===m)return f.slice(o+I+1);if(I===2)return f.slice(o+I)}y>D&&(i.charCodeAt(v+I)===m?F=I:I===2&&(F=3)),F===-1&&(F=0)}var X="";for(I=v+F+1;I<=L;++I)(I===L||i.charCodeAt(I)===m)&&(X+=X.length===0?"..":"\\..");return o+=F,X.length>0?""+X+f.slice(o,w):(f.charCodeAt(o)===m&&++o,f.slice(o,w))},toNamespacedPath:function(i){if(typeof i!="string")return i;if(i.length===0)return"";var u=t.win32.resolve(i);if(u.length<=2)return i;if(u.charCodeAt(0)===m){if(u.charCodeAt(1)===m){var r=u.charCodeAt(2);if(r!==l&&r!==s)return"\\\\?\\UNC\\"+u.slice(2)}}else if(g(u.charCodeAt(0))&&u.charCodeAt(1)===N&&u.charCodeAt(2)===m)return"\\\\?\\"+u;return i},dirname:function(i){S(i,"path");var u=i.length;if(u===0)return".";var r=-1,f=0,v=i.charCodeAt(0);if(u===1)return E(v)?i:".";if(E(v)){if(r=f=1,E(i.charCodeAt(1))){for(var L=2,y=L;L<u&&!E(i.charCodeAt(L));)L++;if(L<u&&L!==y){for(y=L;L<u&&E(i.charCodeAt(L));)L++;if(L<u&&L!==y){for(y=L;L<u&&!E(i.charCodeAt(L));)L++;if(L===u)return i;L!==y&&(r=f=L+1)}}}}else g(v)&&i.charCodeAt(1)===N&&(r=u>2&&E(i.charCodeAt(2))?3:2,f=r);for(var o=-1,w=!0,A=u-1;A>=f;--A)if(E(i.charCodeAt(A))){if(!w){o=A;break}}else w=!1;if(o===-1){if(r===-1)return".";o=r}return i.slice(0,o)},basename:function(i,u){u!==void 0&&S(u,"ext"),S(i,"path");var r=0,f=-1,v=!0,L;if(i.length>=2&&g(i.charCodeAt(0))&&i.charCodeAt(1)===N&&(r=2),u!==void 0&&u.length>0&&u.length<=i.length){if(u===i)return"";var y=u.length-1,o=-1;for(L=i.length-1;L>=r;--L){var w=i.charCodeAt(L);if(E(w)){if(!v){r=L+1;break}}else o===-1&&(v=!1,o=L+1),y>=0&&(w===u.charCodeAt(y)?--y==-1&&(f=L):(y=-1,f=o))}return r===f?f=o:f===-1&&(f=i.length),i.slice(r,f)}for(L=i.length-1;L>=r;--L)if(E(i.charCodeAt(L))){if(!v){r=L+1;break}}else f===-1&&(v=!1,f=L+1);return f===-1?"":i.slice(r,f)},extname:function(i){S(i,"path");var u=0,r=-1,f=0,v=-1,L=!0,y=0;i.length>=2&&i.charCodeAt(1)===N&&g(i.charCodeAt(0))&&(u=f=2);for(var o=i.length-1;o>=u;--o){var w=i.charCodeAt(o);if(E(w)){if(!L){f=o+1;break}continue}v===-1&&(L=!1,v=o+1),w===s?r===-1?r=o:y!==1&&(y=1):r!==-1&&(y=-1)}return r===-1||v===-1||y===0||y===1&&r===v-1&&r===f+1?"":i.slice(r,v)},format:p.bind(null,"\\"),parse:function(i){S(i,"path");var u={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return u;var r=i.length,f=0,v=i.charCodeAt(0);if(r===1)return E(v)?(u.root=u.dir=i,u):(u.base=u.name=i,u);if(E(v)){if(f=1,E(i.charCodeAt(1))){for(var L=2,y=L;L<r&&!E(i.charCodeAt(L));)L++;if(L<r&&L!==y){for(y=L;L<r&&E(i.charCodeAt(L));)L++;if(L<r&&L!==y){for(y=L;L<r&&!E(i.charCodeAt(L));)L++;L===r?f=L:L!==y&&(f=L+1)}}}}else if(g(v)&&i.charCodeAt(1)===N){if(r<=2)return u.root=u.dir=i,u;if(f=2,E(i.charCodeAt(2))){if(r===3)return u.root=u.dir=i,u;f=3}}f>0&&(u.root=i.slice(0,f));for(var o=-1,w=f,A=-1,D=!0,F=i.length-1,I=0;F>=f;--F){if(v=i.charCodeAt(F),E(v)){if(!D){w=F+1;break}continue}A===-1&&(D=!1,A=F+1),v===s?o===-1?o=F:I!==1&&(I=1):o!==-1&&(I=-1)}return A!==-1&&(o===-1||I===0||I===1&&o===A-1&&o===w+1?u.base=u.name=i.slice(w,A):(u.name=i.slice(w,o),u.base=i.slice(w,A),u.ext=i.slice(o,A))),w>0&&w!==f?u.dir=i.slice(0,w-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve:function(){for(var i=[],u=0;u<arguments.length;u++)i[u]=arguments[u];for(var r="",f=!1,v=i.length-1;v>=-1&&!f;v--){var L=v>=0?i[v]:C.cwd();S(L,"path"),L.length!==0&&(r=L+"/"+r,f=L.charCodeAt(0)===a)}return r=h(r,!f,"/",c),f?"/"+r:r.length>0?r:"."},normalize:function(i){if(S(i,"path"),i.length===0)return".";var u=i.charCodeAt(0)===a,r=i.charCodeAt(i.length-1)===a;return i=h(i,!u,"/",c),i.length===0?u?"/":r?"./":".":(r&&(i+="/"),u?"/"+i:i)},isAbsolute:function(i){return S(i,"path"),i.length>0&&i.charCodeAt(0)===a},join:function(){for(var i=[],u=0;u<arguments.length;u++)i[u]=arguments[u];if(i.length===0)return".";for(var r,f=0;f<i.length;++f){var v=i[f];S(v,"path"),v.length>0&&(r===void 0?r=v:r+="/"+v)}return r===void 0?".":t.posix.normalize(r)},relative:function(i,u){if(S(i,"from"),S(u,"to"),i===u||(i=t.posix.resolve(i),u=t.posix.resolve(u),i===u))return"";for(var r=1,f=i.length,v=f-r,L=1,y=u.length-L,o=v<y?v:y,w=-1,A=0;A<o;A++){var D=i.charCodeAt(r+A);if(D!==u.charCodeAt(L+A))break;D===a&&(w=A)}if(A===o)if(y>o){if(u.charCodeAt(L+A)===a)return u.slice(L+A+1);if(A===0)return u.slice(L+A)}else v>o&&(i.charCodeAt(r+A)===a?w=A:A===0&&(w=0));var F="";for(A=r+w+1;A<=f;++A)(A===f||i.charCodeAt(A)===a)&&(F+=F.length===0?"..":"/..");return""+F+u.slice(L+w)},toNamespacedPath:function(i){return i},dirname:function(i){if(S(i,"path"),i.length===0)return".";for(var u=i.charCodeAt(0)===a,r=-1,f=!0,v=i.length-1;v>=1;--v)if(i.charCodeAt(v)===a){if(!f){r=v;break}}else f=!1;return r===-1?u?"/":".":u&&r===1?"//":i.slice(0,r)},basename:function(i,u){u!==void 0&&S(u,"ext"),S(i,"path");var r=0,f=-1,v=!0,L;if(u!==void 0&&u.length>0&&u.length<=i.length){if(u===i)return"";var y=u.length-1,o=-1;for(L=i.length-1;L>=0;--L){var w=i.charCodeAt(L);if(w===a){if(!v){r=L+1;break}}else o===-1&&(v=!1,o=L+1),y>=0&&(w===u.charCodeAt(y)?--y==-1&&(f=L):(y=-1,f=o))}return r===f?f=o:f===-1&&(f=i.length),i.slice(r,f)}for(L=i.length-1;L>=0;--L)if(i.charCodeAt(L)===a){if(!v){r=L+1;break}}else f===-1&&(v=!1,f=L+1);return f===-1?"":i.slice(r,f)},extname:function(i){S(i,"path");for(var u=-1,r=0,f=-1,v=!0,L=0,y=i.length-1;y>=0;--y){var o=i.charCodeAt(y);if(o===a){if(!v){r=y+1;break}continue}f===-1&&(v=!1,f=y+1),o===s?u===-1?u=y:L!==1&&(L=1):u!==-1&&(L=-1)}return u===-1||f===-1||L===0||L===1&&u===f-1&&u===r+1?"":i.slice(u,f)},format:p.bind(null,"/"),parse:function(i){S(i,"path");var u={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return u;var r=i.charCodeAt(0)===a,f;r?(u.root="/",f=1):f=0;for(var v=-1,L=0,y=-1,o=!0,w=i.length-1,A=0;w>=f;--w){var D=i.charCodeAt(w);if(D===a){if(!o){L=w+1;break}continue}y===-1&&(o=!1,y=w+1),D===s?v===-1?v=w:A!==1&&(A=1):v!==-1&&(A=-1)}if(y!==-1){var F=L===0&&r?1:L;v===-1||A===0||A===1&&v===y-1&&v===L+1?u.base=u.name=i.slice(F,y):(u.name=i.slice(F,v),u.base=i.slice(F,y),u.ext=i.slice(v,y))}return L>0?u.dir=i.slice(0,L-1):r&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=C.platform==="win32"?t.win32.normalize:t.posix.normalize,t.isAbsolute=C.platform==="win32"?t.win32.isAbsolute:t.posix.isAbsolute,t.join=C.platform==="win32"?t.win32.join:t.posix.join,t.resolve=C.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=C.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=C.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=C.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=C.platform==="win32"?t.win32.extname:t.posix.extname,t.format=C.platform==="win32"?t.win32.format:t.posix.format,t.parse=C.platform==="win32"?t.win32.parse:t.posix.parse,t.toNamespacedPath=C.platform==="win32"?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=C.platform==="win32"?t.win32.sep:t.posix.sep,t.delimiter=C.platform==="win32"?t.win32.delimiter:t.posix.delimiter}),te(re[13],ie([1,0,2]),function(R,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;var M=C.globals.performance&&typeof C.globals.performance.now=="function",d=function(){function n(_){this._highResolution=M&&_,this._startTime=this._now(),this._stopTime=-1}return n.create=function(_){return _===void 0&&(_=!0),new n(_)},n.prototype.stop=function(){this._stopTime=this._now()},n.prototype.elapsed=function(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime},n.prototype._now=function(){return this._highResolution?C.globals.performance.now():Date.now()},n}();t.StopWatch=d});var fe=this&&this.__read||function(R,t){var C=typeof Symbol=="function"&&R[Symbol.iterator];if(!C)return R;var M=C.call(R),d,n=[],_;try{for(;(t===void 0||t-- >0)&&!(d=M.next()).done;)n.push(d.value)}catch(s){_={error:s}}finally{try{d&&!d.done&&(C=M.return)&&C.call(M)}finally{if(_)throw _.error}}return n},_e=this&&this.__spreadArray||function(R,t){for(var C=0,M=t.length,d=R.length;C<M;C++,d++)R[d]=t[C];return R},ue=this&&this.__values||function(R){var t=typeof Symbol=="function"&&Symbol.iterator,C=t&&R[t],M=0;if(C)return C.call(R);if(R&&typeof R.length=="number")return{next:function(){return R&&M>=R.length&&(R=void 0),{value:R&&R[M++],done:!R}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")};te(re[14],ie([1,0,4,7,8,18,13]),function(R,t,C,M,d,n,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.PauseableEmitter=t.Emitter=t.setGlobalLeakWarningThreshold=t.Event=void 0;var s;(function(h){h.None=function(){return d.Disposable.None};function p(e){return function(W,j,Q){j===void 0&&(j=null);var K=!1,ae;return ae=e(function(T){if(!K)return ae?ae.dispose():K=!0,W.call(j,T)},null,Q),K&&ae.dispose(),ae}}h.once=p;function i(e,W){return y(function(j,Q,K){return Q===void 0&&(Q=null),e(function(ae){return j.call(Q,W(ae))},null,K)})}h.map=i;function u(e,W){return y(function(j,Q,K){return Q===void 0&&(Q=null),e(function(ae){W(ae),j.call(Q,ae)},null,K)})}h.forEach=u;function r(e,W){return y(function(j,Q,K){return Q===void 0&&(Q=null),e(function(ae){return W(ae)&&j.call(Q,ae)},null,K)})}h.filter=r;function f(e){return e}h.signal=f;function v(){for(var e=[],W=0;W<arguments.length;W++)e[W]=arguments[W];return function(j,Q,K){return Q===void 0&&(Q=null),d.combinedDisposable.apply(void 0,_e([],fe(e.map(function(ae){return ae(function(T){return j.call(Q,T)},null,K)}))))}}h.any=v;function L(e,W,j){var Q=j;return i(e,function(K){return Q=W(Q,K),Q})}h.reduce=L;function y(e){var W,j=new b({onFirstListenerAdd:function(){W=e(j.fire,j)},onLastListenerRemove:function(){W.dispose()}});return j.event}h.snapshot=y;function o(e,W,j,Q,K){j===void 0&&(j=100),Q===void 0&&(Q=!1);var ae,T=void 0,k=void 0,O=0,Y=new b({leakWarningThreshold:K,onFirstListenerAdd:function(){ae=e(function(G){O++,T=W(T,G),Q&&!k&&(Y.fire(T),T=void 0),clearTimeout(k),k=setTimeout(function(){var J=T;T=void 0,k=void 0,(!Q||O>1)&&Y.fire(J),O=0},j)})},onLastListenerRemove:function(){ae.dispose()}});return Y.event}h.debounce=o;function w(e){var W=new Date().getTime();return i(p(e),function(j){return new Date().getTime()-W})}h.stopwatch=w;function A(e){var W=!0,j;return r(e,function(Q){var K=W||Q!==j;return W=!1,j=Q,K})}h.latch=A;function D(e,W,j){W===void 0&&(W=!1),j===void 0&&(j=[]);var Q=j.slice(),K=e(function(k){Q?Q.push(k):T.fire(k)}),ae=function(){Q&&Q.forEach(function(k){return T.fire(k)}),Q=null},T=new b({onFirstListenerAdd:function(){K||(K=e(function(k){return T.fire(k)}))},onFirstListenerDidAdd:function(){Q&&(W?setTimeout(ae):ae())},onLastListenerRemove:function(){K&&K.dispose(),K=null}});return T.event}h.buffer=D;var F=function(){function e(W){this.event=W}return e.prototype.map=function(W){return new e(i(this.event,W))},e.prototype.forEach=function(W){return new e(u(this.event,W))},e.prototype.filter=function(W){return new e(r(this.event,W))},e.prototype.reduce=function(W,j){return new e(L(this.event,W,j))},e.prototype.latch=function(){return new e(A(this.event))},e.prototype.debounce=function(W,j,Q,K){return j===void 0&&(j=100),Q===void 0&&(Q=!1),new e(o(this.event,W,j,Q,K))},e.prototype.on=function(W,j,Q){return this.event(W,j,Q)},e.prototype.once=function(W,j,Q){return p(this.event)(W,j,Q)},e}();function I(e){return new F(e)}h.chain=I;function z(e,W,j){j===void 0&&(j=function(k){return k});var Q=function(){for(var k=[],O=0;O<arguments.length;O++)k[O]=arguments[O];return T.fire(j.apply(void 0,_e([],fe(k))))},K=function(){return e.on(W,Q)},ae=function(){return e.removeListener(W,Q)},T=new b({onFirstListenerAdd:K,onLastListenerRemove:ae});return T.event}h.fromNodeEventEmitter=z;function X(e,W,j){j===void 0&&(j=function(k){return k});var Q=function(){for(var k=[],O=0;O<arguments.length;O++)k[O]=arguments[O];return T.fire(j.apply(void 0,_e([],fe(k))))},K=function(){return e.addEventListener(W,Q)},ae=function(){return e.removeEventListener(W,Q)},T=new b({onFirstListenerAdd:K,onLastListenerRemove:ae});return T.event}h.fromDOMEventEmitter=X;function H(e){var W=new b,j=!1;return e.then(void 0,function(){return null}).then(function(){j?W.fire(void 0):setTimeout(function(){return W.fire(void 0)},0)}),j=!0,W.event}h.fromPromise=H;function $(e){return new Promise(function(W){return p(e)(W)})}h.toPromise=$})(s=t.Event||(t.Event={}));var a=function(){function h(p){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=p+"_"+h._idPool++}return h.prototype.start=function(p){this._stopWatch=new _.StopWatch(!0),this._listenerCount=p},h.prototype.stop=function(){if(this._stopWatch){var p=this._stopWatch.elapsed();this._elapsedOverall+=p,this._invocationCount+=1,console.info("did FIRE "+this._name+": elapsed_ms: "+p.toFixed(5)+", listener: "+this._listenerCount+" (elapsed_overall: "+this._elapsedOverall.toFixed(2)+", invocations: "+this._invocationCount+")"),this._stopWatch=void 0}},h._idPool=0,h}(),m=-1;function N(h){var p=m;return m=h,{dispose:function(){m=p}}}t.setGlobalLeakWarningThreshold=N;var l=function(){function h(p,i){i===void 0&&(i=Math.random().toString(18).slice(2,5)),this.customThreshold=p,this.name=i,this._warnCountdown=0}return h.prototype.dispose=function(){this._stacks&&this._stacks.clear()},h.prototype.check=function(p){var i,u,r=this,f=m;if(typeof this.customThreshold=="number"&&(f=this.customThreshold),!(f<=0||p<f)){this._stacks||(this._stacks=new Map);var v=new Error().stack.split(`
`).slice(3).join(`
`),L=this._stacks.get(v)||0;if(this._stacks.set(v,L+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=f*.5;var y=void 0,o=0;try{for(var w=ue(this._stacks),A=w.next();!A.done;A=w.next()){var D=fe(A.value,2),F=D[0],I=D[1];(!y||o<I)&&(y=F,o=I)}}catch(z){i={error:z}}finally{try{A&&!A.done&&(u=w.return)&&u.call(w)}finally{if(i)throw i.error}}console.warn("["+this.name+"] potential listener LEAK detected, having "+p+" listeners already. MOST frequent listener ("+o+"):"),console.warn(y)}return function(){var z=r._stacks.get(v)||0;r._stacks.set(v,z-1)}}},h}(),b=function(){function h(p){var i;this._disposed=!1,this._options=p,this._leakageMon=m>0?new l(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((i=this._options)===null||i===void 0?void 0:i._profName)?new a(this._options._profName):void 0}return Object.defineProperty(h.prototype,"event",{get:function(){var p=this;return this._event||(this._event=function(i,u,r){var f;p._listeners||(p._listeners=new n.LinkedList);var v=p._listeners.isEmpty();v&&p._options&&p._options.onFirstListenerAdd&&p._options.onFirstListenerAdd(p);var L=p._listeners.push(u?[i,u]:i);v&&p._options&&p._options.onFirstListenerDidAdd&&p._options.onFirstListenerDidAdd(p),p._options&&p._options.onListenerDidAdd&&p._options.onListenerDidAdd(p,i,u);var y=(f=p._leakageMon)===null||f===void 0?void 0:f.check(p._listeners.size),o;return o={dispose:function(){if(y&&y(),o.dispose=h._noop,!p._disposed&&(L(),p._options&&p._options.onLastListenerRemove)){var w=p._listeners&&!p._listeners.isEmpty();w||p._options.onLastListenerRemove(p)}}},r instanceof d.DisposableStore?r.add(o):Array.isArray(r)&&r.push(o),o}),this._event},enumerable:!1,configurable:!0}),h.prototype.fire=function(p){var i,u,r,f;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new n.LinkedList);try{for(var v=ue(this._listeners),L=v.next();!L.done;L=v.next()){var y=L.value;this._deliveryQueue.push([y,p])}}catch(A){i={error:A}}finally{try{L&&!L.done&&(u=v.return)&&u.call(v)}finally{if(i)throw i.error}}for((r=this._perfMon)===null||r===void 0||r.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){var o=fe(this._deliveryQueue.shift(),2),y=o[0],w=o[1];try{typeof y=="function"?y.call(void 0,w):y[0].call(y[1],w)}catch(D){C.onUnexpectedError(D)}}(f=this._perfMon)===null||f===void 0||f.stop()}},h.prototype.dispose=function(){var p,i,u;(p=this._listeners)===null||p===void 0||p.clear(),(i=this._deliveryQueue)===null||i===void 0||i.clear(),(u=this._leakageMon)===null||u===void 0||u.dispose(),this._disposed=!0},h._noop=function(){},h}();t.Emitter=b;var S=function(h){ye(p,h);function p(i){var u=h.call(this,i)||this;return u._isPaused=0,u._eventQueue=new n.LinkedList,u._mergeFn=i==null?void 0:i.merge,u}return p.prototype.pause=function(){this._isPaused++},p.prototype.resume=function(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){var i=Array.from(this._eventQueue);this._eventQueue.clear(),h.prototype.fire.call(this,this._mergeFn(i))}else for(;!this._isPaused&&this._eventQueue.size!==0;)h.prototype.fire.call(this,this._eventQueue.shift())},p.prototype.fire=function(i){this._listeners&&(this._isPaused!==0?this._eventQueue.push(i):h.prototype.fire.call(this,i))},p}(b);t.PauseableEmitter=S;var E=function(){function h(){var p=this;this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:function(){return p.onFirstListenerAdd()},onLastListenerRemove:function(){return p.onLastListenerRemove()}})}return Object.defineProperty(h.prototype,"event",{get:function(){return this.emitter.event},enumerable:!1,configurable:!0}),h.prototype.add=function(p){var i=this,u={event:p,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);var r=function(){i.hasListeners&&i.unhook(u);var f=i.events.indexOf(u);i.events.splice(f,1)};return d.toDisposable(M.once(r))},h.prototype.onFirstListenerAdd=function(){var p=this;this.hasListeners=!0,this.events.forEach(function(i){return p.hook(i)})},h.prototype.onLastListenerRemove=function(){var p=this;this.hasListeners=!1,this.events.forEach(function(i){return p.unhook(i)})},h.prototype.hook=function(p){var i=this;p.listener=p.event(function(u){return i.emitter.fire(u)})},h.prototype.unhook=function(p){p.listener&&p.listener.dispose(),p.listener=null},h.prototype.dispose=function(){this.emitter.dispose()},h}();t.EventMultiplexer=E;var c=function(){function h(){this.buffers=[]}return h.prototype.wrapEvent=function(p){var i=this;return function(u,r,f){return p(function(v){var L=i.buffers[i.buffers.length-1];L?L.push(function(){return u.call(r,v)}):u.call(r,v)},void 0,f)}},h.prototype.bufferEvents=function(p){var i=[];this.buffers.push(i);var u=p();return this.buffers.pop(),i.forEach(function(r){return r()}),u},h}();t.EventBufferer=c;var g=function(){function h(){var p=this;this.listening=!1,this.inputEvent=s.None,this.inputEventListener=d.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:function(){p.listening=!0,p.inputEventListener=p.inputEvent(p.emitter.fire,p.emitter)},onLastListenerRemove:function(){p.listening=!1,p.inputEventListener.dispose()}}),this.event=this.emitter.event}return Object.defineProperty(h.prototype,"input",{set:function(p){this.inputEvent=p,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=p(this.emitter.fire,this.emitter))},enumerable:!1,configurable:!0}),h.prototype.dispose=function(){this.inputEventListener.dispose(),this.emitter.dispose()},h}();t.Relay=g}),te(re[15],ie([1,0,14]),function(R,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;var M=Object.freeze(function(s,a){var m=setTimeout(s.bind(a),0);return{dispose:function(){clearTimeout(m)}}}),d;(function(s){function a(m){return m===s.None||m===s.Cancelled||m instanceof n?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}s.isCancellationToken=a,s.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:C.Event.None}),s.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(d=t.CancellationToken||(t.CancellationToken={}));var n=function(){function s(){this._isCancelled=!1,this._emitter=null}return s.prototype.cancel=function(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))},Object.defineProperty(s.prototype,"isCancellationRequested",{get:function(){return this._isCancelled},enumerable:!1,configurable:!0}),Object.defineProperty(s.prototype,"onCancellationRequested",{get:function(){return this._isCancelled?M:(this._emitter||(this._emitter=new C.Emitter),this._emitter.event)},enumerable:!1,configurable:!0}),s.prototype.dispose=function(){this._emitter&&(this._emitter.dispose(),this._emitter=null)},s}(),_=function(){function s(a){this._token=void 0,this._parentListener=void 0,this._parentListener=a&&a.onCancellationRequested(this.cancel,this)}return Object.defineProperty(s.prototype,"token",{get:function(){return this._token||(this._token=new n),this._token},enumerable:!1,configurable:!0}),s.prototype.cancel=function(){this._token?this._token instanceof n&&this._token.cancel():this._token=d.Cancelled},s.prototype.dispose=function(a){a===void 0&&(a=!1),a&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof n&&this._token.dispose():this._token=d.None},s}();t.CancellationTokenSource=_}),te(re[6],ie([1,0]),function(R,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.breakBetweenGraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsEmoji=t.containsRTL=t.decodeUTF8=t.encodeUTF8=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format=t.isFalsyOrWhitespace=void 0;function C(P){return!P||typeof P!="string"?!0:P.trim().length===0}t.isFalsyOrWhitespace=C;var M=/{(\d+)}/g;function d(P){for(var U=[],q=1;q<arguments.length;q++)U[q-1]=arguments[q];return U.length===0?P:P.replace(M,function(B,V){var Z=parseInt(V,10);return isNaN(Z)||Z<0||Z>=U.length?B:U[Z]})}t.format=d;function n(P){return P.replace(/[<>&]/g,function(U){switch(U){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return U}})}t.escape=n;function _(P){return P.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=_;function s(P,U){for(var q=0,B=U.charCodeAt(0),V=P.length-1;V>=0;V--)P.charCodeAt(V)===B&&q++;return q}t.count=s;function a(P,U,q){return q===void 0&&(q="\u2026"),P.length<=U?P:""+P.substr(0,U)+q}t.truncate=a;function m(P,U){U===void 0&&(U=" ");var q=N(P,U);return l(q,U)}t.trim=m;function N(P,U){if(!P||!U)return P;var q=U.length;if(q===0||P.length===0)return P;for(var B=0;P.indexOf(U,B)===B;)B=B+q;return P.substring(B)}t.ltrim=N;function l(P,U){if(!P||!U)return P;var q=U.length,B=P.length;if(q===0||B===0)return P;for(var V=B,Z=-1;Z=P.lastIndexOf(U,V-1),!(Z===-1||Z+q!==V);){if(Z===0)return"";V=Z}return P.substring(0,V)}t.rtrim=l;function b(P){return P.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=b;function S(P){return P.replace(/\*/g,"")}t.stripWildcards=S;function E(P,U,q){if(q===void 0&&(q={}),!P)throw new Error("Cannot create regex from empty string");U||(P=_(P)),q.wholeWord&&(/\B/.test(P.charAt(0))||(P="\\b"+P),/\B/.test(P.charAt(P.length-1))||(P=P+"\\b"));var B="";return q.global&&(B+="g"),q.matchCase||(B+="i"),q.multiline&&(B+="m"),q.unicode&&(B+="u"),new RegExp(P,B)}t.createRegExp=E;function c(P){if(P.source==="^"||P.source==="^$"||P.source==="$"||P.source==="^\\s*$")return!1;var U=P.exec("");return!!(U&&P.lastIndex===0)}t.regExpLeadsToEndlessLoop=c;function g(P){return!!P.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=g;function h(P){return(P.global?"g":"")+(P.ignoreCase?"i":"")+(P.multiline?"m":"")+(P.unicode?"u":"")}t.regExpFlags=h;function p(P){return P.split(/\r\n|\r|\n/)}t.splitLines=p;function i(P){for(var U=0,q=P.length;U<q;U++){var B=P.charCodeAt(U);if(B!==32&&B!==9)return U}return-1}t.firstNonWhitespaceIndex=i;function u(P,U,q){U===void 0&&(U=0),q===void 0&&(q=P.length);for(var B=U;B<q;B++){var V=P.charCodeAt(B);if(V!==32&&V!==9)return P.substring(U,B)}return P.substring(U,q)}t.getLeadingWhitespace=u;function r(P,U){U===void 0&&(U=P.length-1);for(var q=U;q>=0;q--){var B=P.charCodeAt(q);if(B!==32&&B!==9)return q}return-1}t.lastNonWhitespaceIndex=r;function f(P,U){return P<U?-1:P>U?1:0}t.compare=f;function v(P,U,q,B,V,Z){for(q===void 0&&(q=0),B===void 0&&(B=P.length),V===void 0&&(V=0),Z===void 0&&(Z=U.length);q<B&&V<Z;q++,V++){var ne=P.charCodeAt(q),ce=U.charCodeAt(V);if(ne<ce)return-1;if(ne>ce)return 1}var ge=B-q,we=Z-V;return ge<we?-1:ge>we?1:0}t.compareSubstring=v;function L(P,U){return y(P,U,0,P.length,0,U.length)}t.compareIgnoreCase=L;function y(P,U,q,B,V,Z){for(q===void 0&&(q=0),B===void 0&&(B=P.length),V===void 0&&(V=0),Z===void 0&&(Z=U.length);q<B&&V<Z;q++,V++){var ne=P.charCodeAt(q),ce=U.charCodeAt(V);if(ne!==ce){var ge=ne-ce;if(!(ge===32&&w(ce))&&!(ge===-32&&w(ne)))return o(ne)&&o(ce)?ge:v(P.toLowerCase(),U.toLowerCase(),q,B,V,Z)}}var we=B-q,Ce=Z-V;return we<Ce?-1:we>Ce?1:0}t.compareSubstringIgnoreCase=y;function o(P){return P>=97&&P<=122}t.isLowerAsciiLetter=o;function w(P){return P>=65&&P<=90}t.isUpperAsciiLetter=w;function A(P){return o(P)||w(P)}function D(P,U){return P.length===U.length&&F(P,U)}t.equalsIgnoreCase=D;function F(P,U,q){q===void 0&&(q=P.length);for(var B=0;B<q;B++){var V=P.charCodeAt(B),Z=U.charCodeAt(B);if(V!==Z){if(A(V)&&A(Z)){var ne=Math.abs(V-Z);if(ne!==0&&ne!==32)return!1}else if(String.fromCharCode(V).toLowerCase()!==String.fromCharCode(Z).toLowerCase())return!1}}return!0}function I(P,U){var q=U.length;return U.length>P.length?!1:F(P,U,q)}t.startsWithIgnoreCase=I;function z(P,U){var q,B=Math.min(P.length,U.length);for(q=0;q<B;q++)if(P.charCodeAt(q)!==U.charCodeAt(q))return q;return B}t.commonPrefixLength=z;function X(P,U){var q,B=Math.min(P.length,U.length),V=P.length-1,Z=U.length-1;for(q=0;q<B;q++)if(P.charCodeAt(V-q)!==U.charCodeAt(Z-q))return q;return B}t.commonSuffixLength=X;function H(P){return 55296<=P&&P<=56319}t.isHighSurrogate=H;function $(P){return 56320<=P&&P<=57343}t.isLowSurrogate=$;function e(P,U){return(P-55296<<10)+(U-56320)+65536}t.computeCodePoint=e;function W(P,U,q){var B=P.charCodeAt(q);if(H(B)&&q+1<U){var V=P.charCodeAt(q+1);if($(V))return e(B,V)}return B}t.getNextCodePoint=W;function j(P,U){var q=P.charCodeAt(U-1);if($(q)&&U>1){var B=P.charCodeAt(U-2);if(H(B))return e(B,q)}return q}function Q(P,U){var q=Ne.getInstance(),B=U,V=P.length,Z=W(P,V,U);U+=Z>=65536?2:1;for(var ne=q.getGraphemeBreakType(Z);U<V;){var ce=W(P,V,U),ge=q.getGraphemeBreakType(ce);if(Se(ne,ge))break;U+=ce>=65536?2:1,ne=ge}return U-B}t.nextCharLength=Q;function K(P,U){var q=Ne.getInstance(),B=U,V=j(P,U);U-=V>=65536?2:1;for(var Z=q.getGraphemeBreakType(V);U>0;){var ne=j(P,U),ce=q.getGraphemeBreakType(ne);if(Se(ce,Z))break;U-=ne>=65536?2:1,Z=ce}return B-U}t.prevCharLength=K;function ae(P,U){var q=Ne.getInstance(),B=P.length,V=U,Z=W(P,B,U),ne=q.getGraphemeBreakType(Z);U+=Z>=65536?2:1;for(var ce=ne;U<B;){var ge=W(P,B,U),we=q.getGraphemeBreakType(ge);if(Se(ce,we))break;U+=ge>=65536?2:1,ce=we}var Ce=U;for(U=V,ce=ne;U>0;){var Ae=j(P,U),Pe=q.getGraphemeBreakType(Ae);if(Se(Pe,ce))break;U-=Ae>=65536?2:1,ce=Pe}return[U,Ce]}function T(P,U){return U>0&&$(P.charCodeAt(U))?ae(P,U-1):ae(P,U)}t.getCharContainingOffset=T;function k(P){for(var U=P.length,q=0,B=0;B<U;){var V=W(P,U,B);B+=V>=65536?2:1,V<128?q+=1:V<2048?q+=2:V<65536?q+=3:q+=4}var Z=new Uint8Array(q);B=0;for(var ne=0;B<U;){var V=W(P,U,B);B+=V>=65536?2:1,V<128?Z[ne++]=V:V<2048?(Z[ne++]=192|(V&1984)>>>6,Z[ne++]=128|(V&63)>>>0):V<65536?(Z[ne++]=224|(V&61440)>>>12,Z[ne++]=128|(V&4032)>>>6,Z[ne++]=128|(V&63)>>>0):(Z[ne++]=240|(V&1835008)>>>18,Z[ne++]=128|(V&258048)>>>12,Z[ne++]=128|(V&4032)>>>6,Z[ne++]=128|(V&63)>>>0)}return Z}t.encodeUTF8=k;function O(P){for(var U=P.byteLength,q=[],B=0;B<U;){var V=P[B],Z=void 0;if(V>=240&&B+3<U?Z=(P[B++]&7)<<18>>>0|(P[B++]&63)<<12>>>0|(P[B++]&63)<<6>>>0|(P[B++]&63)<<0>>>0:V>=224&&B+2<U?Z=(P[B++]&15)<<12>>>0|(P[B++]&63)<<6>>>0|(P[B++]&63)<<0>>>0:V>=192&&B+1<U?Z=(P[B++]&31)<<6>>>0|(P[B++]&63)<<0>>>0:Z=P[B++],Z>=0&&Z<=55295||Z>=57344&&Z<=65535)q.push(String.fromCharCode(Z));else if(Z>=65536&&Z<=1114111){var ne=Z-65536,ce=55296+((ne&1047552)>>>10),ge=56320+((ne&1023)>>>0);q.push(String.fromCharCode(ce)),q.push(String.fromCharCode(ge))}else q.push(String.fromCharCode(65533))}return q.join("")}t.decodeUTF8=O;var Y=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function G(P){return Y.test(P)}t.containsRTL=G;var J=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function x(P){return J.test(P)}t.containsEmoji=x;var se=/^[\t\n\r\x20-\x7E]*$/;function ee(P){return se.test(P)}t.isBasicASCII=ee,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function oe(P){return t.UNUSUAL_LINE_TERMINATORS.test(P)}t.containsUnusualLineTerminators=oe;function le(P){for(var U=0,q=P.length;U<q;U++)if(ve(P.charCodeAt(U)))return!0;return!1}t.containsFullWidthCharacter=le;function ve(P){return P=+P,P>=11904&&P<=55215||P>=63744&&P<=64255||P>=65281&&P<=65374}t.isFullWidthCharacter=ve;function me(P){return P>=127462&&P<=127487||P===8986||P===8987||P===9200||P===9203||P>=9728&&P<=10175||P===11088||P===11093||P>=127744&&P<=128591||P>=128640&&P<=128764||P>=128992&&P<=129003||P>=129280&&P<=129535||P>=129648&&P<=129750}t.isEmojiImprecise=me;function be(P,U){if(P.length<U)return P;for(var q=/\b/g,B=0;q.test(P)&&!(P.length-q.lastIndex<U);)B=q.lastIndex,q.lastIndex+=1;return P.substring(B).replace(/^\s/,"")}t.lcut=be;var Le=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Ue=/\x1b\[0?m/g;function Fe(P){return P&&(P=P.replace(Le,""),P=P.replace(De,""),P=P.replace(Ue,"")),P}t.removeAnsiEscapeCodes=Fe,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(P){return!!(P&&P.length>0&&P.charCodeAt(0)===65279)}t.startsWithUTF8BOM=Ee;function Te(P){return Ee(P)?P.substr(1):P}t.stripUTF8BOM=Te;function Ie(P,U){if(!P||!U||P.length<U.length)return!1;for(var q=U.length,B=P.toLowerCase(),V=0,Z=-1;V<q;){var ne=B.indexOf(U[V],Z+1);if(ne<0)return!1;Z=ne,V++}return!0}t.fuzzyContains=Ie;function ke(P,U){return U===void 0&&(U=!1),P?(U&&(P=P.replace(/\\./g,"")),P.toLowerCase()!==P):!1}t.containsUppercaseCharacter=ke;function We(P){return P.charAt(0).toUpperCase()+P.slice(1)}t.uppercaseFirstLetter=We;function qe(P,U){if(U===void 0&&(U=1),U===0)return"";var q=-1;do q=P.indexOf(`
`,q+1),U--;while(U>0&&q>=0);return q===-1?P:(P[q-1]==="\r"&&q--,P.substr(0,q))}t.getNLines=qe;function Oe(P){var U=90-65+1;return P=P%(2*U),P<U?String.fromCharCode(97+P):String.fromCharCode(65+P-U)}t.singleLetterHash=Oe;function Be(P){var U=Ne.getInstance();return U.getGraphemeBreakType(P)}t.getGraphemeBreakType=Be;function Se(P,U){return P===0?U!==5&&U!==7:P===2&&U===3?!1:P===4||P===2||P===3||U===4||U===2||U===3?!0:!(P===8&&(U===8||U===9||U===11||U===12)||(P===11||P===9)&&(U===9||U===10)||(P===12||P===10)&&U===10||U===5||U===13||U===7||P===1||P===13&&U===14||P===6&&U===6)}t.breakBetweenGraphemeBreakType=Se;var Ne=function(){function P(){this._data=He()}return P.getInstance=function(){return P._INSTANCE||(P._INSTANCE=new P),P._INSTANCE},P.prototype.getGraphemeBreakType=function(U){if(U<32)return U===10?3:U===13?2:4;if(U<127)return 0;for(var q=this._data,B=q.length/3,V=1;V<=B;)if(U<q[3*V])V=2*V;else if(U>q[3*V+1])V=2*V+1;else return q[3*V+2];return 0},P._INSTANCE=null,P}();function He(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),te(re[17],ie([1,0,6]),function(R,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.doHash=t.hash=void 0;function M(g){return d(g,0)}t.hash=M;function d(g,h){switch(typeof g){case"object":return g===null?n(349,h):Array.isArray(g)?a(g,h):m(g,h);case"string":return s(g,h);case"boolean":return _(g,h);case"number":return n(g,h);case"undefined":return n(937,h);default:return n(617,h)}}t.doHash=d;function n(g,h){return(h<<5)-h+g|0}function _(g,h){return n(g?433:863,h)}function s(g,h){h=n(149417,h);for(var p=0,i=g.length;p<i;p++)h=n(g.charCodeAt(p),h);return h}t.stringHash=s;function a(g,h){return h=n(104579,h),g.reduce(function(p,i){return d(i,p)},h)}function m(g,h){return h=n(181387,h),Object.keys(g).sort().reduce(function(p,i){return p=s(i,p),d(g[i],p)},h)}var N=function(){function g(){this._value=0}return Object.defineProperty(g.prototype,"value",{get:function(){return this._value},enumerable:!1,configurable:!0}),g.prototype.hash=function(h){return this._value=d(h,this._value),this._value},g}();t.Hasher=N;function l(g,h,p){p===void 0&&(p=32);var i=p-h,u=~((1<<i)-1);return(g<<h|(u&g)>>>i)>>>0}function b(g,h,p,i){h===void 0&&(h=0),p===void 0&&(p=g.byteLength),i===void 0&&(i=0);for(var u=0;u<p;u++)g[h+u]=i}function S(g,h,p){for(p===void 0&&(p="0");g.length<h;)g=p+g;return g}function E(g,h){return h===void 0&&(h=32),g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(function(p){return p.toString(16).padStart(2,"0")}).join(""):S((g>>>0).toString(16),h/4)}t.toHexString=E;var c=function(){function g(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}return g.prototype.update=function(h){var p=h.length;if(p!==0){var i=this._buff,u=this._buffLen,r=this._leftoverHighSurrogate,f,v;for(r!==0?(f=r,v=-1,r=0):(f=h.charCodeAt(0),v=0);;){var L=f;if(C.isHighSurrogate(f))if(v+1<p){var y=h.charCodeAt(v+1);C.isLowSurrogate(y)?(v++,L=C.computeCodePoint(f,y)):L=65533}else{r=f;break}else C.isLowSurrogate(f)&&(L=65533);if(u=this._push(i,u,L),v++,v<p)f=h.charCodeAt(v);else break}this._buffLen=u,this._leftoverHighSurrogate=r}},g.prototype._push=function(h,p,i){return i<128?h[p++]=i:i<2048?(h[p++]=192|(i&1984)>>>6,h[p++]=128|(i&63)>>>0):i<65536?(h[p++]=224|(i&61440)>>>12,h[p++]=128|(i&4032)>>>6,h[p++]=128|(i&63)>>>0):(h[p++]=240|(i&1835008)>>>18,h[p++]=128|(i&258048)>>>12,h[p++]=128|(i&4032)>>>6,h[p++]=128|(i&63)>>>0),p>=64&&(this._step(),p-=64,this._totalLen+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),p},g.prototype.digest=function(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),E(this._h0)+E(this._h1)+E(this._h2)+E(this._h3)+E(this._h4)},g.prototype._wrapUp=function(){this._buff[this._buffLen++]=128,b(this._buff,this._buffLen),this._buffLen>56&&(this._step(),b(this._buff));var h=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(h/4294967296),!1),this._buffDV.setUint32(60,h%4294967296,!1),this._step()},g.prototype._step=function(){for(var h=g._bigBlock32,p=this._buffDV,i=0;i<64;i+=4)h.setUint32(i,p.getUint32(i,!1),!1);for(var i=64;i<320;i+=4)h.setUint32(i,l(h.getUint32(i-12,!1)^h.getUint32(i-32,!1)^h.getUint32(i-56,!1)^h.getUint32(i-64,!1),1),!1);for(var u=this._h0,r=this._h1,f=this._h2,v=this._h3,L=this._h4,y,o,w,i=0;i<80;i++)i<20?(y=r&f|~r&v,o=1518500249):i<40?(y=r^f^v,o=1859775393):i<60?(y=r&f|r&v|f&v,o=2400959708):(y=r^f^v,o=3395469782),w=l(u,5)+y+L+o+h.getUint32(i*4,!1)&4294967295,L=v,v=f,f=l(r,30),r=u,u=w;this._h0=this._h0+u&4294967295,this._h1=this._h1+r&4294967295,this._h2=this._h2+f&4294967295,this._h3=this._h3+v&4294967295,this._h4=this._h4+L&4294967295},g._bigBlock32=new DataView(new ArrayBuffer(320)),g}();t.StringSHA1=c});var fe=this&&this.__read||function(R,t){var C=typeof Symbol=="function"&&R[Symbol.iterator];if(!C)return R;var M=C.call(R),d,n=[],_;try{for(;(t===void 0||t-- >0)&&!(d=M.next()).done;)n.push(d.value)}catch(s){_={error:s}}finally{try{d&&!d.done&&(C=M.return)&&C.call(M)}finally{if(_)throw _.error}}return n};te(re[9],ie([1,0,19,17]),function(R,t,C,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.MyArray=t.Debug=t.stringDiff=t.StringDiffSequence=void 0;var d=function(){function N(l){this.source=l}return N.prototype.getElements=function(){for(var l=this.source,b=new Int32Array(l.length),S=0,E=l.length;S<E;S++)b[S]=l.charCodeAt(S);return b},N}();t.StringDiffSequence=d;function n(N,l,b){return new m(new d(N),new d(l)).ComputeDiff(b).changes}t.stringDiff=n;var _=function(){function N(){}return N.Assert=function(l,b){if(!l)throw new Error(b)},N}();t.Debug=_;var s=function(){function N(){}return N.Copy=function(l,b,S,E,c){for(var g=0;g<c;g++)S[E+g]=l[b+g]},N.Copy2=function(l,b,S,E,c){for(var g=0;g<c;g++)S[E+g]=l[b+g]},N}();t.MyArray=s;var a=function(){function N(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}return N.prototype.MarkNextChange=function(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new C.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824},N.prototype.AddOriginalElement=function(l,b){this.m_originalStart=Math.min(this.m_originalStart,l),this.m_modifiedStart=Math.min(this.m_modifiedStart,b),this.m_originalCount++},N.prototype.AddModifiedElement=function(l,b){this.m_originalStart=Math.min(this.m_originalStart,l),this.m_modifiedStart=Math.min(this.m_modifiedStart,b),this.m_modifiedCount++},N.prototype.getChanges=function(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes},N.prototype.getReverseChanges=function(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes},N}(),m=function(){function N(l,b,S){S===void 0&&(S=null),this.ContinueProcessingPredicate=S;var E=fe(N._getElements(l),3),c=E[0],g=E[1],h=E[2],p=fe(N._getElements(b),3),i=p[0],u=p[1],r=p[2];this._hasStrings=h&&r,this._originalStringElements=c,this._originalElementsOrHash=g,this._modifiedStringElements=i,this._modifiedElementsOrHash=u,this.m_forwardHistory=[],this.m_reverseHistory=[]}return N._isStringArray=function(l){return l.length>0&&typeof l[0]=="string"},N._getElements=function(l){var b=l.getElements();if(N._isStringArray(b)){for(var S=new Int32Array(b.length),E=0,c=b.length;E<c;E++)S[E]=M.stringHash(b[E],0);return[b,S,!0]}return b instanceof Int32Array?[[],b,!1]:[[],new Int32Array(b),!1]},N.prototype.ElementsAreEqual=function(l,b){return this._originalElementsOrHash[l]!==this._modifiedElementsOrHash[b]?!1:this._hasStrings?this._originalStringElements[l]===this._modifiedStringElements[b]:!0},N.prototype.OriginalElementsAreEqual=function(l,b){return this._originalElementsOrHash[l]!==this._originalElementsOrHash[b]?!1:this._hasStrings?this._originalStringElements[l]===this._originalStringElements[b]:!0},N.prototype.ModifiedElementsAreEqual=function(l,b){return this._modifiedElementsOrHash[l]!==this._modifiedElementsOrHash[b]?!1:this._hasStrings?this._modifiedStringElements[l]===this._modifiedStringElements[b]:!0},N.prototype.ComputeDiff=function(l){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,l)},N.prototype._ComputeDiff=function(l,b,S,E,c){var g=[!1],h=this.ComputeDiffRecursive(l,b,S,E,g);return c&&(h=this.PrettifyChanges(h)),{quitEarly:g[0],changes:h}},N.prototype.ComputeDiffRecursive=function(l,b,S,E,c){for(c[0]=!1;l<=b&&S<=E&&this.ElementsAreEqual(l,S);)l++,S++;for(;b>=l&&E>=S&&this.ElementsAreEqual(b,E);)b--,E--;if(l>b||S>E){var g=void 0;return S<=E?(_.Assert(l===b+1,"originalStart should only be one more than originalEnd"),g=[new C.DiffChange(l,0,S,E-S+1)]):l<=b?(_.Assert(S===E+1,"modifiedStart should only be one more than modifiedEnd"),g=[new C.DiffChange(l,b-l+1,S,0)]):(_.Assert(l===b+1,"originalStart should only be one more than originalEnd"),_.Assert(S===E+1,"modifiedStart should only be one more than modifiedEnd"),g=[]),g}var h=[0],p=[0],i=this.ComputeRecursionPoint(l,b,S,E,h,p,c),u=h[0],r=p[0];if(i!==null)return i;if(!c[0]){var f=this.ComputeDiffRecursive(l,u,S,r,c),v=[];return c[0]?v=[new C.DiffChange(u+1,b-(u+1)+1,r+1,E-(r+1)+1)]:v=this.ComputeDiffRecursive(u+1,b,r+1,E,c),this.ConcatenateChanges(f,v)}return[new C.DiffChange(l,b-l+1,S,E-S+1)]},N.prototype.WALKTRACE=function(l,b,S,E,c,g,h,p,i,u,r,f,v,L,y,o,w,A){var D=null,F=null,I=new a,z=b,X=S,H=v[0]-o[0]-E,$=-1073741824,e=this.m_forwardHistory.length-1;do{var W=H+l;W===z||W<X&&i[W-1]<i[W+1]?(r=i[W+1],L=r-H-E,r<$&&I.MarkNextChange(),$=r,I.AddModifiedElement(r+1,L),H=W+1-l):(r=i[W-1]+1,L=r-H-E,r<$&&I.MarkNextChange(),$=r-1,I.AddOriginalElement(r,L+1),H=W-1-l),e>=0&&(i=this.m_forwardHistory[e],l=i[0],z=1,X=i.length-1)}while(--e>=-1);if(D=I.getReverseChanges(),A[0]){var j=v[0]+1,Q=o[0]+1;if(D!==null&&D.length>0){var K=D[D.length-1];j=Math.max(j,K.getOriginalEnd()),Q=Math.max(Q,K.getModifiedEnd())}F=[new C.DiffChange(j,f-j+1,Q,y-Q+1)]}else{I=new a,z=g,X=h,H=v[0]-o[0]-p,$=1073741824,e=w?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{var W=H+c;W===z||W<X&&u[W-1]>=u[W+1]?(r=u[W+1]-1,L=r-H-p,r>$&&I.MarkNextChange(),$=r+1,I.AddOriginalElement(r+1,L+1),H=W+1-c):(r=u[W-1],L=r-H-p,r>$&&I.MarkNextChange(),$=r,I.AddModifiedElement(r+1,L+1),H=W-1-c),e>=0&&(u=this.m_reverseHistory[e],c=u[0],z=1,X=u.length-1)}while(--e>=-1);F=I.getChanges()}return this.ConcatenateChanges(D,F)},N.prototype.ComputeRecursionPoint=function(l,b,S,E,c,g,h){var p=0,i=0,u=0,r=0,f=0,v=0;l--,S--,c[0]=0,g[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];var L=b-l+(E-S),y=L+1,o=new Int32Array(y),w=new Int32Array(y),A=E-S,D=b-l,F=l-S,I=b-E,z=D-A,X=z%2==0;o[A]=l,w[D]=b,h[0]=!1;for(var H=1;H<=L/2+1;H++){var $=0,e=0;u=this.ClipDiagonalBound(A-H,H,A,y),r=this.ClipDiagonalBound(A+H,H,A,y);for(var W=u;W<=r;W+=2){W===u||W<r&&o[W-1]<o[W+1]?p=o[W+1]:p=o[W-1]+1,i=p-(W-A)-F;for(var j=p;p<b&&i<E&&this.ElementsAreEqual(p+1,i+1);)p++,i++;if(o[W]=p,p+i>$+e&&($=p,e=i),!X&&Math.abs(W-D)<=H-1&&p>=w[W])return c[0]=p,g[0]=i,j<=w[W]&&1447>0&&H<=1447+1?this.WALKTRACE(A,u,r,F,D,f,v,I,o,w,p,b,c,i,E,g,X,h):null}var Q=($-l+(e-S)-H)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate($,Q))return h[0]=!0,c[0]=$,g[0]=e,Q>0&&1447>0&&H<=1447+1?this.WALKTRACE(A,u,r,F,D,f,v,I,o,w,p,b,c,i,E,g,X,h):(l++,S++,[new C.DiffChange(l,b-l+1,S,E-S+1)]);f=this.ClipDiagonalBound(D-H,H,D,y),v=this.ClipDiagonalBound(D+H,H,D,y);for(var W=f;W<=v;W+=2){W===f||W<v&&w[W-1]>=w[W+1]?p=w[W+1]-1:p=w[W-1],i=p-(W-D)-I;for(var j=p;p>l&&i>S&&this.ElementsAreEqual(p,i);)p--,i--;if(w[W]=p,X&&Math.abs(W-A)<=H&&p<=o[W])return c[0]=p,g[0]=i,j>=o[W]&&1447>0&&H<=1447+1?this.WALKTRACE(A,u,r,F,D,f,v,I,o,w,p,b,c,i,E,g,X,h):null}if(H<=1447){var K=new Int32Array(r-u+2);K[0]=A-u+1,s.Copy2(o,u,K,1,r-u+1),this.m_forwardHistory.push(K),K=new Int32Array(v-f+2),K[0]=D-f+1,s.Copy2(w,f,K,1,v-f+1),this.m_reverseHistory.push(K)}}return this.WALKTRACE(A,u,r,F,D,f,v,I,o,w,p,b,c,i,E,g,X,h)},N.prototype.PrettifyChanges=function(l){for(var b=0;b<l.length;b++){for(var S=l[b],E=b<l.length-1?l[b+1].originalStart:this._originalElementsOrHash.length,c=b<l.length-1?l[b+1].modifiedStart:this._modifiedElementsOrHash.length,g=S.originalLength>0,h=S.modifiedLength>0;S.originalStart+S.originalLength<E&&S.modifiedStart+S.modifiedLength<c&&(!g||this.OriginalElementsAreEqual(S.originalStart,S.originalStart+S.originalLength))&&(!h||this.ModifiedElementsAreEqual(S.modifiedStart,S.modifiedStart+S.modifiedLength));)S.originalStart++,S.modifiedStart++;var p=[null];if(b<l.length-1&&this.ChangesOverlap(l[b],l[b+1],p)){l[b]=p[0],l.splice(b+1,1),b--;continue}}for(var b=l.length-1;b>=0;b--){var S=l[b],E=0,c=0;if(b>0){var i=l[b-1];i.originalLength>0&&(E=i.originalStart+i.originalLength),i.modifiedLength>0&&(c=i.modifiedStart+i.modifiedLength)}for(var g=S.originalLength>0,h=S.modifiedLength>0,u=0,r=this._boundaryScore(S.originalStart,S.originalLength,S.modifiedStart,S.modifiedLength),f=1;;f++){var v=S.originalStart-f,L=S.modifiedStart-f;if(v<E||L<c||g&&!this.OriginalElementsAreEqual(v,v+S.originalLength)||h&&!this.ModifiedElementsAreEqual(L,L+S.modifiedLength))break;var y=this._boundaryScore(v,S.originalLength,L,S.modifiedLength);y>r&&(r=y,u=f)}S.originalStart-=u,S.modifiedStart-=u}if(this._hasStrings)for(var b=1,o=l.length;b<o;b++){var w=l[b-1],A=l[b],D=A.originalStart-w.originalStart-w.originalLength,F=w.originalStart,I=A.originalStart+A.originalLength,z=I-F,X=w.modifiedStart,H=A.modifiedStart+A.modifiedLength,$=H-X;if(D<5&&z<20&&$<20){var e=this._findBetterContiguousSequence(F,z,X,$,D);if(e){var W=fe(e,2),j=W[0],Q=W[1];(j!==w.originalStart+w.originalLength||Q!==w.modifiedStart+w.modifiedLength)&&(w.originalLength=j-w.originalStart,w.modifiedLength=Q-w.modifiedStart,A.originalStart=j+D,A.modifiedStart=Q+D,A.originalLength=I-A.originalStart,A.modifiedLength=H-A.modifiedStart)}}}return l},N.prototype._findBetterContiguousSequence=function(l,b,S,E,c){if(b<c||E<c)return null;for(var g=l+b-c+1,h=S+E-c+1,p=0,i=0,u=0,r=l;r<g;r++)for(var f=S;f<h;f++){var v=this._contiguousSequenceScore(r,f,c);v>0&&v>p&&(p=v,i=r,u=f)}return p>0?[i,u]:null},N.prototype._contiguousSequenceScore=function(l,b,S){for(var E=0,c=0;c<S;c++){if(!this.ElementsAreEqual(l+c,b+c))return 0;E+=this._originalStringElements[l+c].length}return E},N.prototype._OriginalIsBoundary=function(l){return l<=0||l>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[l])},N.prototype._OriginalRegionIsBoundary=function(l,b){if(this._OriginalIsBoundary(l)||this._OriginalIsBoundary(l-1))return!0;if(b>0){var S=l+b;if(this._OriginalIsBoundary(S-1)||this._OriginalIsBoundary(S))return!0}return!1},N.prototype._ModifiedIsBoundary=function(l){return l<=0||l>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[l])},N.prototype._ModifiedRegionIsBoundary=function(l,b){if(this._ModifiedIsBoundary(l)||this._ModifiedIsBoundary(l-1))return!0;if(b>0){var S=l+b;if(this._ModifiedIsBoundary(S-1)||this._ModifiedIsBoundary(S))return!0}return!1},N.prototype._boundaryScore=function(l,b,S,E){var c=this._OriginalRegionIsBoundary(l,b)?1:0,g=this._ModifiedRegionIsBoundary(S,E)?1:0;return c+g},N.prototype.ConcatenateChanges=function(l,b){var S=[];if(l.length===0||b.length===0)return b.length>0?b:l;if(this.ChangesOverlap(l[l.length-1],b[0],S)){var E=new Array(l.length+b.length-1);return s.Copy(l,0,E,0,l.length-1),E[l.length-1]=S[0],s.Copy(b,1,E,l.length,b.length-1),E}else{var E=new Array(l.length+b.length);return s.Copy(l,0,E,0,l.length),s.Copy(b,0,E,l.length,b.length),E}},N.prototype.ChangesOverlap=function(l,b,S){if(_.Assert(l.originalStart<=b.originalStart,"Left change is not less than or equal to right change"),_.Assert(l.modifiedStart<=b.modifiedStart,"Left change is not less than or equal to right change"),l.originalStart+l.originalLength>=b.originalStart||l.modifiedStart+l.modifiedLength>=b.modifiedStart){var E=l.originalStart,c=l.originalLength,g=l.modifiedStart,h=l.modifiedLength;return l.originalStart+l.originalLength>=b.originalStart&&(c=b.originalStart+b.originalLength-l.originalStart),l.modifiedStart+l.modifiedLength>=b.modifiedStart&&(h=b.modifiedStart+b.modifiedLength-l.modifiedStart),S[0]=new C.DiffChange(E,c,g,h),!0}else return S[0]=null,!1},N.prototype.ClipDiagonalBound=function(l,b,S,E){if(l>=0&&l<E)return l;var c=S,g=E-S-1,h=b%2==0;if(l<0){var p=c%2==0;return h===p?0:1}else{var i=g%2==0;return h===i?E-1:E-2}},N}();t.LcsDiff=m});var ue=this&&this.__values||function(R){var t=typeof Symbol=="function"&&Symbol.iterator,C=t&&R[t],M=0;if(C)return C.call(R);if(R&&typeof R.length=="number")return{next:function(){return R&&M>=R.length&&(R=void 0),{value:R&&R[M++],done:!R}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")};te(re[10],ie([1,0]),function(R,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NotImplementedProxy=t.withUndefinedAsNull=t.withNullAsUndefined=t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isNumber=t.isObject=t.isStringArray=t.isString=t.isArray=void 0;function C(o){return Array.isArray(o)}t.isArray=C;function M(o){return typeof o=="string"}t.isString=M;function d(o){return Array.isArray(o)&&o.every(function(w){return M(w)})}t.isStringArray=d;function n(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}t.isObject=n;function _(o){return typeof o=="number"&&!isNaN(o)}t.isNumber=_;function s(o){return o===!0||o===!1}t.isBoolean=s;function a(o){return typeof o=="undefined"}t.isUndefined=a;function m(o){return!N(o)}t.isDefined=m;function N(o){return a(o)||o===null}t.isUndefinedOrNull=N;function l(o,w){if(!o)throw new Error(w?"Unexpected type, expected '"+w+"'":"Unexpected type")}t.assertType=l;function b(o){if(N(o))throw new Error("Assertion Failed: argument is undefined or null");return o}t.assertIsDefined=b;function S(){for(var o=[],w=0;w<arguments.length;w++)o[w]=arguments[w];for(var A=[],D=0;D<o.length;D++){var F=o[D];if(N(F))throw new Error("Assertion Failed: argument at index "+D+" is undefined or null");A.push(F)}return A}t.assertAllDefined=S;var E=Object.prototype.hasOwnProperty;function c(o){if(!n(o))return!1;for(var w in o)if(E.call(o,w))return!1;return!0}t.isEmptyObject=c;function g(o){return typeof o=="function"}t.isFunction=g;function h(){for(var o=[],w=0;w<arguments.length;w++)o[w]=arguments[w];return o.length>0&&o.every(g)}t.areFunctions=h;function p(o,w){for(var A=Math.min(o.length,w.length),D=0;D<A;D++)i(o[D],w[D])}t.validateConstraints=p;function i(o,w){if(M(w)){if(typeof o!==w)throw new Error("argument does not match constraint: typeof "+w)}else if(g(w)){try{if(o instanceof w)return}catch(A){}if(!N(o)&&o.constructor===w||w.length===1&&w.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=i;function u(o){for(var w=[],A=Object.getPrototypeOf(o);Object.prototype!==A;)w=w.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return w}t.getAllPropertyNames=u;function r(o){var w,A,D=[];try{for(var F=ue(u(o)),I=F.next();!I.done;I=F.next()){var z=I.value;typeof o[z]=="function"&&D.push(z)}}catch(X){w={error:X}}finally{try{I&&!I.done&&(A=F.return)&&A.call(F)}finally{if(w)throw w.error}}return D}t.getAllMethodNames=r;function f(o,w){var A,D,F=function($){return function(){var e=Array.prototype.slice.call(arguments,0);return w($,e)}},I={};try{for(var z=ue(o),X=z.next();!X.done;X=z.next()){var H=X.value;I[H]=F(H)}}catch($){A={error:$}}finally{try{X&&!X.done&&(D=z.return)&&D.call(z)}finally{if(A)throw A.error}}return I}t.createProxyObject=f;function v(o){return o===null?void 0:o}t.withNullAsUndefined=v;function L(o){return typeof o=="undefined"?null:o}t.withUndefinedAsNull=L;function y(o){return function(){function w(){return new Proxy({},{get:function(A,D){if(A[D])return A[D];throw new Error("Not Implemented: "+o+"->"+String(D))}})}return w}()}t.NotImplementedProxy=y}),te(re[11],ie([1,0]),function(R,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=void 0;function C(d){return d<0?0:d>255?255:d|0}t.toUint8=C;function M(d){return d<0?0:d>4294967295?4294967295:d|0}t.toUint32=M});var fe=this&&this.__read||function(R,t){var C=typeof Symbol=="function"&&R[Symbol.iterator];if(!C)return R;var M=C.call(R),d,n=[],_;try{for(;(t===void 0||t-- >0)&&!(d=M.next()).done;)n.push(d.value)}catch(s){_={error:s}}finally{try{d&&!d.done&&(C=M.return)&&C.call(M)}finally{if(_)throw _.error}}return n},_e=this&&this.__spreadArray||function(R,t){for(var C=0,M=t.length,d=R.length;C<M;C++,d++)R[d]=t[C];return R};te(re[12],ie([1,0,2,21]),function(R,t,C,M){"use strict";var d;Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;var n=/^\w[\w\d+.-]*$/,_=/^\//,s=/^\/\//;function a(y,o){if(!y.scheme&&o)throw new Error('[UriError]: Scheme is missing: {scheme: "", authority: "'+y.authority+'", path: "'+y.path+'", query: "'+y.query+'", fragment: "'+y.fragment+'"}');if(y.scheme&&!n.test(y.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(y.path){if(y.authority){if(!_.test(y.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(s.test(y.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(y,o){return!y&&!o?"file":y}function N(y,o){switch(y){case"https":case"http":case"file":o?o[0]!==b&&(o=b+o):o=b;break}return o}var l="",b="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/,E=function(){function y(o,w,A,D,F,I){I===void 0&&(I=!1),typeof o=="object"?(this.scheme=o.scheme||l,this.authority=o.authority||l,this.path=o.path||l,this.query=o.query||l,this.fragment=o.fragment||l):(this.scheme=m(o,I),this.authority=w||l,this.path=N(this.scheme,A||l),this.query=D||l,this.fragment=F||l,a(this,I))}return y.isUri=function(o){return o instanceof y?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1},Object.defineProperty(y.prototype,"fsPath",{get:function(){return u(this,!1)},enumerable:!1,configurable:!0}),y.prototype.with=function(o){if(!o)return this;var w=o.scheme,A=o.authority,D=o.path,F=o.query,I=o.fragment;return w===void 0?w=this.scheme:w===null&&(w=l),A===void 0?A=this.authority:A===null&&(A=l),D===void 0?D=this.path:D===null&&(D=l),F===void 0?F=this.query:F===null&&(F=l),I===void 0?I=this.fragment:I===null&&(I=l),w===this.scheme&&A===this.authority&&D===this.path&&F===this.query&&I===this.fragment?this:new g(w,A,D,F,I)},y.parse=function(o,w){w===void 0&&(w=!1);var A=S.exec(o);return A?new g(A[2]||l,L(A[4]||l),L(A[5]||l),L(A[7]||l),L(A[9]||l),w):new g(l,l,l,l,l)},y.file=function(o){var w=l;if(C.isWindows&&(o=o.replace(/\\/g,b)),o[0]===b&&o[1]===b){var A=o.indexOf(b,2);A===-1?(w=o.substring(2),o=b):(w=o.substring(2,A),o=o.substring(A)||b)}return new g("file",w,o,l,l)},y.from=function(o){return new g(o.scheme,o.authority,o.path,o.query,o.fragment)},y.joinPath=function(o){for(var w,A,D=[],F=1;F<arguments.length;F++)D[F-1]=arguments[F];if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");var I;return C.isWindows&&o.scheme==="file"?I=y.file((w=M.win32).join.apply(w,_e([u(o,!0)],fe(D)))).path:I=(A=M.posix).join.apply(A,_e([o.path],fe(D))),o.with({path:I})},y.prototype.toString=function(o){return o===void 0&&(o=!1),r(this,o)},y.prototype.toJSON=function(){return this},y.revive=function(o){if(o){if(o instanceof y)return o;var w=new g(o);return w._formatted=o.external,w._fsPath=o._sep===c?o.fsPath:null,w}else return o},y}();t.URI=E;var c=C.isWindows?1:void 0,g=function(y){ye(o,y);function o(){var w=y!==null&&y.apply(this,arguments)||this;return w._formatted=null,w._fsPath=null,w}return Object.defineProperty(o.prototype,"fsPath",{get:function(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath},enumerable:!1,configurable:!0}),o.prototype.toString=function(w){return w===void 0&&(w=!1),w?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)},o.prototype.toJSON=function(){var w={$mid:1};return this._fsPath&&(w.fsPath=this._fsPath,w._sep=c),this._formatted&&(w.external=this._formatted),this.path&&(w.path=this.path),this.scheme&&(w.scheme=this.scheme),this.authority&&(w.authority=this.authority),this.query&&(w.query=this.query),this.fragment&&(w.fragment=this.fragment),w},o}(E),h=(d={},d[58]="%3A",d[47]="%2F",d[63]="%3F",d[35]="%23",d[91]="%5B",d[93]="%5D",d[64]="%40",d[33]="%21",d[36]="%24",d[38]="%26",d[39]="%27",d[40]="%28",d[41]="%29",d[42]="%2A",d[43]="%2B",d[44]="%2C",d[59]="%3B",d[61]="%3D",d[32]="%20",d);function p(y,o){for(var w=void 0,A=-1,D=0;D<y.length;D++){var F=y.charCodeAt(D);if(F>=97&&F<=122||F>=65&&F<=90||F>=48&&F<=57||F===45||F===46||F===95||F===126||o&&F===47)A!==-1&&(w+=encodeURIComponent(y.substring(A,D)),A=-1),w!==void 0&&(w+=y.charAt(D));else{w===void 0&&(w=y.substr(0,D));var I=h[F];I!==void 0?(A!==-1&&(w+=encodeURIComponent(y.substring(A,D)),A=-1),w+=I):A===-1&&(A=D)}}return A!==-1&&(w+=encodeURIComponent(y.substring(A))),w!==void 0?w:y}function i(y){for(var o=void 0,w=0;w<y.length;w++){var A=y.charCodeAt(w);A===35||A===63?(o===void 0&&(o=y.substr(0,w)),o+=h[A]):o!==void 0&&(o+=y[w])}return o!==void 0?o:y}function u(y,o){var w;return y.authority&&y.path.length>1&&y.scheme==="file"?w="//"+y.authority+y.path:y.path.charCodeAt(0)===47&&(y.path.charCodeAt(1)>=65&&y.path.charCodeAt(1)<=90||y.path.charCodeAt(1)>=97&&y.path.charCodeAt(1)<=122)&&y.path.charCodeAt(2)===58?o?w=y.path.substr(1):w=y.path[1].toLowerCase()+y.path.substr(2):w=y.path,C.isWindows&&(w=w.replace(/\//g,"\\")),w}t.uriToFsPath=u;function r(y,o){var w=o?i:p,A="",D=y.scheme,F=y.authority,I=y.path,z=y.query,X=y.fragment;if(D&&(A+=D,A+=":"),(F||D==="file")&&(A+=b,A+=b),F){var H=F.indexOf("@");if(H!==-1){var $=F.substr(0,H);F=F.substr(H+1),H=$.indexOf(":"),H===-1?A+=w($,!1):(A+=w($.substr(0,H),!1),A+=":",A+=w($.substr(H+1),!1)),A+="@"}F=F.toLowerCase(),H=F.indexOf(":"),H===-1?A+=w(F,!1):(A+=w(F.substr(0,H),!1),A+=F.substr(H))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){var e=I.charCodeAt(1);e>=65&&e<=90&&(I="/"+String.fromCharCode(e+32)+":"+I.substr(3))}else if(I.length>=2&&I.charCodeAt(1)===58){var e=I.charCodeAt(0);e>=65&&e<=90&&(I=String.fromCharCode(e+32)+":"+I.substr(2))}A+=w(I,!0)}return z&&(A+="?",A+=w(z,!1)),X&&(A+="#",A+=o?X:p(X,!1)),A}function f(y){try{return decodeURIComponent(y)}catch(o){return y.length>3?y.substr(0,3)+f(y.substr(3)):y}}var v=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function L(y){return y.match(v)?y.replace(v,function(o){return f(o)}):y}}),te(re[35],ie([1,0,4,8,2,10]),function(R,t,C,M,d,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;var _="$initialize",s=!1;function a(S){!d.isWeb||(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(S.message))}t.logOnceWebWorkerWarning=a;var m=function(){function S(E){this._workerId=-1,this._handler=E,this._lastSentReq=0,this._pendingReplies=Object.create(null)}return S.prototype.setWorkerId=function(E){this._workerId=E},S.prototype.sendMessage=function(E,c){var g=this,h=String(++this._lastSentReq);return new Promise(function(p,i){g._pendingReplies[h]={resolve:p,reject:i},g._send({vsWorker:g._workerId,req:h,method:E,args:c})})},S.prototype.handleMessage=function(E){!E||!E.vsWorker||this._workerId!==-1&&E.vsWorker!==this._workerId||this._handleMessage(E)},S.prototype._handleMessage=function(E){var c=this;if(E.seq){var g=E;if(!this._pendingReplies[g.seq]){console.warn("Got reply to unknown seq");return}var h=this._pendingReplies[g.seq];if(delete this._pendingReplies[g.seq],g.err){var p=g.err;g.err.$isError&&(p=new Error,p.name=g.err.name,p.message=g.err.message,p.stack=g.err.stack),h.reject(p);return}h.resolve(g.res);return}var i=E,u=i.req,r=this._handler.handleMessage(i.method,i.args);r.then(function(f){c._send({vsWorker:c._workerId,seq:u,res:f,err:void 0})},function(f){f.detail instanceof Error&&(f.detail=C.transformErrorForSerialization(f.detail)),c._send({vsWorker:c._workerId,seq:u,res:void 0,err:C.transformErrorForSerialization(f)})})},S.prototype._send=function(E){var c=[];if(E.req)for(var g=E,h=0;h<g.args.length;h++)g.args[h]instanceof ArrayBuffer&&c.push(g.args[h]);else{var g=E;g.res instanceof ArrayBuffer&&c.push(g.res)}this._handler.sendMessage(E,c)},S}(),N=function(S){ye(E,S);function E(c,g,h){var p=S.call(this)||this,i=null;p._worker=p._register(c.create("vs/base/common/worker/simpleWorker",function(v){p._protocol.handleMessage(v)},function(v){i&&i(v)})),p._protocol=new m({sendMessage:function(v,L){p._worker.postMessage(v,L)},handleMessage:function(v,L){if(typeof h[v]!="function")return Promise.reject(new Error("Missing method "+v+" on main thread host."));try{return Promise.resolve(h[v].apply(h,L))}catch(y){return Promise.reject(y)}}}),p._protocol.setWorkerId(p._worker.getId());var u=null;typeof self.require!="undefined"&&typeof self.require.getConfig=="function"?u=self.require.getConfig():typeof self.requirejs!="undefined"&&(u=self.requirejs.s.contexts._.config);var r=n.getAllMethodNames(h);p._onModuleLoaded=p._protocol.sendMessage(_,[p._worker.getId(),JSON.parse(JSON.stringify(u)),g,r]);var f=function(v,L){return p._request(v,L)};return p._lazyProxy=new Promise(function(v,L){i=L,p._onModuleLoaded.then(function(y){v(n.createProxyObject(y,f))},function(y){L(y),p._onError("Worker failed to load "+g,y)})}),p}return E.prototype.getProxyObject=function(){return this._lazyProxy},E.prototype._request=function(c,g){var h=this;return new Promise(function(p,i){h._onModuleLoaded.then(function(){h._protocol.sendMessage(c,g).then(p,i)},i)})},E.prototype._onError=function(c,g){console.error(c),console.info(g)},E}(M.Disposable);t.SimpleWorkerClient=N;var l=function(){function S(E,c){var g=this;this._requestHandlerFactory=c,this._requestHandler=null,this._protocol=new m({sendMessage:function(h,p){E(h,p)},handleMessage:function(h,p){return g._handleMessage(h,p)}})}return S.prototype.onmessage=function(E){this._protocol.handleMessage(E)},S.prototype._handleMessage=function(E,c){if(E===_)return this.initialize(c[0],c[1],c[2],c[3]);if(!this._requestHandler||typeof this._requestHandler[E]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+E));try{return Promise.resolve(this._requestHandler[E].apply(this._requestHandler,c))}catch(g){return Promise.reject(g)}},S.prototype.initialize=function(E,c,g,h){var p=this;this._protocol.setWorkerId(E);var i=function(r,f){return p._protocol.sendMessage(r,f)},u=n.createProxyObject(h,i);return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(u),Promise.resolve(n.getAllMethodNames(this._requestHandler))):(c&&(typeof c.baseUrl!="undefined"&&delete c.baseUrl,typeof c.paths!="undefined"&&typeof c.paths.vs!="undefined"&&delete c.paths.vs,typeof c.trustedTypesPolicy!==void 0&&delete c.trustedTypesPolicy,c.catchError=!0,self.require.config(c)),new Promise(function(r,f){self.require([g],function(v){if(p._requestHandler=v.create(u),!p._requestHandler){f(new Error("No RequestHandler!"));return}r(n.getAllMethodNames(p._requestHandler))},f)}))},S}();t.SimpleWorkerServer=l;function b(S){return new l(S,null)}t.create=b}),te(re[23],ie([1,0,11]),function(R,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;var M=function(){function n(_){var s=C.toUint8(_);this._defaultValue=s,this._asciiMap=n._createAsciiMap(s),this._map=new Map}return n._createAsciiMap=function(_){for(var s=new Uint8Array(256),a=0;a<256;a++)s[a]=_;return s},n.prototype.set=function(_,s){var a=C.toUint8(s);_>=0&&_<256?this._asciiMap[_]=a:this._map.set(_,a)},n.prototype.get=function(_){return _>=0&&_<256?this._asciiMap[_]:this._map.get(_)||this._defaultValue},n}();t.CharacterClassifier=M;var d=function(){function n(){this._actual=new M(0)}return n.prototype.add=function(_){this._actual.set(_,1)},n.prototype.has=function(_){return this._actual.get(_)===1},n}();t.CharacterSet=d}),te(re[3],ie([1,0]),function(R,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;var C=function(){function M(d,n){this.lineNumber=d,this.column=n}return M.prototype.with=function(d,n){return d===void 0&&(d=this.lineNumber),n===void 0&&(n=this.column),d===this.lineNumber&&n===this.column?this:new M(d,n)},M.prototype.delta=function(d,n){return d===void 0&&(d=0),n===void 0&&(n=0),this.with(this.lineNumber+d,this.column+n)},M.prototype.equals=function(d){return M.equals(this,d)},M.equals=function(d,n){return!d&&!n?!0:!!d&&!!n&&d.lineNumber===n.lineNumber&&d.column===n.column},M.prototype.isBefore=function(d){return M.isBefore(this,d)},M.isBefore=function(d,n){return d.lineNumber<n.lineNumber?!0:n.lineNumber<d.lineNumber?!1:d.column<n.column},M.prototype.isBeforeOrEqual=function(d){return M.isBeforeOrEqual(this,d)},M.isBeforeOrEqual=function(d,n){return d.lineNumber<n.lineNumber?!0:n.lineNumber<d.lineNumber?!1:d.column<=n.column},M.compare=function(d,n){var _=d.lineNumber|0,s=n.lineNumber|0;if(_===s){var a=d.column|0,m=n.column|0;return a-m}return _-s},M.prototype.clone=function(){return new M(this.lineNumber,this.column)},M.prototype.toString=function(){return"("+this.lineNumber+","+this.column+")"},M.lift=function(d){return new M(d.lineNumber,d.column)},M.isIPosition=function(d){return d&&typeof d.lineNumber=="number"&&typeof d.column=="number"},M}();t.Position=C}),te(re[5],ie([1,0,3]),function(R,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var M=function(){function d(n,_,s,a){n>s||n===s&&_>a?(this.startLineNumber=s,this.startColumn=a,this.endLineNumber=n,this.endColumn=_):(this.startLineNumber=n,this.startColumn=_,this.endLineNumber=s,this.endColumn=a)}return d.prototype.isEmpty=function(){return d.isEmpty(this)},d.isEmpty=function(n){return n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn},d.prototype.containsPosition=function(n){return d.containsPosition(this,n)},d.containsPosition=function(n,_){return!(_.lineNumber<n.startLineNumber||_.lineNumber>n.endLineNumber||_.lineNumber===n.startLineNumber&&_.column<n.startColumn||_.lineNumber===n.endLineNumber&&_.column>n.endColumn)},d.prototype.containsRange=function(n){return d.containsRange(this,n)},d.containsRange=function(n,_){return!(_.startLineNumber<n.startLineNumber||_.endLineNumber<n.startLineNumber||_.startLineNumber>n.endLineNumber||_.endLineNumber>n.endLineNumber||_.startLineNumber===n.startLineNumber&&_.startColumn<n.startColumn||_.endLineNumber===n.endLineNumber&&_.endColumn>n.endColumn)},d.prototype.strictContainsRange=function(n){return d.strictContainsRange(this,n)},d.strictContainsRange=function(n,_){return!(_.startLineNumber<n.startLineNumber||_.endLineNumber<n.startLineNumber||_.startLineNumber>n.endLineNumber||_.endLineNumber>n.endLineNumber||_.startLineNumber===n.startLineNumber&&_.startColumn<=n.startColumn||_.endLineNumber===n.endLineNumber&&_.endColumn>=n.endColumn)},d.prototype.plusRange=function(n){return d.plusRange(this,n)},d.plusRange=function(n,_){var s,a,m,N;return _.startLineNumber<n.startLineNumber?(s=_.startLineNumber,a=_.startColumn):_.startLineNumber===n.startLineNumber?(s=_.startLineNumber,a=Math.min(_.startColumn,n.startColumn)):(s=n.startLineNumber,a=n.startColumn),_.endLineNumber>n.endLineNumber?(m=_.endLineNumber,N=_.endColumn):_.endLineNumber===n.endLineNumber?(m=_.endLineNumber,N=Math.max(_.endColumn,n.endColumn)):(m=n.endLineNumber,N=n.endColumn),new d(s,a,m,N)},d.prototype.intersectRanges=function(n){return d.intersectRanges(this,n)},d.intersectRanges=function(n,_){var s=n.startLineNumber,a=n.startColumn,m=n.endLineNumber,N=n.endColumn,l=_.startLineNumber,b=_.startColumn,S=_.endLineNumber,E=_.endColumn;return s<l?(s=l,a=b):s===l&&(a=Math.max(a,b)),m>S?(m=S,N=E):m===S&&(N=Math.min(N,E)),s>m||s===m&&a>N?null:new d(s,a,m,N)},d.prototype.equalsRange=function(n){return d.equalsRange(this,n)},d.equalsRange=function(n,_){return!!n&&!!_&&n.startLineNumber===_.startLineNumber&&n.startColumn===_.startColumn&&n.endLineNumber===_.endLineNumber&&n.endColumn===_.endColumn},d.prototype.getEndPosition=function(){return d.getEndPosition(this)},d.getEndPosition=function(n){return new C.Position(n.endLineNumber,n.endColumn)},d.prototype.getStartPosition=function(){return d.getStartPosition(this)},d.getStartPosition=function(n){return new C.Position(n.startLineNumber,n.startColumn)},d.prototype.toString=function(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"},d.prototype.setEndPosition=function(n,_){return new d(this.startLineNumber,this.startColumn,n,_)},d.prototype.setStartPosition=function(n,_){return new d(n,_,this.endLineNumber,this.endColumn)},d.prototype.collapseToStart=function(){return d.collapseToStart(this)},d.collapseToStart=function(n){return new d(n.startLineNumber,n.startColumn,n.startLineNumber,n.startColumn)},d.fromPositions=function(n,_){return _===void 0&&(_=n),new d(n.lineNumber,n.column,_.lineNumber,_.column)},d.lift=function(n){return n?new d(n.startLineNumber,n.startColumn,n.endLineNumber,n.endColumn):null},d.isIRange=function(n){return n&&typeof n.startLineNumber=="number"&&typeof n.startColumn=="number"&&typeof n.endLineNumber=="number"&&typeof n.endColumn=="number"},d.areIntersectingOrTouching=function(n,_){return!(n.endLineNumber<_.startLineNumber||n.endLineNumber===_.startLineNumber&&n.endColumn<_.startColumn||_.endLineNumber<n.startLineNumber||_.endLineNumber===n.startLineNumber&&_.endColumn<n.startColumn)},d.areIntersecting=function(n,_){return!(n.endLineNumber<_.startLineNumber||n.endLineNumber===_.startLineNumber&&n.endColumn<=_.startColumn||_.endLineNumber<n.startLineNumber||_.endLineNumber===n.startLineNumber&&_.endColumn<=n.startColumn)},d.compareRangesUsingStarts=function(n,_){if(n&&_){var s=n.startLineNumber|0,a=_.startLineNumber|0;if(s===a){var m=n.startColumn|0,N=_.startColumn|0;if(m===N){var l=n.endLineNumber|0,b=_.endLineNumber|0;if(l===b){var S=n.endColumn|0,E=_.endColumn|0;return S-E}return l-b}return m-N}return s-a}var c=n?1:0,g=_?1:0;return c-g},d.compareRangesUsingEnds=function(n,_){return n.endLineNumber===_.endLineNumber?n.endColumn===_.endColumn?n.startLineNumber===_.startLineNumber?n.startColumn-_.startColumn:n.startLineNumber-_.startLineNumber:n.endColumn-_.endColumn:n.endLineNumber-_.endLineNumber},d.spansMultipleLines=function(n){return n.endLineNumber>n.startLineNumber},d}();t.Range=M}),te(re[26],ie([1,0,3,5]),function(R,t,C,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=void 0;var d=function(n){ye(_,n);function _(s,a,m,N){var l=n.call(this,s,a,m,N)||this;return l.selectionStartLineNumber=s,l.selectionStartColumn=a,l.positionLineNumber=m,l.positionColumn=N,l}return _.prototype.toString=function(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"},_.prototype.equalsSelection=function(s){return _.selectionsEqual(this,s)},_.selectionsEqual=function(s,a){return s.selectionStartLineNumber===a.selectionStartLineNumber&&s.selectionStartColumn===a.selectionStartColumn&&s.positionLineNumber===a.positionLineNumber&&s.positionColumn===a.positionColumn},_.prototype.getDirection=function(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1},_.prototype.setEndPosition=function(s,a){return this.getDirection()===0?new _(this.startLineNumber,this.startColumn,s,a):new _(s,a,this.startLineNumber,this.startColumn)},_.prototype.getPosition=function(){return new C.Position(this.positionLineNumber,this.positionColumn)},_.prototype.setStartPosition=function(s,a){return this.getDirection()===0?new _(s,a,this.endLineNumber,this.endColumn):new _(this.endLineNumber,this.endColumn,s,a)},_.fromPositions=function(s,a){return a===void 0&&(a=s),new _(s.lineNumber,s.column,a.lineNumber,a.column)},_.liftSelection=function(s){return new _(s.selectionStartLineNumber,s.selectionStartColumn,s.positionLineNumber,s.positionColumn)},_.selectionsArrEqual=function(s,a){if(s&&!a||!s&&a)return!1;if(!s&&!a)return!0;if(s.length!==a.length)return!1;for(var m=0,N=s.length;m<N;m++)if(!this.selectionsEqual(s[m],a[m]))return!1;return!0},_.isISelection=function(s){return s&&typeof s.selectionStartLineNumber=="number"&&typeof s.selectionStartColumn=="number"&&typeof s.positionLineNumber=="number"&&typeof s.positionColumn=="number"},_.createWithDirection=function(s,a,m,N,l){return l===0?new _(s,a,m,N):new _(m,N,s,a)},_}(M.Range);t.Selection=d}),te(re[27],ie([1,0]),function(R,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationResult2=t.TokenizationResult=t.Token=void 0;var C=function(){function n(_,s,a){this.offset=_|0,this.type=s,this.language=a}return n.prototype.toString=function(){return"("+this.offset+", "+this.type+")"},n}();t.Token=C;var M=function(){function n(_,s){this.tokens=_,this.endState=s}return n}();t.TokenizationResult=M;var d=function(){function n(_,s){this.tokens=_,this.endState=s}return n}();t.TokenizationResult2=d}),te(re[28],ie([1,0,9,6]),function(R,t,C,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=void 0;var d=3;function n(c,g,h,p){var i=new C.LcsDiff(c,g,h);return i.ComputeDiff(p)}var _=function(){function c(g){for(var h=[],p=[],i=0,u=g.length;i<u;i++)h[i]=b(g[i],1),p[i]=S(g[i],1);this.lines=g,this._startColumns=h,this._endColumns=p}return c.prototype.getElements=function(){for(var g=[],h=0,p=this.lines.length;h<p;h++)g[h]=this.lines[h].substring(this._startColumns[h]-1,this._endColumns[h]-1);return g},c.prototype.getStartLineNumber=function(g){return g+1},c.prototype.getEndLineNumber=function(g){return g+1},c.prototype.createCharSequence=function(g,h,p){for(var i=[],u=[],r=[],f=0,v=h;v<=p;v++)for(var L=this.lines[v],y=g?this._startColumns[v]:1,o=g?this._endColumns[v]:L.length+1,w=y;w<o;w++)i[f]=L.charCodeAt(w-1),u[f]=v+1,r[f]=w,f++;return new s(i,u,r)},c}(),s=function(){function c(g,h,p){this._charCodes=g,this._lineNumbers=h,this._columns=p}return c.prototype.getElements=function(){return this._charCodes},c.prototype.getStartLineNumber=function(g){return this._lineNumbers[g]},c.prototype.getStartColumn=function(g){return this._columns[g]},c.prototype.getEndLineNumber=function(g){return this._lineNumbers[g]},c.prototype.getEndColumn=function(g){return this._columns[g]+1},c}(),a=function(){function c(g,h,p,i,u,r,f,v){this.originalStartLineNumber=g,this.originalStartColumn=h,this.originalEndLineNumber=p,this.originalEndColumn=i,this.modifiedStartLineNumber=u,this.modifiedStartColumn=r,this.modifiedEndLineNumber=f,this.modifiedEndColumn=v}return c.createFromDiffChange=function(g,h,p){var i,u,r,f,v,L,y,o;return g.originalLength===0?(i=0,u=0,r=0,f=0):(i=h.getStartLineNumber(g.originalStart),u=h.getStartColumn(g.originalStart),r=h.getEndLineNumber(g.originalStart+g.originalLength-1),f=h.getEndColumn(g.originalStart+g.originalLength-1)),g.modifiedLength===0?(v=0,L=0,y=0,o=0):(v=p.getStartLineNumber(g.modifiedStart),L=p.getStartColumn(g.modifiedStart),y=p.getEndLineNumber(g.modifiedStart+g.modifiedLength-1),o=p.getEndColumn(g.modifiedStart+g.modifiedLength-1)),new c(i,u,r,f,v,L,y,o)},c}();function m(c){if(c.length<=1)return c;for(var g=[c[0]],h=g[0],p=1,i=c.length;p<i;p++){var u=c[p],r=u.originalStart-(h.originalStart+h.originalLength),f=u.modifiedStart-(h.modifiedStart+h.modifiedLength),v=Math.min(r,f);v<d?(h.originalLength=u.originalStart+u.originalLength-h.originalStart,h.modifiedLength=u.modifiedStart+u.modifiedLength-h.modifiedStart):(g.push(u),h=u)}return g}var N=function(){function c(g,h,p,i,u){this.originalStartLineNumber=g,this.originalEndLineNumber=h,this.modifiedStartLineNumber=p,this.modifiedEndLineNumber=i,this.charChanges=u}return c.createFromDiffResult=function(g,h,p,i,u,r,f){var v,L,y,o,w=void 0;if(h.originalLength===0?(v=p.getStartLineNumber(h.originalStart)-1,L=0):(v=p.getStartLineNumber(h.originalStart),L=p.getEndLineNumber(h.originalStart+h.originalLength-1)),h.modifiedLength===0?(y=i.getStartLineNumber(h.modifiedStart)-1,o=0):(y=i.getStartLineNumber(h.modifiedStart),o=i.getEndLineNumber(h.modifiedStart+h.modifiedLength-1)),r&&h.originalLength>0&&h.originalLength<20&&h.modifiedLength>0&&h.modifiedLength<20&&u()){var A=p.createCharSequence(g,h.originalStart,h.originalStart+h.originalLength-1),D=i.createCharSequence(g,h.modifiedStart,h.modifiedStart+h.modifiedLength-1),F=n(A,D,u,!0).changes;f&&(F=m(F)),w=[];for(var I=0,z=F.length;I<z;I++)w.push(a.createFromDiffChange(F[I],A,D))}return new c(v,L,y,o,w)},c}(),l=function(){function c(g,h,p){this.shouldComputeCharChanges=p.shouldComputeCharChanges,this.shouldPostProcessCharChanges=p.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=p.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=p.shouldMakePrettyDiff,this.originalLines=g,this.modifiedLines=h,this.original=new _(g),this.modified=new _(h),this.continueLineDiff=E(p.maxComputationTime),this.continueCharDiff=E(p.maxComputationTime===0?0:Math.min(p.maxComputationTime,5e3))}return c.prototype.computeDiff=function(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};var g=n(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),h=g.changes,p=g.quitEarly;if(this.shouldIgnoreTrimWhitespace){for(var i=[],u=0,r=h.length;u<r;u++)i.push(N.createFromDiffResult(this.shouldIgnoreTrimWhitespace,h[u],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:p,changes:i}}for(var f=[],v=0,L=0,u=-1,y=h.length;u<y;u++){for(var o=u+1<y?h[u+1]:null,w=o?o.originalStart:this.originalLines.length,A=o?o.modifiedStart:this.modifiedLines.length;v<w&&L<A;){var D=this.originalLines[v],F=this.modifiedLines[L];if(D!==F){{for(var I=b(D,1),z=b(F,1);I>1&&z>1;){var X=D.charCodeAt(I-2),H=F.charCodeAt(z-2);if(X!==H)break;I--,z--}(I>1||z>1)&&this._pushTrimWhitespaceCharChange(f,v+1,1,I,L+1,1,z)}{for(var $=S(D,1),e=S(F,1),W=D.length+1,j=F.length+1;$<W&&e<j;){var X=D.charCodeAt($-1),H=D.charCodeAt(e-1);if(X!==H)break;$++,e++}($<W||e<j)&&this._pushTrimWhitespaceCharChange(f,v+1,$,W,L+1,e,j)}}v++,L++}o&&(f.push(N.createFromDiffResult(this.shouldIgnoreTrimWhitespace,o,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),v+=o.originalLength,L+=o.modifiedLength)}return{quitEarly:p,changes:f}},c.prototype._pushTrimWhitespaceCharChange=function(g,h,p,i,u,r,f){if(!this._mergeTrimWhitespaceCharChange(g,h,p,i,u,r,f)){var v=void 0;this.shouldComputeCharChanges&&(v=[new a(h,p,h,i,u,r,u,f)]),g.push(new N(h,h,u,u,v))}},c.prototype._mergeTrimWhitespaceCharChange=function(g,h,p,i,u,r,f){var v=g.length;if(v===0)return!1;var L=g[v-1];return L.originalEndLineNumber===0||L.modifiedEndLineNumber===0?!1:L.originalEndLineNumber+1===h&&L.modifiedEndLineNumber+1===u?(L.originalEndLineNumber=h,L.modifiedEndLineNumber=u,this.shouldComputeCharChanges&&L.charChanges&&L.charChanges.push(new a(h,p,h,i,u,r,u,f)),!0):!1},c}();t.DiffComputer=l;function b(c,g){var h=M.firstNonWhitespaceIndex(c);return h===-1?g:h+1}function S(c,g){var h=M.lastNonWhitespaceIndex(c);return h===-1?g:h+2}function E(c){if(c===0)return function(){return!0};var g=Date.now();return function(){return Date.now()-g<c}}});var ue=this&&this.__values||function(R){var t=typeof Symbol=="function"&&Symbol.iterator,C=t&&R[t],M=0;if(C)return C.call(R);if(R&&typeof R.length=="number")return{next:function(){return R&&M>=R.length&&(R=void 0),{value:R&&R[M++],done:!R}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")};te(re[29],ie([1,0]),function(R,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function C(s){var a,m;s===void 0&&(s="");var N="(-?\\d*\\.\\d\\w*)|([^";try{for(var l=ue(t.USUAL_WORD_SEPARATORS),b=l.next();!b.done;b=l.next()){var S=b.value;s.indexOf(S)>=0||(N+="\\"+S)}}catch(E){a={error:E}}finally{try{b&&!b.done&&(m=l.return)&&m.call(l)}finally{if(a)throw a.error}}return N+="\\s]+)",new RegExp(N,"g")}t.DEFAULT_WORD_REGEXP=C();function M(s){var a=t.DEFAULT_WORD_REGEXP;if(s&&s instanceof RegExp)if(s.global)a=s;else{var m="g";s.ignoreCase&&(m+="i"),s.multiline&&(m+="m"),s.unicode&&(m+="u"),a=new RegExp(s.source,m)}return a.lastIndex=0,a}t.ensureValidWordDefinition=M;var d={maxLen:1e3,windowSize:15,timeBudget:150};function n(s,a,m,N,l){if(l===void 0&&(l=d),m.length>l.maxLen){var b=s-l.maxLen/2;return b<0?b=0:N+=b,m=m.substring(b,s+l.maxLen/2),n(s,a,m,N,l)}for(var S=Date.now(),E=s-1-N,c=-1,g=null,h=1;!(Date.now()-S>=l.timeBudget);h++){var p=E-l.windowSize*h;a.lastIndex=Math.max(0,p);var i=_(a,m,E,c);if(!i&&g||(g=i,p<=0))break;c=p}if(g){var u={word:g[0],startColumn:N+1+g.index,endColumn:N+1+g.index+g[0].length};return a.lastIndex=0,u}return null}t.getWordAtText=n;function _(s,a,m,N){for(var l;l=s.exec(a);){var b=l.index||0;if(b<=m&&s.lastIndex>=m)return l;if(N>0&&b>N)return null}return null}});var fe=this&&this.__read||function(R,t){var C=typeof Symbol=="function"&&R[Symbol.iterator];if(!C)return R;var M=C.call(R),d,n=[],_;try{for(;(t===void 0||t-- >0)&&!(d=M.next()).done;)n.push(d.value)}catch(s){_={error:s}}finally{try{d&&!d.done&&(C=M.return)&&C.call(M)}finally{if(_)throw _.error}}return n};te(re[30],ie([1,0,23]),function(R,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.Uint8Matrix=void 0;var M=function(){function l(b,S,E){for(var c=new Uint8Array(b*S),g=0,h=b*S;g<h;g++)c[g]=E;this._data=c,this.rows=b,this.cols=S}return l.prototype.get=function(b,S){return this._data[b*this.cols+S]},l.prototype.set=function(b,S,E){this._data[b*this.cols+S]=E},l}();t.Uint8Matrix=M;var d=function(){function l(b){for(var S=0,E=0,c=0,g=b.length;c<g;c++){var h=fe(b[c],3),p=h[0],i=h[1],u=h[2];i>S&&(S=i),p>E&&(E=p),u>E&&(E=u)}S++,E++;for(var r=new M(E,S,0),c=0,g=b.length;c<g;c++){var f=fe(b[c],3),p=f[0],i=f[1],u=f[2];r.set(p,i,u)}this._states=r,this._maxCharCode=S}return l.prototype.nextState=function(b,S){return S<0||S>=this._maxCharCode?0:this._states.get(b,S)},l}();t.StateMachine=d;var n=null;function _(){return n===null&&(n=new d([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),n}var s=null;function a(){if(s===null){s=new C.CharacterClassifier(0);for(var l=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`,b=0;b<l.length;b++)s.set(l.charCodeAt(b),1);for(var S=".,;",b=0;b<S.length;b++)s.set(S.charCodeAt(b),2)}return s}var m=function(){function l(){}return l._createLink=function(b,S,E,c,g){var h=g-1;do{var p=S.charCodeAt(h),i=b.get(p);if(i!==2)break;h--}while(h>c);if(c>0){var u=S.charCodeAt(c-1),r=S.charCodeAt(h);(u===40&&r===41||u===91&&r===93||u===123&&r===125)&&h--}return{range:{startLineNumber:E,startColumn:c+1,endLineNumber:E,endColumn:h+2},url:S.substring(c,h+1)}},l.computeLinks=function(b,S){S===void 0&&(S=_());for(var E=a(),c=[],g=1,h=b.getLineCount();g<=h;g++){for(var p=b.getLineContent(g),i=p.length,u=0,r=0,f=0,v=1,L=!1,y=!1,o=!1,w=!1;u<i;){var A=!1,D=p.charCodeAt(u);if(v===13){var F=void 0;switch(D){case 40:L=!0,F=0;break;case 41:F=L?0:1;break;case 91:o=!0,y=!0,F=0;break;case 93:o=!1,F=y?0:1;break;case 123:w=!0,F=0;break;case 125:F=w?0:1;break;case 39:F=f===34||f===96?0:1;break;case 34:F=f===39||f===96?0:1;break;case 96:F=f===39||f===34?0:1;break;case 42:F=f===42?1:0;break;case 124:F=f===124?1:0;break;case 32:F=o?0:1;break;default:F=E.get(D)}F===1&&(c.push(l._createLink(E,p,g,r,u)),A=!0)}else if(v===12){var F=void 0;D===91?(y=!0,F=0):F=E.get(D),F===1?A=!0:v=13}else v=S.nextState(v,D),v===0&&(A=!0);A&&(v=1,L=!1,y=!1,w=!1,r=u+1,f=D),u++}v===13&&c.push(l._createLink(E,p,g,r,i))}return c},l}();t.LinkComputer=m;function N(l){return!l||typeof l.getLineCount!="function"||typeof l.getLineContent!="function"?[]:m.computeLinks(l)}t.computeLinks=N}),te(re[31],ie([1,0]),function(R,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;var C=function(){function M(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}return M.prototype.navigateValueSet=function(d,n,_,s,a){if(d&&n){var m=this.doNavigateValueSet(n,a);if(m)return{range:d,value:m}}if(_&&s){var m=this.doNavigateValueSet(s,a);if(m)return{range:_,value:m}}return null},M.prototype.doNavigateValueSet=function(d,n){var _=this.numberReplace(d,n);return _!==null?_:this.textReplace(d,n)},M.prototype.numberReplace=function(d,n){var _=Math.pow(10,d.length-(d.lastIndexOf(".")+1)),s=Number(d),a=parseFloat(d);return!isNaN(s)&&!isNaN(a)&&s===a?s===0&&!n?null:(s=Math.floor(s*_),s+=n?_:-_,String(s/_)):null},M.prototype.textReplace=function(d,n){return this.valueSetsReplace(this._defaultValueSet,d,n)},M.prototype.valueSetsReplace=function(d,n,_){for(var s=null,a=0,m=d.length;s===null&&a<m;a++)s=this.valueSetReplace(d[a],n,_);return s},M.prototype.valueSetReplace=function(d,n,_){var s=d.indexOf(n);return s>=0?(s+=_?1:-1,s<0?s=d.length-1:s%=d.length,d[s]):null},M.INSTANCE=new M,M}();t.BasicInplaceReplace=C}),te(re[32],ie([1,0]),function(R,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineHintKind=t.IndentAction=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.AccessibilitySupport=void 0;var C;(function(e){e[e.Unknown=0]="Unknown",e[e.Disabled=1]="Disabled",e[e.Enabled=2]="Enabled"})(C=t.AccessibilitySupport||(t.AccessibilitySupport={}));var M;(function(e){e[e.KeepWhitespace=1]="KeepWhitespace",e[e.InsertAsSnippet=4]="InsertAsSnippet"})(M=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var d;(function(e){e[e.Method=0]="Method",e[e.Function=1]="Function",e[e.Constructor=2]="Constructor",e[e.Field=3]="Field",e[e.Variable=4]="Variable",e[e.Class=5]="Class",e[e.Struct=6]="Struct",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Event=10]="Event",e[e.Operator=11]="Operator",e[e.Unit=12]="Unit",e[e.Value=13]="Value",e[e.Constant=14]="Constant",e[e.Enum=15]="Enum",e[e.EnumMember=16]="EnumMember",e[e.Keyword=17]="Keyword",e[e.Text=18]="Text",e[e.Color=19]="Color",e[e.File=20]="File",e[e.Reference=21]="Reference",e[e.Customcolor=22]="Customcolor",e[e.Folder=23]="Folder",e[e.TypeParameter=24]="TypeParameter",e[e.User=25]="User",e[e.Issue=26]="Issue",e[e.Snippet=27]="Snippet"})(d=t.CompletionItemKind||(t.CompletionItemKind={}));var n;(function(e){e[e.Deprecated=1]="Deprecated"})(n=t.CompletionItemTag||(t.CompletionItemTag={}));var _;(function(e){e[e.Invoke=0]="Invoke",e[e.TriggerCharacter=1]="TriggerCharacter",e[e.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var s;(function(e){e[e.EXACT=0]="EXACT",e[e.ABOVE=1]="ABOVE",e[e.BELOW=2]="BELOW"})(s=t.ContentWidgetPositionPreference||(t.ContentWidgetPositionPreference={}));var a;(function(e){e[e.NotSet=0]="NotSet",e[e.ContentFlush=1]="ContentFlush",e[e.RecoverFromMarkers=2]="RecoverFromMarkers",e[e.Explicit=3]="Explicit",e[e.Paste=4]="Paste",e[e.Undo=5]="Undo",e[e.Redo=6]="Redo"})(a=t.CursorChangeReason||(t.CursorChangeReason={}));var m;(function(e){e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(m=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var N;(function(e){e[e.Text=0]="Text",e[e.Read=1]="Read",e[e.Write=2]="Write"})(N=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));var l;(function(e){e[e.None=0]="None",e[e.Keep=1]="Keep",e[e.Brackets=2]="Brackets",e[e.Advanced=3]="Advanced",e[e.Full=4]="Full"})(l=t.EditorAutoIndentStrategy||(t.EditorAutoIndentStrategy={}));var b;(function(e){e[e.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",e[e.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",e[e.accessibilitySupport=2]="accessibilitySupport",e[e.accessibilityPageSize=3]="accessibilityPageSize",e[e.ariaLabel=4]="ariaLabel",e[e.autoClosingBrackets=5]="autoClosingBrackets",e[e.autoClosingOvertype=6]="autoClosingOvertype",e[e.autoClosingQuotes=7]="autoClosingQuotes",e[e.autoIndent=8]="autoIndent",e[e.automaticLayout=9]="automaticLayout",e[e.autoSurround=10]="autoSurround",e[e.codeLens=11]="codeLens",e[e.codeLensFontFamily=12]="codeLensFontFamily",e[e.codeLensFontSize=13]="codeLensFontSize",e[e.colorDecorators=14]="colorDecorators",e[e.columnSelection=15]="columnSelection",e[e.comments=16]="comments",e[e.contextmenu=17]="contextmenu",e[e.copyWithSyntaxHighlighting=18]="copyWithSyntaxHighlighting",e[e.cursorBlinking=19]="cursorBlinking",e[e.cursorSmoothCaretAnimation=20]="cursorSmoothCaretAnimation",e[e.cursorStyle=21]="cursorStyle",e[e.cursorSurroundingLines=22]="cursorSurroundingLines",e[e.cursorSurroundingLinesStyle=23]="cursorSurroundingLinesStyle",e[e.cursorWidth=24]="cursorWidth",e[e.disableLayerHinting=25]="disableLayerHinting",e[e.disableMonospaceOptimizations=26]="disableMonospaceOptimizations",e[e.dragAndDrop=27]="dragAndDrop",e[e.emptySelectionClipboard=28]="emptySelectionClipboard",e[e.extraEditorClassName=29]="extraEditorClassName",e[e.fastScrollSensitivity=30]="fastScrollSensitivity",e[e.find=31]="find",e[e.fixedOverflowWidgets=32]="fixedOverflowWidgets",e[e.folding=33]="folding",e[e.foldingStrategy=34]="foldingStrategy",e[e.foldingHighlight=35]="foldingHighlight",e[e.unfoldOnClickAfterEndOfLine=36]="unfoldOnClickAfterEndOfLine",e[e.fontFamily=37]="fontFamily",e[e.fontInfo=38]="fontInfo",e[e.fontLigatures=39]="fontLigatures",e[e.fontSize=40]="fontSize",e[e.fontWeight=41]="fontWeight",e[e.formatOnPaste=42]="formatOnPaste",e[e.formatOnType=43]="formatOnType",e[e.glyphMargin=44]="glyphMargin",e[e.gotoLocation=45]="gotoLocation",e[e.hideCursorInOverviewRuler=46]="hideCursorInOverviewRuler",e[e.highlightActiveIndentGuide=47]="highlightActiveIndentGuide",e[e.hover=48]="hover",e[e.inDiffEditor=49]="inDiffEditor",e[e.letterSpacing=50]="letterSpacing",e[e.lightbulb=51]="lightbulb",e[e.lineDecorationsWidth=52]="lineDecorationsWidth",e[e.lineHeight=53]="lineHeight",e[e.lineNumbers=54]="lineNumbers",e[e.lineNumbersMinChars=55]="lineNumbersMinChars",e[e.linkedEditing=56]="linkedEditing",e[e.links=57]="links",e[e.matchBrackets=58]="matchBrackets",e[e.minimap=59]="minimap",e[e.mouseStyle=60]="mouseStyle",e[e.mouseWheelScrollSensitivity=61]="mouseWheelScrollSensitivity",e[e.mouseWheelZoom=62]="mouseWheelZoom",e[e.multiCursorMergeOverlapping=63]="multiCursorMergeOverlapping",e[e.multiCursorModifier=64]="multiCursorModifier",e[e.multiCursorPaste=65]="multiCursorPaste",e[e.occurrencesHighlight=66]="occurrencesHighlight",e[e.overviewRulerBorder=67]="overviewRulerBorder",e[e.overviewRulerLanes=68]="overviewRulerLanes",e[e.padding=69]="padding",e[e.parameterHints=70]="parameterHints",e[e.peekWidgetDefaultFocus=71]="peekWidgetDefaultFocus",e[e.definitionLinkOpensInPeek=72]="definitionLinkOpensInPeek",e[e.quickSuggestions=73]="quickSuggestions",e[e.quickSuggestionsDelay=74]="quickSuggestionsDelay",e[e.readOnly=75]="readOnly",e[e.renameOnType=76]="renameOnType",e[e.renderControlCharacters=77]="renderControlCharacters",e[e.renderIndentGuides=78]="renderIndentGuides",e[e.renderFinalNewline=79]="renderFinalNewline",e[e.renderLineHighlight=80]="renderLineHighlight",e[e.renderLineHighlightOnlyWhenFocus=81]="renderLineHighlightOnlyWhenFocus",e[e.renderValidationDecorations=82]="renderValidationDecorations",e[e.renderWhitespace=83]="renderWhitespace",e[e.revealHorizontalRightPadding=84]="revealHorizontalRightPadding",e[e.roundedSelection=85]="roundedSelection",e[e.rulers=86]="rulers",e[e.scrollbar=87]="scrollbar",e[e.scrollBeyondLastColumn=88]="scrollBeyondLastColumn",e[e.scrollBeyondLastLine=89]="scrollBeyondLastLine",e[e.scrollPredominantAxis=90]="scrollPredominantAxis",e[e.selectionClipboard=91]="selectionClipboard",e[e.selectionHighlight=92]="selectionHighlight",e[e.selectOnLineNumbers=93]="selectOnLineNumbers",e[e.showFoldingControls=94]="showFoldingControls",e[e.showUnused=95]="showUnused",e[e.snippetSuggestions=96]="snippetSuggestions",e[e.smartSelect=97]="smartSelect",e[e.smoothScrolling=98]="smoothScrolling",e[e.stickyTabStops=99]="stickyTabStops",e[e.stopRenderingLineAfter=100]="stopRenderingLineAfter",e[e.suggest=101]="suggest",e[e.suggestFontSize=102]="suggestFontSize",e[e.suggestLineHeight=103]="suggestLineHeight",e[e.suggestOnTriggerCharacters=104]="suggestOnTriggerCharacters",e[e.suggestSelection=105]="suggestSelection",e[e.tabCompletion=106]="tabCompletion",e[e.tabIndex=107]="tabIndex",e[e.unusualLineTerminators=108]="unusualLineTerminators",e[e.useTabStops=109]="useTabStops",e[e.wordSeparators=110]="wordSeparators",e[e.wordWrap=111]="wordWrap",e[e.wordWrapBreakAfterCharacters=112]="wordWrapBreakAfterCharacters",e[e.wordWrapBreakBeforeCharacters=113]="wordWrapBreakBeforeCharacters",e[e.wordWrapColumn=114]="wordWrapColumn",e[e.wordWrapOverride1=115]="wordWrapOverride1",e[e.wordWrapOverride2=116]="wordWrapOverride2",e[e.wrappingIndent=117]="wrappingIndent",e[e.wrappingStrategy=118]="wrappingStrategy",e[e.showDeprecated=119]="showDeprecated",e[e.inlineHints=120]="inlineHints",e[e.editorClassName=121]="editorClassName",e[e.pixelRatio=122]="pixelRatio",e[e.tabFocusMode=123]="tabFocusMode",e[e.layoutInfo=124]="layoutInfo",e[e.wrappingInfo=125]="wrappingInfo"})(b=t.EditorOption||(t.EditorOption={}));var S;(function(e){e[e.TextDefined=0]="TextDefined",e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(S=t.EndOfLinePreference||(t.EndOfLinePreference={}));var E;(function(e){e[e.LF=0]="LF",e[e.CRLF=1]="CRLF"})(E=t.EndOfLineSequence||(t.EndOfLineSequence={}));var c;(function(e){e[e.None=0]="None",e[e.Indent=1]="Indent",e[e.IndentOutdent=2]="IndentOutdent",e[e.Outdent=3]="Outdent"})(c=t.IndentAction||(t.IndentAction={}));var g;(function(e){e[e.Other=0]="Other",e[e.Type=1]="Type",e[e.Parameter=2]="Parameter"})(g=t.InlineHintKind||(t.InlineHintKind={}));var h;(function(e){e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.KEY_0=21]="KEY_0",e[e.KEY_1=22]="KEY_1",e[e.KEY_2=23]="KEY_2",e[e.KEY_3=24]="KEY_3",e[e.KEY_4=25]="KEY_4",e[e.KEY_5=26]="KEY_5",e[e.KEY_6=27]="KEY_6",e[e.KEY_7=28]="KEY_7",e[e.KEY_8=29]="KEY_8",e[e.KEY_9=30]="KEY_9",e[e.KEY_A=31]="KEY_A",e[e.KEY_B=32]="KEY_B",e[e.KEY_C=33]="KEY_C",e[e.KEY_D=34]="KEY_D",e[e.KEY_E=35]="KEY_E",e[e.KEY_F=36]="KEY_F",e[e.KEY_G=37]="KEY_G",e[e.KEY_H=38]="KEY_H",e[e.KEY_I=39]="KEY_I",e[e.KEY_J=40]="KEY_J",e[e.KEY_K=41]="KEY_K",e[e.KEY_L=42]="KEY_L",e[e.KEY_M=43]="KEY_M",e[e.KEY_N=44]="KEY_N",e[e.KEY_O=45]="KEY_O",e[e.KEY_P=46]="KEY_P",e[e.KEY_Q=47]="KEY_Q",e[e.KEY_R=48]="KEY_R",e[e.KEY_S=49]="KEY_S",e[e.KEY_T=50]="KEY_T",e[e.KEY_U=51]="KEY_U",e[e.KEY_V=52]="KEY_V",e[e.KEY_W=53]="KEY_W",e[e.KEY_X=54]="KEY_X",e[e.KEY_Y=55]="KEY_Y",e[e.KEY_Z=56]="KEY_Z",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.US_SEMICOLON=80]="US_SEMICOLON",e[e.US_EQUAL=81]="US_EQUAL",e[e.US_COMMA=82]="US_COMMA",e[e.US_MINUS=83]="US_MINUS",e[e.US_DOT=84]="US_DOT",e[e.US_SLASH=85]="US_SLASH",e[e.US_BACKTICK=86]="US_BACKTICK",e[e.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",e[e.US_BACKSLASH=88]="US_BACKSLASH",e[e.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",e[e.US_QUOTE=90]="US_QUOTE",e[e.OEM_8=91]="OEM_8",e[e.OEM_102=92]="OEM_102",e[e.NUMPAD_0=93]="NUMPAD_0",e[e.NUMPAD_1=94]="NUMPAD_1",e[e.NUMPAD_2=95]="NUMPAD_2",e[e.NUMPAD_3=96]="NUMPAD_3",e[e.NUMPAD_4=97]="NUMPAD_4",e[e.NUMPAD_5=98]="NUMPAD_5",e[e.NUMPAD_6=99]="NUMPAD_6",e[e.NUMPAD_7=100]="NUMPAD_7",e[e.NUMPAD_8=101]="NUMPAD_8",e[e.NUMPAD_9=102]="NUMPAD_9",e[e.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",e[e.NUMPAD_ADD=104]="NUMPAD_ADD",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",e[e.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",e[e.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.MAX_VALUE=112]="MAX_VALUE"})(h=t.KeyCode||(t.KeyCode={}));var p;(function(e){e[e.Hint=1]="Hint",e[e.Info=2]="Info",e[e.Warning=4]="Warning",e[e.Error=8]="Error"})(p=t.MarkerSeverity||(t.MarkerSeverity={}));var i;(function(e){e[e.Unnecessary=1]="Unnecessary",e[e.Deprecated=2]="Deprecated"})(i=t.MarkerTag||(t.MarkerTag={}));var u;(function(e){e[e.Inline=1]="Inline",e[e.Gutter=2]="Gutter"})(u=t.MinimapPosition||(t.MinimapPosition={}));var r;(function(e){e[e.UNKNOWN=0]="UNKNOWN",e[e.TEXTAREA=1]="TEXTAREA",e[e.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",e[e.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",e[e.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",e[e.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",e[e.CONTENT_TEXT=6]="CONTENT_TEXT",e[e.CONTENT_EMPTY=7]="CONTENT_EMPTY",e[e.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",e[e.CONTENT_WIDGET=9]="CONTENT_WIDGET",e[e.OVERVIEW_RULER=10]="OVERVIEW_RULER",e[e.SCROLLBAR=11]="SCROLLBAR",e[e.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",e[e.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(r=t.MouseTargetType||(t.MouseTargetType={}));var f;(function(e){e[e.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",e[e.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",e[e.TOP_CENTER=2]="TOP_CENTER"})(f=t.OverlayWidgetPositionPreference||(t.OverlayWidgetPositionPreference={}));var v;(function(e){e[e.Left=1]="Left",e[e.Center=2]="Center",e[e.Right=4]="Right",e[e.Full=7]="Full"})(v=t.OverviewRulerLane||(t.OverviewRulerLane={}));var L;(function(e){e[e.Off=0]="Off",e[e.On=1]="On",e[e.Relative=2]="Relative",e[e.Interval=3]="Interval",e[e.Custom=4]="Custom"})(L=t.RenderLineNumbersType||(t.RenderLineNumbersType={}));var y;(function(e){e[e.None=0]="None",e[e.Text=1]="Text",e[e.Blocks=2]="Blocks"})(y=t.RenderMinimap||(t.RenderMinimap={}));var o;(function(e){e[e.Smooth=0]="Smooth",e[e.Immediate=1]="Immediate"})(o=t.ScrollType||(t.ScrollType={}));var w;(function(e){e[e.Auto=1]="Auto",e[e.Hidden=2]="Hidden",e[e.Visible=3]="Visible"})(w=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));var A;(function(e){e[e.LTR=0]="LTR",e[e.RTL=1]="RTL"})(A=t.SelectionDirection||(t.SelectionDirection={}));var D;(function(e){e[e.Invoke=1]="Invoke",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.ContentChange=3]="ContentChange"})(D=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var F;(function(e){e[e.File=0]="File",e[e.Module=1]="Module",e[e.Namespace=2]="Namespace",e[e.Package=3]="Package",e[e.Class=4]="Class",e[e.Method=5]="Method",e[e.Property=6]="Property",e[e.Field=7]="Field",e[e.Constructor=8]="Constructor",e[e.Enum=9]="Enum",e[e.Interface=10]="Interface",e[e.Function=11]="Function",e[e.Variable=12]="Variable",e[e.Constant=13]="Constant",e[e.String=14]="String",e[e.Number=15]="Number",e[e.Boolean=16]="Boolean",e[e.Array=17]="Array",e[e.Object=18]="Object",e[e.Key=19]="Key",e[e.Null=20]="Null",e[e.EnumMember=21]="EnumMember",e[e.Struct=22]="Struct",e[e.Event=23]="Event",e[e.Operator=24]="Operator",e[e.TypeParameter=25]="TypeParameter"})(F=t.SymbolKind||(t.SymbolKind={}));var I;(function(e){e[e.Deprecated=1]="Deprecated"})(I=t.SymbolTag||(t.SymbolTag={}));var z;(function(e){e[e.Hidden=0]="Hidden",e[e.Blink=1]="Blink",e[e.Smooth=2]="Smooth",e[e.Phase=3]="Phase",e[e.Expand=4]="Expand",e[e.Solid=5]="Solid"})(z=t.TextEditorCursorBlinkingStyle||(t.TextEditorCursorBlinkingStyle={}));var X;(function(e){e[e.Line=1]="Line",e[e.Block=2]="Block",e[e.Underline=3]="Underline",e[e.LineThin=4]="LineThin",e[e.BlockOutline=5]="BlockOutline",e[e.UnderlineThin=6]="UnderlineThin"})(X=t.TextEditorCursorStyle||(t.TextEditorCursorStyle={}));var H;(function(e){e[e.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",e[e.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",e[e.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",e[e.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(H=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));var $;(function(e){e[e.None=0]="None",e[e.Same=1]="Same",e[e.Indent=2]="Indent",e[e.DeepIndent=3]="DeepIndent"})($=t.WrappingIndent||(t.WrappingIndent={}))}),te(re[33],ie([1,0,15,14,25,12,3,5,26,27,32]),function(R,t,C,M,d,n,_,s,a,m,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;var l=function(){function S(){}return S.chord=function(E,c){return d.KeyChord(E,c)},S.CtrlCmd=2048,S.Shift=1024,S.Alt=512,S.WinCtrl=256,S}();t.KeyMod=l;function b(){return{editor:void 0,languages:void 0,CancellationTokenSource:C.CancellationTokenSource,Emitter:M.Emitter,KeyCode:N.KeyCode,KeyMod:l,Position:_.Position,Range:s.Range,Selection:a.Selection,SelectionDirection:N.SelectionDirection,MarkerSeverity:N.MarkerSeverity,MarkerTag:N.MarkerTag,Uri:n.URI,Token:m.Token}}t.createMonacoBaseAPI=b}),te(re[34],ie([1,0,11]),function(R,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumComputer=t.PrefixSumIndexOfResult=void 0;var M=function(){function n(_,s){this.index=_,this.remainder=s}return n}();t.PrefixSumIndexOfResult=M;var d=function(){function n(_){this.values=_,this.prefixSum=new Uint32Array(_.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}return n.prototype.getCount=function(){return this.values.length},n.prototype.insertValues=function(_,s){_=C.toUint32(_);var a=this.values,m=this.prefixSum,N=s.length;return N===0?!1:(this.values=new Uint32Array(a.length+N),this.values.set(a.subarray(0,_),0),this.values.set(a.subarray(_),_+N),this.values.set(s,_),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(m.subarray(0,this.prefixSumValidIndex[0]+1)),!0)},n.prototype.changeValue=function(_,s){return _=C.toUint32(_),s=C.toUint32(s),this.values[_]===s?!1:(this.values[_]=s,_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),!0)},n.prototype.removeValues=function(_,s){_=C.toUint32(_),s=C.toUint32(s);var a=this.values,m=this.prefixSum;if(_>=a.length)return!1;var N=a.length-_;return s>=N&&(s=N),s===0?!1:(this.values=new Uint32Array(a.length-s),this.values.set(a.subarray(0,_),0),this.values.set(a.subarray(_+s),_),this.prefixSum=new Uint32Array(this.values.length),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(m.subarray(0,this.prefixSumValidIndex[0]+1)),!0)},n.prototype.getTotalValue=function(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)},n.prototype.getAccumulatedValue=function(_){return _<0?0:(_=C.toUint32(_),this._getAccumulatedValue(_))},n.prototype._getAccumulatedValue=function(_){if(_<=this.prefixSumValidIndex[0])return this.prefixSum[_];var s=this.prefixSumValidIndex[0]+1;s===0&&(this.prefixSum[0]=this.values[0],s++),_>=this.values.length&&(_=this.values.length-1);for(var a=s;a<=_;a++)this.prefixSum[a]=this.prefixSum[a-1]+this.values[a];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],_),this.prefixSum[_]},n.prototype.getIndexOf=function(_){_=Math.floor(_),this.getTotalValue();for(var s=0,a=this.values.length-1,m=0,N=0,l=0;s<=a;)if(m=s+(a-s)/2|0,N=this.prefixSum[m],l=N-this.values[m],_<l)a=m-1;else if(_>=N)s=m+1;else break;return new M(m,_-l)},n}();t.PrefixSumComputer=d});var ue=this&&this.__values||function(R){var t=typeof Symbol=="function"&&Symbol.iterator,C=t&&R[t],M=0;if(C)return C.call(R);if(R&&typeof R.length=="number")return{next:function(){return R&&M>=R.length&&(R=void 0),{value:R&&R[M++],done:!R}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")};te(re[22],ie([1,0,6,3,34]),function(R,t,C,M,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;var n=function(){function _(s,a,m,N){this._uri=s,this._lines=a,this._eol=m,this._versionId=N,this._lineStarts=null,this._cachedTextValue=null}return _.prototype.dispose=function(){this._lines.length=0},Object.defineProperty(_.prototype,"version",{get:function(){return this._versionId},enumerable:!1,configurable:!0}),_.prototype.getText=function(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue},_.prototype.onEvents=function(s){var a,m;s.eol&&s.eol!==this._eol&&(this._eol=s.eol,this._lineStarts=null);var N=s.changes;try{for(var l=ue(N),b=l.next();!b.done;b=l.next()){var S=b.value;this._acceptDeleteRange(S.range),this._acceptInsertText(new M.Position(S.range.startLineNumber,S.range.startColumn),S.text)}}catch(E){a={error:E}}finally{try{b&&!b.done&&(m=l.return)&&m.call(l)}finally{if(a)throw a.error}}this._versionId=s.versionId,this._cachedTextValue=null},_.prototype._ensureLineStarts=function(){if(!this._lineStarts){for(var s=this._eol.length,a=this._lines.length,m=new Uint32Array(a),N=0;N<a;N++)m[N]=this._lines[N].length+s;this._lineStarts=new d.PrefixSumComputer(m)}},_.prototype._setLineText=function(s,a){this._lines[s]=a,this._lineStarts&&this._lineStarts.changeValue(s,this._lines[s].length+this._eol.length)},_.prototype._acceptDeleteRange=function(s){if(s.startLineNumber===s.endLineNumber){if(s.startColumn===s.endColumn)return;this._setLineText(s.startLineNumber-1,this._lines[s.startLineNumber-1].substring(0,s.startColumn-1)+this._lines[s.startLineNumber-1].substring(s.endColumn-1));return}this._setLineText(s.startLineNumber-1,this._lines[s.startLineNumber-1].substring(0,s.startColumn-1)+this._lines[s.endLineNumber-1].substring(s.endColumn-1)),this._lines.splice(s.startLineNumber,s.endLineNumber-s.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(s.startLineNumber,s.endLineNumber-s.startLineNumber)},_.prototype._acceptInsertText=function(s,a){if(a.length!==0){var m=C.splitLines(a);if(m.length===1){this._setLineText(s.lineNumber-1,this._lines[s.lineNumber-1].substring(0,s.column-1)+m[0]+this._lines[s.lineNumber-1].substring(s.column-1));return}m[m.length-1]+=this._lines[s.lineNumber-1].substring(s.column-1),this._setLineText(s.lineNumber-1,this._lines[s.lineNumber-1].substring(0,s.column-1)+m[0]);for(var N=new Uint32Array(m.length-1),l=1;l<m.length;l++)this._lines.splice(s.lineNumber+l-1,0,m[l]),N[l-1]=m[l].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(s.lineNumber,N)}},_}();t.MirrorTextModel=n});var ue=this&&this.__values||function(R){var t=typeof Symbol=="function"&&Symbol.iterator,C=t&&R[t],M=0;if(C)return C.call(R);if(R&&typeof R.length=="number")return{next:function(){return R&&M>=R.length&&(R=void 0),{value:R&&R[M++],done:!R}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")};te(re[36],ie([1,0,16,9,2,12,3,5,28,22,29,30,31,33,10,13]),function(R,t,C,M,d,n,_,s,a,m,N,l,b,S,E,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;var g=function(i){ye(u,i);function u(){return i!==null&&i.apply(this,arguments)||this}return Object.defineProperty(u.prototype,"uri",{get:function(){return this._uri},enumerable:!1,configurable:!0}),Object.defineProperty(u.prototype,"version",{get:function(){return this._versionId},enumerable:!1,configurable:!0}),Object.defineProperty(u.prototype,"eol",{get:function(){return this._eol},enumerable:!1,configurable:!0}),u.prototype.getValue=function(){return this.getText()},u.prototype.getLinesContent=function(){return this._lines.slice(0)},u.prototype.getLineCount=function(){return this._lines.length},u.prototype.getLineContent=function(r){return this._lines[r-1]},u.prototype.getWordAtPosition=function(r,f){var v=N.getWordAtText(r.column,N.ensureValidWordDefinition(f),this._lines[r.lineNumber-1],0);return v?new s.Range(r.lineNumber,v.startColumn,r.lineNumber,v.endColumn):null},u.prototype.getWordUntilPosition=function(r,f){var v=this.getWordAtPosition(r,f);return v?{word:this._lines[r.lineNumber-1].substring(v.startColumn-1,r.column-1),startColumn:v.startColumn,endColumn:r.column}:{word:"",startColumn:r.column,endColumn:r.column}},u.prototype.words=function(r){var f,v=this._lines,L=this._wordenize.bind(this),y=0,o="",w=0,A=[];return f={},f[Symbol.iterator]=function(){var D;return de(this,function(F){switch(F.label){case 0:return w<A.length?(D=o.substring(A[w].start,A[w].end),w+=1,[4,D]):[3,2];case 1:return F.sent(),[3,3];case 2:if(y<v.length)o=v[y],A=L(o,r),w=0,y+=1;else return[3,4];F.label=3;case 3:return[3,0];case 4:return[2]}})},f},u.prototype.getLineWords=function(r,f){var v,L,y=this._lines[r-1],o=this._wordenize(y,f),w=[];try{for(var A=ue(o),D=A.next();!D.done;D=A.next()){var F=D.value;w.push({word:y.substring(F.start,F.end),startColumn:F.start+1,endColumn:F.end+1})}}catch(I){v={error:I}}finally{try{D&&!D.done&&(L=A.return)&&L.call(A)}finally{if(v)throw v.error}}return w},u.prototype._wordenize=function(r,f){var v=[],L;for(f.lastIndex=0;(L=f.exec(r))&&L[0].length!==0;)v.push({start:L.index,end:L.index+L[0].length});return v},u.prototype.getValueInRange=function(r){if(r=this._validateRange(r),r.startLineNumber===r.endLineNumber)return this._lines[r.startLineNumber-1].substring(r.startColumn-1,r.endColumn-1);var f=this._eol,v=r.startLineNumber-1,L=r.endLineNumber-1,y=[];y.push(this._lines[v].substring(r.startColumn-1));for(var o=v+1;o<L;o++)y.push(this._lines[o]);return y.push(this._lines[L].substring(0,r.endColumn-1)),y.join(f)},u.prototype.offsetAt=function(r){return r=this._validatePosition(r),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(r.lineNumber-2)+(r.column-1)},u.prototype.positionAt=function(r){r=Math.floor(r),r=Math.max(0,r),this._ensureLineStarts();var f=this._lineStarts.getIndexOf(r),v=this._lines[f.index].length;return{lineNumber:1+f.index,column:1+Math.min(f.remainder,v)}},u.prototype._validateRange=function(r){var f=this._validatePosition({lineNumber:r.startLineNumber,column:r.startColumn}),v=this._validatePosition({lineNumber:r.endLineNumber,column:r.endColumn});return f.lineNumber!==r.startLineNumber||f.column!==r.startColumn||v.lineNumber!==r.endLineNumber||v.column!==r.endColumn?{startLineNumber:f.lineNumber,startColumn:f.column,endLineNumber:v.lineNumber,endColumn:v.column}:r},u.prototype._validatePosition=function(r){if(!_.Position.isIPosition(r))throw new Error("bad position");var f=r.lineNumber,v=r.column,L=!1;if(f<1)f=1,v=1,L=!0;else if(f>this._lines.length)f=this._lines.length,v=this._lines[f-1].length+1,L=!0;else{var y=this._lines[f-1].length+1;v<1?(v=1,L=!0):v>y&&(v=y,L=!0)}return L?{lineNumber:f,column:v}:r},u}(m.MirrorTextModel),h=function(){function i(u,r){this._host=u,this._models=Object.create(null),this._foreignModuleFactory=r,this._foreignModule=null}return i.prototype.dispose=function(){this._models=Object.create(null)},i.prototype._getModel=function(u){return this._models[u]},i.prototype._getModels=function(){var u=this,r=[];return Object.keys(this._models).forEach(function(f){return r.push(u._models[f])}),r},i.prototype.acceptNewModel=function(u){this._models[u.url]=new g(n.URI.parse(u.url),u.lines,u.EOL,u.versionId)},i.prototype.acceptModelChanged=function(u,r){if(!!this._models[u]){var f=this._models[u];f.onEvents(r)}},i.prototype.acceptRemovedModel=function(u){!this._models[u]||delete this._models[u]},i.prototype.computeDiff=function(u,r,f,v){return pe(this,void 0,void 0,function(){var L,y,o,w,A,D,F;return de(this,function(I){return L=this._getModel(u),y=this._getModel(r),!L||!y?[2,null]:(o=L.getLinesContent(),w=y.getLinesContent(),A=new a.DiffComputer(o,w,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:f,shouldMakePrettyDiff:!0,maxComputationTime:v}),D=A.computeDiff(),F=D.changes.length>0?!1:this._modelsAreIdentical(L,y),[2,{quitEarly:D.quitEarly,identical:F,changes:D.changes}])})})},i.prototype._modelsAreIdentical=function(u,r){var f=u.getLineCount(),v=r.getLineCount();if(f!==v)return!1;for(var L=1;L<=f;L++){var y=u.getLineContent(L),o=r.getLineContent(L);if(y!==o)return!1}return!0},i.prototype.computeDirtyDiff=function(u,r,f){return pe(this,void 0,void 0,function(){var v,L,y,o,w;return de(this,function(A){return v=this._getModel(u),L=this._getModel(r),!v||!L?[2,null]:(y=v.getLinesContent(),o=L.getLinesContent(),w=new a.DiffComputer(y,o,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:f,shouldMakePrettyDiff:!0,maxComputationTime:1e3}),[2,w.computeDiff().changes])})})},i.prototype.computeMoreMinimalEdits=function(u,r){return pe(this,void 0,void 0,function(){var f,v,L,y,o,w,A,D,F,I,z,X,H,$,e,W,j,Q,K,ae,T,k;return de(this,function(O){if(f=this._getModel(u),!f)return[2,r];v=[],L=void 0,r=C.mergeSort(r,function(Y,G){if(Y.range&&G.range)return s.Range.compareRangesUsingStarts(Y.range,G.range);var J=Y.range?0:1,x=G.range?0:1;return J-x});try{for(y=ue(r),o=y.next();!o.done;o=y.next())if(w=o.value,A=w.range,D=w.text,F=w.eol,typeof F=="number"&&(L=F),!(s.Range.isEmpty(A)&&!D)&&(I=f.getValueInRange(A),D=D.replace(/\r\n|\n|\r/g,f.eol),I!==D)){if(Math.max(D.length,I.length)>i._diffLimit){v.push({range:A,text:D});continue}z=M.stringDiff(I,D,!1),X=f.offsetAt(s.Range.lift(A).getStartPosition());try{for(H=(T=void 0,ue(z)),$=H.next();!$.done;$=H.next())e=$.value,W=f.positionAt(X+e.originalStart),j=f.positionAt(X+e.originalStart+e.originalLength),Q={text:D.substr(e.modifiedStart,e.modifiedLength),range:{startLineNumber:W.lineNumber,startColumn:W.column,endLineNumber:j.lineNumber,endColumn:j.column}},f.getValueInRange(Q.range)!==Q.text&&v.push(Q)}catch(Y){T={error:Y}}finally{try{$&&!$.done&&(k=H.return)&&k.call(H)}finally{if(T)throw T.error}}}}catch(Y){K={error:Y}}finally{try{o&&!o.done&&(ae=y.return)&&ae.call(y)}finally{if(K)throw K.error}}return typeof L=="number"&&v.push({eol:L,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),[2,v]})})},i.prototype.computeLinks=function(u){return pe(this,void 0,void 0,function(){var r;return de(this,function(f){return r=this._getModel(u),r?[2,l.computeLinks(r)]:[2,null]})})},i.prototype.textualSuggest=function(u,r,f,v){return pe(this,void 0,void 0,function(){var L,y,o,w,A,D,F,I,z,X,H,$,e,W;return de(this,function(j){L=new c.StopWatch(!0),y=new RegExp(f,v),o=new Set;try{e:for(w=ue(u),A=w.next();!A.done;A=w.next())if(D=A.value,F=this._getModel(D),!!F)try{for(I=(e=void 0,ue(F.words(y))),z=I.next();!z.done;z=I.next())if(X=z.value,!(X===r||!isNaN(Number(X)))&&(o.add(X),o.size>i._suggestionsLimit))break e}catch(Q){e={error:Q}}finally{try{z&&!z.done&&(W=I.return)&&W.call(I)}finally{if(e)throw e.error}}}catch(Q){H={error:Q}}finally{try{A&&!A.done&&($=w.return)&&$.call(w)}finally{if(H)throw H.error}}return[2,{words:Array.from(o),duration:L.elapsed()}]})})},i.prototype.computeWordRanges=function(u,r,f,v){return pe(this,void 0,void 0,function(){var L,y,o,w,A,D,F,I,z,X,H;return de(this,function($){if(L=this._getModel(u),!L)return[2,Object.create(null)];for(y=new RegExp(f,v),o=Object.create(null),w=r.startLineNumber;w<r.endLineNumber;w++){A=L.getLineWords(w,y);try{for(D=(X=void 0,ue(A)),F=D.next();!F.done;F=D.next())I=F.value,!!isNaN(Number(I.word))&&(z=o[I.word],z||(z=[],o[I.word]=z),z.push({startLineNumber:w,startColumn:I.startColumn,endLineNumber:w,endColumn:I.endColumn}))}catch(e){X={error:e}}finally{try{F&&!F.done&&(H=D.return)&&H.call(D)}finally{if(X)throw X.error}}}return[2,o]})})},i.prototype.navigateValueSet=function(u,r,f,v,L){return pe(this,void 0,void 0,function(){var y,o,w,A,D,F;return de(this,function(I){return y=this._getModel(u),y?(o=new RegExp(v,L),r.startColumn===r.endColumn&&(r={startLineNumber:r.startLineNumber,startColumn:r.startColumn,endLineNumber:r.endLineNumber,endColumn:r.endColumn+1}),w=y.getValueInRange(r),A=y.getWordAtPosition({lineNumber:r.startLineNumber,column:r.startColumn},o),A?(D=y.getValueInRange(A),F=b.BasicInplaceReplace.INSTANCE.navigateValueSet(r,w,A,D,f),[2,F]):[2,null]):[2,null]})})},i.prototype.loadForeignModule=function(u,r,f){var v=this,L=function(w,A){return v._host.fhr(w,A)},y=E.createProxyObject(f,L),o={host:y,getMirrorModels:function(){return v._getModels()}};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(o,r),Promise.resolve(E.getAllMethodNames(this._foreignModule))):new Promise(function(w,A){R([u],function(D){v._foreignModule=D.create(o,r),w(E.getAllMethodNames(v._foreignModule))},A)})},i.prototype.fmr=function(u,r){if(!this._foreignModule||typeof this._foreignModule[u]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+u));try{return Promise.resolve(this._foreignModule[u].apply(this._foreignModule,r))}catch(f){return Promise.reject(f)}},i._diffLimit=1e5,i._suggestionsLimit=1e4,i}();t.EditorSimpleWorker=h;function p(i){return new h(i,null)}t.create=p,typeof importScripts=="function"&&(d.globals.monaco=S.createMonacoBaseAPI())});"use strict";(function(){var R,t,C=self.MonacoEnvironment,M=C&&C.baseUrl?C.baseUrl:"../../../",d=typeof((R=self.trustedTypes)===null||R===void 0?void 0:R.createPolicy)=="function"?(t=self.trustedTypes)===null||t===void 0?void 0:t.createPolicy("amdLoader",{createScriptURL:function(m){return m}}):void 0;if(typeof self.define!="function"||!self.define.amd){var n=M+"vs/loader.js";d&&(n=d.createScriptURL(n)),importScripts(n)}require.config({baseUrl:M,catchError:!0,trustedTypesPolicy:d});var _=function(m){require([m],function(N){setTimeout(function(){var l=N.create(function(b,S){self.postMessage(b,S)},null);for(self.onmessage=function(b){return l.onmessage(b.data)};a.length>0;)self.onmessage(a.shift())},0)})},s=!0,a=[];self.onmessage=function(m){if(!s){a.push(m);return}s=!1,_(m.data)}})()}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map